ideal
p386

ATTR    =       07h                     ;
NEGATTR =       70h                     ;

W_NONE  =       0                       ;
W_CPU   =       1                       ;
W_REGS  =       2                       ;
W_FLAGS =       3                       ;
W_WATCH =       4                       ;
W_STACK =       5                       ;
W_BP    =       6                       ;
W_DUMP  =       7                       ;

_IP     =       20h                     ; offsets in TSS
_FL     =       24h                     ;
_AX     =       28h                     ;
_CX     =       2Ch                     ;
_DX     =       30h                     ;
_DX     =       30h                     ;
_BX     =       34h                     ;
_SP     =       38h                     ;
_BP     =       3Ch                     ;
_SI     =       40h                     ;
_DI     =       44h                     ;
_ES     =       48h                     ;
_CS     =       4Ch                     ;
_SS     =       50h                     ;
_DS     =       54h                     ;
_FS     =       58h                     ;
_GS     =       5Ch                     ;

opCALL  =       00000001b               ;
opINT   =       00000010b               ;
opINOUT =       00000100b               ;
opDSSI  =       00001000b               ;
opESDI  =       00010000b               ;
opDSES  =       00011000b               ;
opREP   =       00100000b               ;
opJMP   =       00000001b               ;
opJCOND =       00000010b               ;

global  put_string      : proc          ;
global  draw_frame      : proc          ;
global  SetCursor       : proc          ;
global  HideCursor      : proc          ;
global  FACE            : proc          ;
global  PrintHex16      : proc          ;
global  draw_face       : proc          ;
global  draw_message    : proc          ;
global  Jcc_calls       : proc          ;
global  DEBUG           : proc          ;
global  dos_in          : proc          ;
global  dos_fl          : word          ;
global  p_ret           : byte          ;
global  p_ret_of        : word          ;
global  dos_adr         : dword         ; 
global  dos_buf         : near
global  tab_ch1         : near

global  buffer          : near          ;
global  mess_08         : near          ;

extrn   Int_N2          : byte          ;
extrn   Int_F           : word          ;
extrn   Int_N           : byte          ;
extrn   Int_P           : byte          ;
extrn   pref            : byte          ;
extrn   Dos_flag        : dword         ;
;extrn   trace           : byte          ;
;extrn   tr_s            : byte
extrn   Int_PP          : byte          ;
extrn   v86             : proc
;extrn   DOS             : proc
extrn   reloc           : word          ;
extrn   follow_seg      : word          ;
extrn   follow_off      : word          ;
extrn   oper_text       : word          ;
extrn   oper_type       : byte          ;
extrn   oper_code       : byte          ;
extrn   second_byte     : byte          ;
extrn   _3_byte         : word          ;
extrn   bpice_flag      : byte          ;

extrn   DisAsm          : near          ;
extrn   SetMode         : near          ;
extrn   SaveMode        : near          ;
extrn   SavePlanes      : near          ;
extrn   RestorePlanes   : near          ;
extrn   Expression      : near          ;
extrn   get_seg_off     : near          ;
extrn   edit_text       : near          ;
extrn   blanks          : near          ;
extrn   calculator      : near          ;
extrn   unget_key       : near          ;
extrn   check_condition : near          ;

        segment code byte public use16 'CODE'
        assume  cs:code, ds:code

dumpSEG         dw      0               ;
dumpOFF         dw      0               ;
cpuSEG          dw      0FFFFh          ;
cpuOFF          dw      0FFFFh          ;
stackSEG        dw      0FFFFh          ;
stackOFF        dw      0FFFFh          ;

dumpCUR         dw      0FFFFh          ;
regsCUR         dw      0               ;
flagsCUR        dw      0               ;
cpuCUR          dw      0FFFFh          ;
stackCUR        dw      0FFFFh          ;
cpuLAST         dw      0               ;
dumpLAST        dw      0               ;
stackLAST       dw      0               ;
bpOFF           dw      -000Ah          ;
bpCUR           dw      0               ;
bpLAST          dw      0               ;
watchCUR        dw      0               ;

save_ip         dw      0               ;砫쭮 ᬥ饭
save_cs         dw      0               ; ᥣ
save_cx         dw      0               ;  
s_sp            dd      0
dos_adr         dd      0
dos_fl          dw      0
p_ret           db      0               ;䫠  믮 F10 (p ret)
p_ret_of        dw      0               ;

tab_ch1:        dd      10 dup(0)       ;  ॣ-஢
                dd      7  dup(0)       ;^^^ ᥣ. ^^^^^^^ + १

dump_size       db      5               ;
dump_beg        dw      (90*24+1)*2     ;
flag_edit       db      0               ; 0-edit hex
edit_mask       db      0F0h            ;
init_flag       db      0               ;
switch_scr      db      1               ; 0 - no switch , 1 - switch
ret_val         db      0               ;
follow_stk      dw      5*6 dup(0)      ;
follow_ptr      dw      0               ;
oper_seg        dw      0               ;
oper_len        dw      0               ;
tmp             dw      0               ;
data_seg        dw      0               ;
data_off        dw      0               ;
is_cur          db      0               ;
active_win      db      W_CPU           ;
last_active     db      W_CPU           ;
save61          db      0               ;
last_key        dw      0               ;
REGS32          db      0               ; 0 - 16 bits, 2-32 bits
WATCHtxt        db      0               ; 0 - 4/4, 0/16
DG22vec         dd      0               ; 22h vector

breaks:         db      0FFh            ; type of breakpoint #1
                dw      0, 0            ; its address
                db      0FFh            ; ... #2
                dw      0, 0            ;
                db      0FFh            ; ... #3
                dw      0, 0            ;
end_breaks:                             ;
conditions      db      40*3 dup(0)     ;
brk_value       db      3 dup(0)        ;

dd_bb           =       tab_ch1 - 20h

calls_tbl:
        dw      offset keys_in_CPU      ;
        dw      offset keys_in_REGS     ;
        dw      offset keys_in_FLAGS    ;
        dw      offset keys_in_WATCH    ;
        dw      offset keys_in_STACK    ;
        dw      offset keys_in_BP       ;
        dw      offset keys_in_DUMP     ;

include "defines.inc"                   ;
include "keys.inc"                      ;

draw_face:                              ;
        cld                             ;
        pushad                          ;
        push    ds                      ;
        mov     bx, sData               ;
        mov     ds, bx                  ;
        mov     es, bx                  ;
        mov     fs, bx                  ;
        push    sTSS                    ;
        pop     gs                      ;
        mov     [ byte ds:ret_val ], 0  ;

        or      ah, ah                  ;
        jnz     @@100                   ;
        cmp     al, 0                   ;
        jz      @@100                   ;
        dec     ax                      ;
;ax --  猪
        mov     si, ax                  ;
        shl     si, 2                   ;
        add     si, ax                  ;㬭  5
        test    [ byte si+offset breaks ], 80h;
        jz      @@99                    ; breakpoint with condition ?
        test    [ byte si+offset breaks ], 0Fh;
        jnz     @@to_data               ; breakpoint on data ?
        shl     si, 3                   ;
        add     si, offset conditions   ;
        call    check_condition         ;
        jnc     face_done               ; false -> don't pop up
        jmp     short @@99              ;
@@to_data:                              ;
        mov     di, ax                  ;
        add     si, offset breaks       ;
        mov     bx, [ si+1 ]            ;
        mov     dx, [ si+3 ]            ;
        call    get_memory              ;
        cmp     al, [ di+offset brk_value ];
        jnz     face_done               ;
@@99:                                   ;
        xor     ax, ax                  ;
@@100:
        push    ax                      ; save code
        in      al,61h                  ;
        mov     [ byte ds:save61 ], al  ;
        mov     ah,al                   ;
        or      al,80h                  ;
        out     61h,al                  ;
        mov     al,ah                   ;
        and     al, 0FCh                ;
        out     61h,al                  ;

        mov     al,20h                  ;
        out     20h,al                  ;

        mov     al, 0                   ;
        call    DisableBreak            ;

        mov     ax, [ ss:TSSv86._cs ]   ;
        cmp     ax, [ ds:cpuSEG ]       ;
        jne     @@5                     ;
        mov     ax, [word ss:TSSv86._eip];
        cmp     ax, [ ds:cpuOFF ]       ;
        jb      @@5                     ;
        cmp     ax, [ ds:cpuLAST ]      ;
        ja      @@5                     ;
        mov     [ ds:cpuCUR ], ax       ;
        jmp     @@7                     ;
@@5:                                    ;
        mov     ax,[word ss:TSSv86._eip];
        mov     [ss:cpuOFF],ax          ;
        mov     [ss:cpuCUR],ax          ;
        mov     ax,[ss:TSSv86._cs]      ;
        mov     [ss:cpuSEG],ax          ;
@@7:                                    ;
        mov     ax,[word ss:TSSv86._esp];
        mov     [ss:stackOFF],ax        ;
        mov     [ss:stackCUR],ax        ;
        mov     ax,[ss:TSSv86._ss]      ;
        mov     [ss:stackSEG],ax        ;

        cmp     [ byte ds:init_flag ],0 ;
        jnz     @@8                     ;
        xor     ax, ax                  ;
        mov     [word dumpOFF], ax      ;
        mov     [word dumpCUR], ax      ;
        mov     ax,[ss:TSSv86._ds]      ;
        mov     [ dumpSEG ],ax          ;
        mov     [ word regsCUR ], 0     ;
        xor     dx, dx                  ;
        mov     bx, 22h*4               ;
        call    get_mem_word            ;
        mov     [ word ds:DG22vec ], ax ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
        mov     [ word ds:DG22vec+2], ax;
        mov     [ byte ds:init_flag ],1 ;
@@8:                                    ;
        cmp     [ byte ds:switch_scr ], 0;
        je      @@10                    ;

        lea     di, [ video_mode ]      ;
        call    SaveMode                ;
        lea     di, [ video_data ]      ;
        call    SavePlanes              ;
        lea     si, [ video_mode_03 ]   ;
        call    SetMode                 ;
        call    clear_face              ;
@@10:                                   ;
        mov     [ byte ds:switch_scr ], 0;
        call    FACE                    ;

        pop     ax                      ; what sended to me?
        cmp     ah, 10h                 ; exit?
        jne     @@110                   ;
        mov     si, offset mess_02      ;
        mov     ah, 0FFh                ;
        call    draw_message            ;
        mov     [ byte init_flag ], 2   ;
        jmp     short @@800             ;
@@110:                                  ;
        cmp     ah, 02h                 ; exeption 13?
        jne     @@120                   ;
        mov     si, offset mess_06      ;
        call    draw_message            ;
        jmp     short @@800             ;
@@120:                                  ;
;...
@@800:                                  ;
        mov     al, [ byte last_active ];
        mov     [ byte active_win ], al ;
@@900:                                  ;
        movzx   bx, [ byte active_win ] ;
        or      bx, bx                  ; W_NONE ?
        jz      @@901                   ;
        mov     [ byte last_active ], bl;
        call    FACE                    ;
        dec     bx                      ;
        shl     bx, 1                   ;
        call    [ word calls_tbl + bx ] ;
        jmp     short @@900             ;
@@901:                                  ;
        cmp     [ byte init_flag ], 2   ;
        jnz     @@902                   ;
        cmp     [ byte ret_val ], 0FEh  ;
        jae     @@902                   ;
        mov     si, offset mess_13      ;
        mov     ah, 00                  ;
        call    draw_message            ;
        jmp     @@800                   ;
@@902:                                  ;
        cmp     [ byte ds:switch_scr ], 0;
        je      @@20                    ;
        mov     ax, sData               ;
        mov     ds, ax                  ;
        mov     es, ax                  ;
        lea     di, [ video_data ]      ;
        call    RestorePlanes           ;
        lea     si, [ video_mode ]      ;
        call    SetMode                 ;
@@20:                                   ;
        mov     di, offset follow_stk   ;
        push    fs                      ;
        pop     es                      ;
        mov     ax, [ ds:cpuSEG ]       ;
        stosw                           ;
        mov     ax, [ ds:cpuOFF ]       ;
        stosw                           ;
        mov     ax, [ ds:cpuCUR ]       ;
        stosw                           ;
        mov     [ ds:follow_ptr ], 6    ;
        mov     al, [ byte ds:save61 ]  ;
        out     61h, al                 ;
face_done:                              ;
        pop     ds                      ;
        popad                           ;
        mov     al, [ byte fs:ret_val ] ;
        ret                             ;
;---------------------------------------;
clear_face:                             ;
        pusha                           ;
        push    es                      ;
        mov     ax, sVideo              ;
        mov     es, ax                  ;
        mov     ah, ATTR                ;
        lea     si, [tables]            ;
        xor     di, di                  ;
        mov     ch, 0                   ;
@@10:                                   ;
        lodsb                           ;
        mov     bl, al                  ;
@@20:                                   ;
        push    si                      ;
        mov     bh, 3                   ;
@@22:
        lodsb                           ;
        stosw                           ;
        lodsb                           ;
        mov     cl, al                  ;
        lodsb                           ;
        rep     stosw                   ;
        dec     bh                      ;
        jnz     @@22                    ;
        lodsb                           ;
        stosw                           ;
        pop     si                      ;
        dec     bl                      ;
        jnz     short @@20              ;
        add     si, 10                  ;
        cmp     si, offset etable       ;
        jb      short @@10              ;
        pop     es                      ;
        popa                            ;
        ret                             ;
;---------------------------------------;
FACE:                                   ;
        push    es                      ;
        pusha                           ;
        mov     ax, sVideo              ;
        mov     es, ax                  ;
        cmp     [ byte ds:dump_size ], 5;
        je      @@10                    ;
        mov     cx, 88*256+28           ; ch = col. cl = rows.
        xor     di, di                  ;
        mov     ah, ATTR                ;
        call    draw_frame              ;
        call    draw_dump               ;
        jmp     short @@20              ;
@@10:                                   ;
        call    draw_cpu                ;
        call    draw_regs               ;
        call    draw_flags              ;
        call    draw_stack              ;
        call    draw_dump               ;
        call    draw_watch              ;
        call    draw_bp                 ;
@@20:                                   ;
        popa                            ;
        pop     es                      ;
        ret                             ;
;---------------------------------------;
draw_cpu:                               ;
        mov     ax, sData               ;
        mov     ds, ax                  ; ds = fs = sData
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     [ byte ds:is_cur ], 0   ;
@@00:                                   ;
        mov     [ ds:data_seg ], 0FFFEh ;
        mov     dx, [ word ds:cpuSEG ]  ;
        mov     bx, [ word ds:cpuOFF ]  ;
        mov     di, (90*1+1)*2          ;
        xor     cx, cx                  ; zero count
@@3:                                    ;
        push    cx                      ;
        mov     ax, offset buffer+100   ;
        sub     ax, bx                  ;
        neg     ax                      ;
        mov     [ word ds:reloc ], ax   ;
        mov     ax, _CS                 ;
        mov     [ ds:cpuLAST ], bx      ;
        call    put_seg_off             ;
        cmp     dx, [ ss:TSSv86._cs ]   ;
        jne     @@4                     ;
        cmp     bx, [ word ss:TSSv86._eip ];
        jne     @@4                     ;
        mov     [ byte es:di-2 ], ''   ;⥫ IP
@@4:                                    ;
        push    es                      ;
        push    di                      ;
        push    ds                      ;
        pop     es                      ;
        mov     di, offset buffer+100   ;
        mov     cl, 20                  ;
        push    bx                      ;
@@10:                                   ;
        call    get_memory              ;뢠 20  ணࠬ
        inc     bx                      ;
        stosb                           ;
        dec     cl                      ;
        jnz     @@10                    ;
        pop     bx                      ;
                                        ;
        mov     si, offset buffer+100   ;
        mov     bp, si                  ;
        mov     di, offset buffer       ;
        push    bx                      ;
        call    DisAsm                  ;
        mov     [ byte ds:tmp ], al     ;
        mov     [ byte ds:oper_seg ], ah;
        mov     [ byte ds:oper_len ], cl;
        pop     bx                      ;
        pop     di                      ;
        pop     es                      ;
        mov     cx, 16                  ;
@@15:                                   ;
        call    get_memory              ;
        inc     bx                      ;
        inc     bp                      ;
        mov     ah, ATTR                ;
        call    PrintHex8               ;
        dec     cx                      ;
        dec     cx                      ;
        mov     al, '+'                 ;
        jz      short @@17              ;
        cmp     bp, si                  ;
        jne     short @@15              ;
        mov     al, ' '                 ;
        rep     stosw                   ;
@@17:                                   ;
        sub     si, bp                  ;
        add     bx, si                  ;
        stosw                           ;
        mov     si, offset buffer       ;
        mov     [ byte si+34 ],0        ;
        call    put_string              ;
        add     di, 29*2                ;
        pop     cx                      ;
        cmp     [ active_win ], W_CPU   ;
        jz      @@17_                   ;
        mov     [ is_cur ], 1           ;
        jmp     @@20                    ;
@@17_:                                  ;
        mov     ax, [ ds:cpuLAST ]      ;
        cmp     ax, [ ds:cpuCUR ]       ;
        jne     @@20                    ; it is current line ?
        mov     [ byte ds:is_cur ], 1   ;
        push    di                      ;
        sub     di, 90*2-1              ;

        mov     al, [ byte ds:oper_type ];
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 0C0h                ;
        jne     @@200                   ;
        test    al, opJCOND             ; Jcc?
        jz      @@200                   ;
        movzx   si, [ byte ds:oper_code ];
        cmp     si,80h
        jb      @@55n
        sub     si,10h
@@55n:  sub     si, 70h                 ;
        shl     si, 2                   ; si*=4
        add     si, offset Jcc_calls    ;
        mov     ax,[word ss:TSSv86._eflags]
        and     ax, 0000100011010101b   ;
        push    bx                      ;
        mov     bx, ax                  ;
        pushf                           ;
        pop     ax                      ;
        and     ax, 1111011100101010b   ;
        or      ax, bx                  ;
        push    ax                      ;
        popf                            ;
        pop     bx                      ;
        call    si                      ;
        or      al, al                  ;
        jz      @@200                   ;
        cmp     [ byte ds:oper_code ],80h
        mov     al, ''                 ;
        jae     @@56_
        test    [ byte ds:second_byte ], 80h;
        jz      @@201                   ;
        mov     al, ''                 ;
        jmp     @@201
@@56_:  test    [ byte ds:_3_byte],80h ;
        jz      @@201                   ;
        mov     al, ''                 ;
@@201:                                  ;
        mov     [ byte es:di+(44*2+1) ], al;
@@200:                                  ;
        mov     al, NEGATTR             ;
        mov     ah, 61                  ;
@@18:                                   ;
        stosb                           ;
        inc     di                      ;
        dec     ah                      ;
        jnz     @@18                    ;

        mov     di, 45*2                ;
        mov     si, 17                  ;
        mov     ax, '' + 256*ATTR      ;
@@51:                                   ;
        stosw                           ;
        dec     si                      ;
        jnz     @@51                    ;
        cmp     [ byte ds:tmp ], 7Fh    ;
        je      @@50                    ;
@@19:                                   ;
        push    dx                      ;
        push    bx                      ;

        mov     di, 45*2                ;
        mov     si, [ word ds:oper_seg ];
        shl     si, 2                   ;
        push    si                      ;
        add     si, offset seg_txt      ;
        inc     si                      ;
        mov     ah, ATTR                ;
        call    put_string              ;
        mov     al, ':'                 ;
        stosw                           ;
        mov     si, [ ds:oper_text ]    ;
        call    Expression              ;
        mov     bx, ax                  ;
        call    PrintHex16              ;
        mov     al, '='                 ;
        stosw                           ;
        pop     si                      ;

        push    ds                      ;
        push    sTSS                    ;
        pop     ds                      ;
        mov     dx, [ word ds:si+_ES ]  ;
        pop     ds                      ;

        mov     si, [ ds:oper_len ]     ;
        mov     [ ds:data_seg ], dx     ;
        mov     [ ds:data_off ], bx     ;
        dec     si                      ;
        add     bx, si                  ;
@@60:                                   ;
        call    get_memory              ;
        dec     bx                      ;
        mov     ah, ATTR                ;
        call    PrintHex8               ;
        dec     si                      ;
        jns     @@60                    ;

        pop     bx                      ;
        pop     dx                      ;
@@50:                                   ;
        pop     di                      ; end of current line drawing
@@20:                                   ;
        push    bx                      ;
        push    dx                      ;
        mov     bx, [ ds:cpuLAST ]      ;
        mov     dx, [ ds:cpuSEG ]       ;
        call    is_break                ; breakpoint?
        jc      @@790                   ;
        test    [ byte si ], 0Fh        ;
        jnz     @@790                   ; on execution ?
        mov     al, 47h                 ;
        test    [ byte si ], 80h        ;
        jz      @@710                   ; conditional ?
        mov     al, 57h                 ;
@@710:                                  ;
        push    di                      ;
        mov     ah, 9                   ;
        sub     di, 90*2-1              ;
@@720:                                  ;
        stosb                           ;
        inc     di                      ;
        dec     ah                      ;
        jnz     @@720                   ;
        pop     di                      ;
@@790:                                  ;
        pop     dx                      ;
        pop     bx                      ;
        inc     cx                      ;
        cmp     cx, 21                  ;
        jz      @@30                    ;
        jmp     @@3                     ;
@@30:                                   ;
        cmp     [ byte ds:is_cur ], 1   ;
        jz      @@40                    ;
        mov     ax, [ ds:cpuCUR ]       ;
        mov     [ ds:cpuOFF ], ax       ;
        jmp     @@00                    ;
@@40:                                   ;
        ret                             ;
;---------------------------------------;
draw_regs:                              ;
        mov     [ word tmp ], 0         ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     si, offset reg_tbl      ;
        mov     di, (90+64)*2           ;
        mov     dh, 8                   ;
@@5:                                    ;
        mov     dl, 2                   ;
@@10:                                   ;
        mov     ah, ATTR                ;
        mov     al, ' '                 ;
        cmp     [ byte REGS32 ], dl     ;
        jnz     @@11                    ;
        mov     al, 'e'                 ;
@@11:                                   ;
        stosw                           ;
                                        ;
        lodsb                           ;
        stosw                           ;
        lodsb                           ;
        stosw                           ;
        mov     al, ' '                 ;
        stosw                           ;ᠫ 'eax '
        push    di                      ;
        lodsb                           ;
        mov     bl, al                  ;
        mov     bh, 0                   ;
        mov     eax, [ dword gs:bx ]    ;
        cmp     [ byte REGS32 ], dl     ;
        jnz     @@12                    ;
;-- 뤥  -஢
        cmp     eax,[dword cs:bx+dd_bb]
        je      @@1a
        push    eax                     ;
        shr     eax, 16                 ;
        call    PrintHex16_2            ;
        pop     eax                     ;
        call    PrintHex16_2            ;
        jmp     short @@122             ;

@@1a:   push    eax                     ;
        shr     eax, 16                 ;
        call    PrintHex16              ;
        pop     eax                     ;
        call    PrintHex16              ;
        jmp     short @@122             ;
@@12:                                   ;
        cmp     dl, 2                   ;
        jnz     @@121                   ;
        push    ax                      ;
        push    di                      ;
        mov     cx, 8                   ;
        mov     ax, ATTR*256+' '        ;
        rep     stosw                   ;
        pop     di                      ;
        pop     ax                      ;
@@121:                                  ;
        cmp     ax,[word cs:bx+dd_bb]
        je      @@12a
        call    PrintHex16_2            ;
        jmp     @@122

@@12a:  call    PrintHex16              ;
@@122:                                  ;
        mov     bx, di                  ;
        pop     di                      ;
        add     di, 8*2                 ;
        cmp     [ active_win ], W_REGS  ;
        jne     @@17                    ;
        mov     ax, [ word regsCUR ]    ;
        cmp     ax, [ tmp ]             ;
        jnz     @@17                    ;

        push    di                      ;
        mov     di, bx                  ;

        mov     cx, 8                   ;
        cmp     [ byte REGS32 ], dl     ;
        jnz     @@13                    ;
        mov     cx, 12                  ;
@@13:                                   ;
        sub     di, cx                  ;
        sub     di, cx                  ;
        inc     di                      ;
@@16:                                   ;
        mov     [ byte es:di ], NEGATTR ;
        inc     di                      ;
        inc     di                      ;
        loop    @@16                    ;
        pop     di                      ;
@@17:                                   ;
        add     [ word tmp ], 6         ;

        dec     dl                      ;
        jnz     @@10                    ;
        add     di, 66*2                ;
        dec     dh                      ;
        jnz     @@5                     ;

        ret                             ;
;---------------------------------------;
draw_flags:                             ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     si, offset flags_tbl    ;
        mov     di, (90+86)*2           ;
        xor     cx, cx                  ;

        mov     bx, [ gs:_FL ]          ;
        mov     dh, 8                   ;
@@15:                                   ;
        mov     ah, ATTR                ;
        lodsb                           ;
        stosw                           ;
        mov     al, '='                 ;
        stosw                           ;
        test    bx, [ ds:si ]           ;
        mov     al, '0'                 ;
        jz      short @@30              ;
        mov     al, '1'                 ;
@@30:                                   ;
        stosw                           ;
        inc     si                      ;
        inc     si                      ;
        cmp     [ active_win ], W_FLAGS ;
        jne     @@47                    ;
        cmp     cx, [ word flagsCUR ]   ;
        jnz     @@47                    ;
        sub     di, 5                   ;
        mov     dl, 3                   ;
@@46:                                   ;
        mov     [ byte es:di ], NEGATTR ;
        inc     di                      ;
        inc     di                      ;
        dec     dl                      ;
        jnz     @@46                    ;
        dec     di                      ;
@@47:                                   ;
        inc     cx                      ;

        add     di, 87*2                ;
        dec     dh                      ;
        jnz     @@15                    ;

        mov     [ word es:(90-1)*2 ], 07BFh;
        test    [ word ss:TSSv86._eflags ], 100h;
        jz      @@50                    ;
        mov     [ word es:(90-1)*2 ], 4E54h;
@@50:                                   ;
        ret                             ;
;---------------------------------------;
draw_stack:                             ;
        push    sVideo                  ;
        pop     es                      ;
        mov     dx, [ word ds:stackSEG ];
        mov     bx, [ word ds:stackOFF ];
        mov     di, (90*21+63)*2        ;
        mov     cx, 7                   ;
@@5:                                    ;
        mov     ax, _SS                 ;
        call    put_seg_off             ;
        mov     [ ds:stackLAST ], bx    ;
        cmp     dx, [ ss:TSSv86._ss ]   ;
        jne     @@10                    ;
        cmp     bx, [ word ss:TSSv86._esp ];
        jne     @@10                    ;
        mov     [ byte es:di-2 ], ''   ;
@@10:                                   ;
        call    get_mem_word            ;
        inc     bx                      ;
        inc     bx                      ;
        call    PrintHex16              ;
        cmp     [ active_win ], W_STACK ;
        jne     @@30                    ;
        mov     ax, [ ds:stackLAST ]    ;
        cmp     ax, [ ds:stackCUR ]     ;
        jne     @@30                    ;
        push    di                      ;
        dec     di                      ;
        mov     al, 14                  ;
@@20:                                   ;
        mov     [ byte es:di ], NEGATTR ;
        dec     di                      ;
        dec     di                      ;
        dec     al                      ;
        jnz     @@20                    ;
        pop     di                      ;
@@30:                                   ;
        sub     di, (90*1+14)*2         ;
        loop    @@5                     ;

        ret                             ;
;---------------------------------------;
draw_bp:                                ;
        push    sVideo                  ;
        pop     es                      ;
        mov     dx, [ ss:TSSv86._ss ]   ;
        mov     bx, [ word ds:bpOFF ]   ;
        mov     di, (90*28+79)*2        ;
        mov     cx, 14                  ;
        mov     ah, ATTR                ;
@@5:                                    ;
        mov     [ word bpLAST ], bx     ;
        push    bx                      ;
        mov     al, '+'                 ;
        or      bx, bx                  ;
        jns     @@7                     ;
        mov     al, '-'                 ;
        neg     bx                      ;
@@7:                                    ;
        stosw                           ;
        mov     ax, bx                  ;
        call    PrintHex16              ;
        mov     al, ' '                 ;
        or      bx, bx                  ;
        jne     @@10                    ;
        mov     al, ''                 ;
@@10:                                   ;
        stosw                           ;
        pop     bx                      ;
        push    bx                      ;
        add     bx, [ word ss:TSSv86._ebp ];
        call    get_mem_word            ;
        call    PrintHex16              ;
        pop     bx                      ;
        cmp     [ active_win ], W_BP    ;
        jne     @@30                    ;
        cmp     bx, [ ds:bpCUR ]        ;
        jne     @@30                    ;
        push    di                      ;
        dec     di                      ;
        mov     al, 10                  ;
@@20:                                   ;
        mov     [ byte es:di ], NEGATTR ;
        dec     di                      ;
        dec     di                      ;
        dec     al                      ;
        jnz     @@20                    ;
        pop     di                      ;
@@30:                                   ;
        inc     bx                      ;
        inc     bx                      ;
        sub     di, (90*1+10)*2         ;
        loop    @@5                     ;

        ret                             ;
;---------------------------------------;
draw_dump:                              ;
        call    HideCursor              ;
        push    sVideo                  ;
        pop     es                      ;
        mov     si, offset dump_title   ;
        mov     di, [ word ds:dump_beg ];
        push    di                      ;
        sub     di, (90*1-10)*2         ;
        mov     ah, ATTR                ;
        call    put_string              ;
        pop     di                      ;
        mov     si, [ word ds:dump_beg ];
        add     si, (59*2)              ;
        mov     dx, [ word ds:dumpSEG ] ;
        mov     bx, [ word ds:dumpOFF ] ;
        mov     ch, [ byte ds:dump_size ];
@@5:                                    ;
        mov     ax, _DS                 ;
        call    put_seg_off             ;
        mov     cl, 16                  ;
@@10:                                   ;
        call    get_memory              ;
        push    ax                      ;
        mov     ah, ATTR                ;
        cmp     [ active_win ], W_DUMP  ;
        jne     @@12                    ;
        cmp     [ flag_edit ], 0        ;
        jnz     @@12                    ;
        cmp     bx, [ ds:dumpCUR ]      ;
        jne     @@12                    ;
        cmp     [ edit_mask ], 0Fh      ;
        jne     @@10_                   ;
        inc     di                      ;
        inc     di                      ;
        call    SetCursor               ;
        dec     di                      ;
        dec     di                      ;
        jmp     short @@12              ;
@@10_:                                  ;
        call    SetCursor               ;
@@12:                                   ;
        push    ax                      ;
        push    si                      ;
        call    is_break                ;
        mov     ah, [ byte ds:si ]      ;
        mov     bp, ax                  ;
        pop     si                      ;
        pop     ax                      ;
        jc      @@14                    ;
        test    bp, 0F00h               ; on execution ?
        jz      @@14                    ;
        mov     ah, 47h                 ;
        test    bp, 8000h               ; conditional ?
        jz      @@14                    ;
        mov     ah, 57h                 ;
@@14:                                   ;
        call    PrintHex8               ;
        mov     ax, 256*ATTR+' '        ;
        stosw                           ;
        pop     ax                      ;
        cmp     al, ' '                 ;
        jb      @@15                    ;
        cmp     al, 0F0h                ;
        jb      @@20                    ;
@@15:                                   ;
        mov     al, '.'                 ;
@@20:                                   ;
        cmp     bx, [ ds:dumpCUR ]      ;
        jne     @@25                    ;
        cmp     [ active_win ], W_DUMP  ;
        jne     @@25                    ;
        cmp     [ flag_edit ], 0        ;
        jz      @@25                    ;
        push    di                      ;
        mov     di, si                  ;
        call    SetCursor               ;
        pop     di                      ;
@@25:                                   ;
        test    bp, 4                   ;
        jnz     @@26                    ; it is not breakpoint ?
        test    bp, 0F00h               ;
        jz      @@26                    ; on execution ?
        mov     ah, 47h                 ;
        test    bp, 8000h               ; conditional ?
        jz      @@26                    ;
        mov     ah, 57h                 ;
@@26:                                   ;
        mov     [ word es:si ], ax      ;
        mov     ah, ATTR                ;
        mov     [ ds:dumpLAST ], bx     ;
        inc     bx                      ;
        inc     si                      ;
        inc     si                      ;
        dec     cl                      ;
        jnz     @@10                    ;
        add     di, 32*2                ;
        add     si, 74*2                ;
        dec     ch                      ;
        jnz     @@5                     ;
                                        ;
        ret                             ;
;---------------------------------------;
draw_watch:                             ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        push    sData                   ;
        pop     ds                      ; ds = sData
        mov     di, (10*90+63)*2        ; offset to screen place
        mov     si, offset watches      ;
        mov     ah, ATTR                ;
        mov     ch, 4                   ; 4 rows
        xor     bp, bp                  ; current item
@@10:                                   ;
        push    cx                      ;
        mov     cl, 9                   ;
        push    si                      ;
@@20:                                   ;
        lodsb                           ;
        stosw                           ;
        dec     cl                      ;
        jnz     @@20                    ;

        cmp     [ active_win ], W_WATCH ; it's active window?
        jnz     @@25                    ;
        cmp     bp, [ watchCUR ]        ; it's current item?
        jnz     @@25                    ;
        mov     cl, 9                   ;
        sub     di, 9*2-1               ;
@@22:                                   ;
        mov     [ byte es:di ], NEGATTR ;
        inc     di                      ;
        inc     di                      ;
        dec     cl                      ;
        jnz     @@22                    ;
        dec     di                      ;
@@25:                                   ;
        inc     bp                      ;
        inc     di                      ;
        inc     di                      ;
        pop     si                      ;
        push    si                      ;
        mov     dx, [ ss:TSSv86._ds ]   ; default : DS
        call    Expression              ;
        cmp     [ byte ds:si ], ':'     ;
        jne     @@30                    ;
        mov     dx, ax                  ;
        inc     si                      ;
        call    Expression              ;
@@30:                                   ;
        mov     bx, ax                  ;
        mov     ah, ATTR                ;
        cmp     [ WATCHtxt ], 1         ;
        jnz     @@39                    ;
        mov     cl, 16                  ;
@@31:                                   ;
        call    get_memory              ;
        inc     bx                      ;
        cmp     al, ' '                 ;
        jb      @@32                    ;
        cmp     al, 0F0h                ;
        jb      @@33                    ;
@@32:                                   ;
        mov     al, '.'                 ;
@@33:                                   ;
        stosw                           ;
        dec     cl                      ;
        jnz     @@31                    ;
        sub     di, 8                   ;
        jmp     short @@55              ;
@@39:                                   ;
        mov     cl, 4                   ;
        lea     si, [ di+12*2 ]         ;
@@40:                                   ;
        call    get_memory              ;
        push    ax                      ;
        call    PrintHex8               ;
        mov     al, ' '                 ;
        stosw                           ;
        pop     ax                      ;
        cmp     al, ' '                 ;
        jb      @@45                    ;
        cmp     al, 0F0h                ;
        jb      @@50                    ;
@@45:                                   ;
        mov     al, '.'                 ;
@@50:                                   ;
        mov     [ byte es:si ], al      ;
        inc     si                      ;
        inc     si                      ;
        inc     bx                      ;
        dec     cl                      ;
        jnz     @@40                    ;
@@55:                                   ;
        pop     si                      ;
        add     di, 68*2                ;
        add     si, 20                  ;
        pop     cx                      ;
        dec     ch                      ;
        jnz     @@10                    ;

        ret                             ;
;---------------------------------------;----------------------------------
keys_in_CPU:                            ;
        call    draw_cpu                ;
@@loop:                                 ;
        mov     bx, [ cpuCUR ]          ;
        mov     dx, [ cpuSEG ]          ;
        call    getch                   ;
        cmp     ax, 0FFFFh              ;
        je      cpu_ret                 ;
        mov     si, offset KEYS_cpu     ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_CPU   ;
        je      keys_in_CPU             ;
cpu_ret:ret                             ;

cpu_down:                               ; ( DOWN )
        mov     bx, [ cpuCUR ]          ;
        mov     dx, [ cpuSEG ]          ;
        push    bx                      ;
        call    get_next_cmd            ;
        mov     [ cpuCUR ], bx          ;
        pop     ax                      ;
        cmp     ax, [ cpuLAST ]         ;
        jae     @@next_dn               ;
        ret                             ;
@@next_dn:                              ;
        mov     [ cpuLAST ], bx         ;
        mov     bx, [ word cpuOFF ]     ;
        call    get_next_cmd            ;
        mov     [ cpuOFF ], bx          ;
        ret                             ;
cpu_up:                                 ; ( UP )
        mov     bx, [ cpuCUR ]          ;
        mov     dx, [ cpuSEG ]          ;
        push    bx                      ;
        call    get_prev_cmd            ;
        mov     [ cpuCUR ], bx          ;
        pop     ax                      ;
        cmp     ax, [ cpuOFF ]          ;
        jbe     @@next_up               ;
        ret                             ;
@@next_up:                              ;
        mov     [ cpuOFF ], bx          ;
        ret                             ;
cpu_origin:                             ; ( Ctrl + O )
        mov     ax,[word ss:TSSv86._eip];
        mov     [ ds:cpuOFF ], ax       ;
        mov     [ ds:cpuCUR ], ax       ;
        mov     ax,[ss:TSSv86._cs]      ;
        mov     [ ds:cpuSEG ], ax       ;
        ret                             ;
cpu_goto:                               ; ( Ctrl + G )
        mov     si, offset mess_03      ;
        mov     di, (90*5+20)*2         ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        mov     [ ds:cpuOFF ], bx       ;
        mov     [ ds:cpuCUR ], bx       ;
        mov     [ ds:cpuSEG], dx        ;
@@ret:                                  ;
        ret                             ;
cpu_new:                                ; ( Ctrl + N )
        mov     [word ss:TSSv86._cs], dx;
        mov     [word ss:TSSv86._eip],bx;
        call    draw_regs               ;
        mov     [Int_P],0               ;᫨ ⠭  cs:ip ,  㫨
        mov     [Int_PP],0              ; 䫠   INT  out/in
        ret                             ;
cpu_follow:                             ; ( Ctrl + F )
        call    get_next_cmd            ;
        cmp     [ ds:follow_off ], 0FFFFh;
        jne     @@3                     ;
        mov     al, [ byte ds:oper_type ];
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 080h                ;
        jne     @@2                     ;
        test    al, opINT               ; int?
        jz      @@1                     ;
        xor     dx, dx                  ;
        mov     bl, [ ds:second_byte ]  ;
        mov     bh, 0                   ;
        shl     bx, 2                   ;
        call    get_mem_word            ;
        mov     [ ds:follow_off ], ax   ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
        mov     [ ds:follow_seg ], ax   ;
        jmp     short @@3               ;
@@1:                                    ;
        test    al, opCALL              ; call?
        jz      @@ret                   ;
@@1_:                                   ;
        mov     bx, [ ds:data_off ]     ;
        mov     dx, [ ds:data_seg ]     ;
        cmp     dx, 0FFFEh              ;
        jz      @@ret                   ;
        call    get_mem_word            ;
        mov     [ ds:follow_off ], ax   ;
        cmp     [ byte ds:oper_len ], 4 ;
        jne     @@3                     ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
        mov     [ ds:follow_seg ], ax   ;
        jmp     short @@3               ;
@@2:                                    ;
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 0C0h                ;
        jne     @@ret                   ;
        test    al, opJMP               ; jmp?
        jnz     @@1_                    ;
        ret                             ;
@@3:                                    ;
        mov     di, [ ds:follow_ptr ]   ;
        cmp     di, 5*6                 ;
        jb      @@5                     ;
        xor     di, di                  ;
@@5:                                    ;
        add     di, offset follow_stk   ;
        push    ds                      ;
        pop     es                      ;
        mov     ax, [ cpuSEG ]          ;
        stosw                           ;
        mov     ax, [ cpuOFF ]          ;
        stosw                           ;
        mov     ax, [ cpuCUR ]          ;
        stosw                           ;
        sub     di, offset follow_stk   ;
        mov     [ follow_ptr ], di      ;

        mov     ax, [ follow_seg ]      ;
        cmp     ax, 0FFFEh              ;
        je      @@10                    ;
        mov     [ cpuSEG ], ax          ;
@@10:                                   ;
        mov     ax, [ follow_off ]      ;
        mov     [ cpuOFF ], ax          ;
        mov     [ cpuCUR ], ax          ;
@@ret:                                  ;
        ret                             ;
cpu_prev:                               ; ( Ctrl + P )
        mov     si, [ ds:follow_ptr ]   ;
        or      si, si                  ;
        jz      @@ret                   ;
        sub     si, 6                   ;
        mov     [ ds:follow_ptr ], si   ;
        add     si, offset follow_stk   ;
        lodsw                           ;
        mov     [ ds:cpuSEG ], ax       ;
        lodsw                           ;
        mov     [ ds:cpuOFF ], ax       ;
        lodsw                           ;
        mov     [ ds:cpuCUR ], ax       ;
@@ret:                                  ;
        ret                             ;
cpu_search:                             ; ( Ctrl + S )
        call    searching               ;
        jnc     cpu_found               ;
        ret                             ;
cpu_cont_s:                             ; ( Ctrl + L )
        call    cont_searching          ;
        jnc     cpu_found               ;
        ret                             ;
cpu_found:                              ;
        mov     [ ds:cpuCUR ], bx       ;
        mov     [ ds:cpuOFF ], bx       ;
        mov     [ ds:cpuSEG ], dx       ;
        ret                             ;
cpu_pgup:                               ; ( PGUP )
        mov     cx, 20                  ;
@@30:                                   ;
        push    cx                      ;
        call    cpu_up                  ;
        pop     cx                      ;
        loop    @@30                    ;
        ret                             ;
cpu_pgdn:                               ; ( PGDN )
        mov     cx, 20                  ;
@@40:                                   ;
        push    cx                      ;
        call    cpu_down                ;
        pop     cx                      ;
        loop    @@40                    ;
        ret                             ;
cpu_f1:                                 ; ( F1 )
        pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+25
        call    draw_frame              ; ࠬ
        mov     si, offset f1_cpu       ;
        mov     di,(90*2+11)*2
        mov     cx, 25
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret
cpu_f2:                                 ; ( F2 )
        call    is_break                ; breakpoint?
        jc      @@790                   ;
        call    DisableBreak            ;
        mov     [ byte ds:si ], 0FFh    ;
        call    FACE                    ;
        ret                             ;
@@790:                                  ;
        call    find_free_break         ;
        jnc     @@10                    ;
        mov     si, offset mess_01      ;
        mov     ah, 00                  ;
        call    draw_message            ;
        ret                             ;
@@10:                                   ;
        mov     ah, 0                   ; on execution
        mov     [ byte ds:si ], ah      ;
        mov     [ word ds:si+1 ], bx    ;
        mov     [ word ds:si+3 ], dx    ;
        call    SetBreak                ;
        cmp     [ last_key ], _Alt or _F2;
        jnz     @@20                    ;

        mov     bp, si                  ;
@@12:                                   ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     di, (90*5+20)*2         ;
        push    di                      ;
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di, 12*2                ;
        mov     si, offset mess_16      ;
        call    put_string              ;
        pop     di                      ;
        add     di, (90*1+1)*2          ;
        call    edit_text               ;
        jc      @@20                    ;
        mov     si, offset buffer       ;
        push    ds                      ;
        pop     es                      ;
        mov     di, bp                  ;
        sub     di, offset breaks       ;
        shl     di, 3                   ;
        add     di, offset conditions   ; di = conditions+N_BREAK*40
        push    di                      ;
        mov     cx, 40                  ;
        rep     movsb                   ;
        pop     si                      ;
        call    check_condition         ;
        cmp     al, 0                   ;
        jz      @@15                    ;
        mov     si, offset mess_17      ;
        mov     ah, 00                  ;
        call    draw_message            ;
        jmp     short @@12              ;
@@15:                                   ;
        or      [ byte ds:bp ], 80h     ;
@@20:                                   ;
        call    FACE                    ;
        ret                             ;
cpu_sf2:                                ; ( Shift + F2 )
        call    is_break                ; breakpoint?
        jc      @@ret                   ;
        cmp     [ byte si ], 80h        ;
        jnz     @@ret                   ;
        dec     al                      ;
        mov     ah, 0                   ;
        imul    ax, ax, 40              ;
        mov     si, offset conditions   ;
        add     si, ax                  ;
        push    ds                      ;
        pop     es                      ;
        mov     di, offset buffer+1     ;
@@10:                                   ;
        lodsb                           ;
        stosb                           ;
        or      al, al                  ;
        jnz     @@10                    ;
        mov     bx, di                  ;
        mov     si, offset buffer       ;
        sub     bx, si                  ;
        dec     bx                      ;
        dec     bx                      ;
        mov     [ byte si ], bl         ;
        mov     ah, 00                  ;
        call    draw_message            ;
@@ret:                                  ;
        ret                             ;
cpu_f4:                                 ; ( F4 )
do_f4:                                  ;
        xor     ax, ax                  ;
        call    SetBreak                ;
        mov     [ ret_val ], 0          ;
        mov     [ switch_scr ], 1       ;
        mov     [ active_win ], W_NONE  ;
        ret                             ;
cpu_alt_f7:                             ; ( Alt + F7 )
        mov     dx,[word ss:TSSv86._cs ];
        mov     bx,[word ss:TSSv86._eip];
        call    get_next_cmd            ;
        mov     al, [ byte ds:oper_type ];
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 80h                 ;
        je      do_one_cmd              ;
l@@5:                                   ;
        mov     [ ret_val ], 1          ;
        mov     [ active_win ], W_NONE  ;
        ret                             ;
do_one_cmd:                             ;
        cmp     al, opINOUT or 80h      ; call or int ?
        jb      @@40                    ;
        test    al, opINOUT             ;
        jz      @@20                    ;
        mov     cx, [ word ss:TSSv86._edx ];
        cmp     cx, 03B0h               ;
        jb      @@20                    ;
        cmp     cx, 03DFh               ;
        jbe     @@99                    ;
@@20:                                   ;
        test    al, opDSSI              ;
        jz      @@30                    ;
        mov     cx, [ word ss:TSSv86._ds ];
        cmp     cx, 0A000h              ;
        jb      @@30                    ;
        cmp     cx, 0C000h              ;
        jb      @@99                    ;
@@30:                                   ;
        test    al, opESDI              ;
        jz      @@40                    ;
        mov     cx, [ word ss:TSSv86._es ];
        cmp     cx, 0A000h              ;
        jb      @@40                    ;
        cmp     cx, 0C000h              ;
        jnb     @@40                    ;
        jmp     @@99                    ;
@@40:                                   ;
        cmp     [ byte ds:tmp ], 07Fh   ;
        jz      @@50                    ;
        mov     si, [ word ds:oper_seg ];
        shl     si, 2                   ;
        push    ds                      ;
        push    sTSS                    ;
        pop     ds                      ;
        mov     cx, [ word ds:si+_ES ]  ;
        pop     ds                      ;
        cmp     cx, 0A000h              ;
        jb      @@50                    ;
        cmp     cx, 0C000h              ;
        jnb     @@50                    ;
@@99:                                   ;
        mov     [ byte ds:switch_scr ], 1;
@@50:                                   ;
        mov     [ ret_val ], 1          ;
        mov     [ active_win ], W_NONE  ;
        ret                             ;
cpu_f7:                                 ; ( F7 )
        mov     dx,[word ss:TSSv86._cs ];
        mov     bx,[word ss:TSSv86._eip];
        call    get_next_cmd            ;
        mov     al, [ byte ds:oper_code];
        cmp     al,0F1h
        jne     @@cf7
        mov     [ds:bpice_flag],1
@@cf7:  mov     al, [ byte ds:oper_type ];
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 80h                 ;
        jne     do_one_cmd              ;
do_f7:                                  ;
        test    al, opINT               ; is it INT ?
        jz      do_one_cmd              ;
        cmp     [ byte second_byte ], 21h; int 21h ?
;        jne     do_f4                   ;
        jne     do_one_cmd              ;
        cmp     [word ss:TSSv86._eax ], 4B00h;
;        jne     do_f4                   ;
        jne     do_one_cmd              ;
        cmp     [ word last_key ], _F8  ;
        je      do_f4                   ;
        mov     [ ret_val ], 2          ;
        mov     [ switch_scr ], 1       ;
        mov     [ active_win ], W_NONE  ;
        ret                             ;
cpu_f8:                                 ; ( F8 )
        mov     dx,[word ss:TSSv86._cs ];
        mov     bx,[word ss:TSSv86._eip];
        call    get_next_cmd            ;
        mov     al, [ byte ds:oper_code];
        cmp     al,0F1h
        jne     @@cf8
        mov     [ds:bpice_flag],1
@@cf8:  mov     al, [ byte ds:oper_type];
        mov     ah, al                  ;
        and     ah, 0C0h                ;
        cmp     ah, 80h                 ;
        jne     do_one_cmd              ;
;????
;        test    al, opREP               ; rep?
;        jnz     do_f4                   ;
        cmp     [ds:pref],1
        jz      do_f4                   ;

        cmp     [ds:oper_code],0e0h
        jb      @@q1
        cmp     [ds:oper_code],0e2h
        jbe     do_f4

@@q1:   test    al, opCALL              ; call?
        jnz     do_f4                   ;
        test    al, opINT               ; is it INT ?
        jnz     do_f4                   ;
        jmp     do_f7                   ;
                                        ;
        ret                             ;
cpu_break:                              ; Alt + 1 (+2,+3)
        and     ax, 3                   ;
        mov     si, offset breaks-5     ;
@@10:                                   ;
        add     si, 5                   ;
        call    find_break              ;
        jc      @@ret                   ;
        test    [ byte ds:si ], 0Fh     ;
        jnz     @@10                    ;
        dec     ax                      ;
        jnz     @@10                    ;
        mov     ax, [ ds:si+1 ]         ;
        mov     [ ds:cpuOFF ], ax       ;
        mov     [ ds:cpuCUR ], ax       ;
        mov     ax, [ ds:si+3 ]         ;
        mov     [ ds:cpuSEG ], ax       ;
@@ret:                                  ;
        ret                             ;
cpu_kill:                               ; ( Alt + K )
        push    bx                      ;
        call    get_next_cmd            ;
        pop     cx                      ;
        mov     al, 90h                 ; nop
@@10:                                   ;
        dec     bx                      ;
        call    set_memory              ;
        cmp     bx, cx                  ;
        jnz     @@10                    ;
        ret                             ;
cpu_jmp:                                ; ( Alt + J )
        call    get_memory              ;
        cmp     al, 70h                 ;
        jb      @@no                    ;
        cmp     al, 7Fh                 ;
        ja      @@no                    ;
        mov     al, 0EBh                ; jmp
        call    set_memory              ;
@@no:                                   ;
        ret                             ;
cpu_to_stack:                           ; ( Ctrl + B )
        mov     dx,[word ss:TSSv86._ss ];
        mov     bx,[word ss:TSSv86._esp];
        call    ask_stack_type          ;
        cmp     al, 27                  ;
        jz      @@ret                   ;
        push    ax                      ;
        mov     dx,[word ss:TSSv86._ss ];
        mov     bx,[word ss:TSSv86._esp];
        call    get_mem_word            ;
        mov     cx, ax                  ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
        pop     bx                      ;
        cmp     bh, 1                   ;
        jz      @@10                    ;
        mov     ax,[word ss:TSSv86._cs ];
@@10:                                   ;
        mov     [ ds:cpuOFF ], cx       ;
        mov     [ ds:cpuCUR ], cx       ;
        mov     [ ds:cpuSEG], ax        ;
@@ret:                                  ;
        ret                             ;
cpu_to_int:                             ; ( Ctrl + I )
        mov     di, (90*5+20)*2         ;
        call    go_to_int               ;
        jc      @@ret                   ;
        mov     [ ds:cpuOFF ], cx       ;
        mov     [ ds:cpuCUR ], cx       ;
        mov     [ ds:cpuSEG ], ax       ;
@@ret:                                  ;
        ret                             ;
;---
cpu_int:                                ; ( Alt + I )
        mov     si, offset mess_20      ;
        mov     di, (90*7+15)*2
        call    get_seg_off             ; bx --  ᫮
        jc      @@ret
        cmp     bx,100h
        je      @@y
        push    bx
        mov     si, offset mess_21      ;
        mov     di, (90*7+15)*2
        call    get_seg_off             ; bx --  ᫮
        jnc     @@r
        pop     bx
        ret
@@y:    mov     bx,0ffffh
        push    bx
@@r:    mov     [Int_F],bx              ; 㭪
        pop     bx
        mov     [Int_N],bl              ;  猪
        mov     [Int_P],0

@@ret:
        ret

cpu_port:                               ;⠭ 猪  
        mov     si, offset mess_22      ;
        mov     di, (90*7+15)*2
        call    get_seg_off             ; bx --  ᫮
        jnc     cpu_po3                 ;
        ret


;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
; - 樨  INT'a          ; ( Alt + G )
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
cpu_gen_int:
        push    bx dx
        mov     si, offset mess_30      ;
        mov     di, (90*7+15)*2
        call    get_seg_off             ;
        jnc     cpu_gen1                ;
        ret
cpu_gen1:
        mov     [byte ptr g_i+1],bl          ;  뢠
        mov     ax,[ss:TSSv86._es]
        mov     [word ptr g_es+1],ax
        mov     ax,[ss:TSSv86._ds]
        mov     [word ptr g_ds+1],ax
        mov     ax,[ss:TSSv86._fs]
        mov     [word ptr g_fs+1],ax
        mov     ax,[ss:TSSv86._gs]
        mov     [word ptr g_gs+1],ax

        mov     eax,[ss:TSSv86._eflags]
        mov     [dos_fl],ax
        mov     [trace],0

        push    es
        mov     ax,sConv                ;
        mov     es,ax                   ; Load 4Gb selector
        mov     di,offset dos_buf
        mov     esi,09fd50h            ;32    9fd5:0
        mov     cx,100/4
dos_g1: mov     eax,[es:esi]              ;࠭  
        mov     [di],eax
        add     esi,4
        add     di,4
        loop    dos_g1
        mov     di,offset gen_int     ;ᬥ饭.  楤
        mov     esi,09ff50h            ;32    9ff50:0
        mov     cx,70/4
dos_g2: mov     eax,[di]              ;ᠫ ᢮ 楄
        mov     [es:esi],eax
        add     esi,4
        add     di,4
        loop    dos_g2
        pop     es
        xor     eax,eax
        mov     ax,[ss:TSSv86._ss]
        push    eax
        mov     eax,[ss:TSSv86._esp]
        push    eax
        mov     eax,22202h
        mov     [ss:TSSv86._eflags],eax
        push    eax

        xor     eax,eax
        mov     ax,9ff5h
        push    eax
        xor     ax,ax
        push    eax

        mov     eax,[ss:TSSv86._eax]
        mov     ebx,[ss:TSSv86._ebx]
        mov     ecx,[ss:TSSv86._ecx]
        mov     edx,[ss:TSSv86._edx]
        mov     ebp,[ss:TSSv86._ebp]
        mov     esi,[ss:TSSv86._esi]
        mov     edi,[ss:TSSv86._edi]
        iretd                           ;

;-----------------------------------------
; 楤      INT (7 )
;-----------------------------------------
gen_int:push    ax
g_ds:   mov     ax,0
        mov     ds,ax
g_es:   mov     ax,0
        mov     es,ax
g_fs:   mov     ax,0
        mov     fs,ax
g_gs:   mov     ax,0
        mov     gs,ax
        pop     ax
g_i:    db      0cdh,13h
;        int     13h
        mov     ax,'CM'
        int     0ffh                    ;ਢ  ᪫祭
;-----------------------------------------

cpu_po3:
        mov     [Int_PP],0
        cmp     bx,0
        jne     cpu_po1

        mov     cx,4096
cpu_po2:mov     [word ss:bx+2+TSSv86.iomap], 0
        add     bx,2
        dec     cx
        jne     cpu_po2                 ;㫨  
        ret

cpu_po1:mov     cl,bl
        shr     bx,3
        and     cl,00111b
        mov     al,1
        shl     al,cl                   ;⠭ 㦭 
        xor     [byte ss:bx+2+TSSv86.iomap],al
        ret

;---------------------------------------;----------------------------------
keys_in_REGS:                           ; 02
        call    draw_regs               ;
@@loop:                                 ;
        call    getch                   ;
        mov     bx, offset regs_table   ;
        add     bx, [ word ds:regsCUR ] ;
        cmp     ax, 0FFFFh              ;
        je      regs_ret                ;
        cmp     ax, ' '                 ;
        je      @@edit_regs2            ;
        cmp     ax, _Enter              ;
        je      @@edit_regs2            ;
        cmp     ax, ' '                 ;
        jb      @@10                    ;
        cmp     ax, 80h                 ;
        jb      @@edit_regs             ;
@@10:                                   ;
        mov     si, offset KEYS_regs    ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_REGS  ;
        je      keys_in_REGS            ;
        ret                             ;

@@edit_regs:                            ;
        call    unget_key               ;
@@edit_regs2:                           ;
        mov     si, offset mess_08      ;
        mov     di, (90*5+20)*2         ;
        push    ebx                     ;
        call    get_seg_off             ;
        mov     eax, ebx                ;
        pop     ebx                     ;
        jc      @@loop                  ;
        mov     bx, [ word bx+4 ]       ;
        cmp     [ byte REGS32 ], 0      ;
        jz      @@20                    ;
        cmp     bx, _ES                 ;
        jae     @@20                    ;
        cmp     bx, _IP                 ;
        jz      @@20                    ;
        cmp     bx, _SP                 ;
        jz      @@20                    ;
        mov     [ gs:bx ], eax          ;
        jmp     short @@30              ;
@@20:                                   ;
        mov     [ gs:bx ], ax           ;
@@30:                                   ;
        call    FACE                    ;
        jmp     keys_in_REGS            ;

regs_zero:                              ; ( Ctrl + Z )
        mov     bx, [ word bx+4 ]       ;
        mov     [ dword gs:bx ], 000    ;
        call    FACE                    ;
        jmp     keys_in_REGS            ;
regs_inc:                               ; ( Ctrl + I )
        mov     bx, [ word bx+4 ]       ;
        inc     [ dword gs:bx ]         ;
        call    FACE                    ;
        jmp     keys_in_REGS            ;
regs_dec:                               ; ( Ctrl + D )
        mov     bx, [ word bx+4 ]       ;
        dec     [ dword gs:bx ]         ;
        call    FACE                    ;
        jmp     keys_in_REGS            ;
regs_f1:pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+4
        call    draw_frame              ; ࠬ
        mov     si, offset f1_regs      ;
        mov     di,(90*2+11)*2
        mov     cx, 4
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret


regs_up:                                ; ( Up )
        mov     al, [ byte bx ]         ;
        mov     [ byte ds:regsCUR ], al ;
        ret                             ;
regs_down:                              ; ( Down )
        mov     al, [ byte bx+1 ]       ;
        mov     [ byte ds:regsCUR ], al ;
        ret                             ;
regs_left:                              ; ( Left )
        mov     al, [ byte bx+2 ]       ;
        mov     [ byte ds:regsCUR ], al ;
        ret                             ;
regs_right:                             ; ( Right )
        mov     al, [ byte bx+3 ]       ;
        mov     [ byte ds:regsCUR ], al ;
        ret                             ;
regs_ret:                               ;
        ret                             ;
;---------------------------------------;----------------------------------
keys_in_STACK:                          ; 04
        call    draw_stack              ;
@@loop:                                 ;
        call    getch                   ;
        mov     bx, [ ds:stackCUR ]     ;
        mov     dx, [ ds:stackSEG ]     ;
        cmp     ax, 0FFFFh              ;
        je      stack_ret               ;
        cmp     ax, ' '                 ;
        jb      @@10                    ;
        cmp     ax, 80h                 ;
        jb      @@edit_stack            ;
@@10:                                   ;
        mov     si, offset KEYS_stack   ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_STACK;
        je      keys_in_STACK           ;
        ret                             ;

@@edit_stack:                           ;
        call    unget_key               ;
        mov     si, offset mess_08      ;
        mov     di, (90*18+20)*2        ;
        push    dx                      ;
        push    bx                      ;
        call    get_seg_off             ;
        mov     ax, bx                  ;
        pop     bx                      ;
        pop     dx                      ;
        jc      @@loop                  ;
        call    set_memory              ;
        inc     bx                      ;
        mov     al, ah                  ;
        call    set_memory              ;
        jmp     keys_in_STACK           ;

stack_f1:
        pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+3
        call    draw_frame              ; ࠬ
        mov     si, offset f1_stack     ;
        mov     di,(90*2+11)*2
        mov     cx, 3
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret

stack_up:                               ; ( Up )
        mov     si, 2                   ;
        jmp     short stack_up_down     ;
stack_down:                             ; ( Down )
        mov     si, -2                  ;
stack_up_down:                          ;
        add     bx, si                  ;
        mov     [ stackCUR ], bx        ;
        mov     ax, [ stackOFF ]        ;
        mov     cx, [ stackLAST ]       ;
        call    check_in                ;
        jnc     @@ret                   ;
        add     [ stackLAST ], si       ;
        add     [ stackOFF ], si        ;
@@ret:                                  ;
        ret                             ;
stack_pgup:                             ; ( PgUp )
        mov     bp, 7                   ;
@@10:                                   ;
        call    stack_up                ;
        dec     bp                      ;
        jnz     @@10                    ;
        ret                             ;
stack_pgdn:                             ; ( PgDn )
        mov     bp, 7                   ;
@@10:                                   ;
        call    stack_down              ;
        dec     bp                      ;
        jnz     @@10                    ;
        ret                             ;
stack_origin:                           ; ( Ctrl + O )
        mov     ax,[word ss:TSSv86._esp];
        mov     [ ds:stackOFF ], ax     ;
        mov     [ ds:stackCUR ], ax     ;
        mov     ax,[ss:TSSv86._ss]      ;
        mov     [ss:stackSEG],ax        ;
        ret                             ;
stack_new:                              ; ( Ctrl + N )
        mov     [word ss:TSSv86._esp], bx;
        mov     [word ss:TSSv86._ss], dx;
        call    draw_regs               ;
        ret                             ;
stack_goto:                             ; ( Ctrl + G )
        mov     si, offset mess_03      ;
        mov     di, (90*18+20)*2        ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        mov     [ ds:stackOFF ], bx     ;
        mov     [ ds:stackCUR ], bx     ;
        mov     [ ds:stackSEG], dx      ;
@@ret:                                  ;
        ret                             ;
stack_ret:                              ;
        ret                             ;
;---------------------------------------;----------------------------------
keys_in_DUMP:                           ; 08
        call    draw_dump               ;
@@loop:                                 ;
        call    edit_dump               ;
        cmp     ax, 0FFFFh              ;
        jne     @@loop                  ;
        ret                             ;
;---------------------------------------;----------------------------------
edit_dump:                              ;
        call    draw_dump               ;
        call    getch                   ;
        mov     bp, ax                  ;
        mov     bx, [ ds:dumpCUR ]      ;
        mov     dx, [ ds:dumpSEG ]      ;
        cmp     ax, 100h                ;
        jae     @@50                    ;
        cmp     [ byte ds:flag_edit ], 0;
        jnz     @@30                    ; hex?

        sub     al, '0'                 ;
        jl      @@50                    ;
        cmp     al, 9                   ;
        jle     @@10                    ;
        and     al, 11011111b           ;
        cmp     al, 'A'-'0'             ;
        jb      @@50                    ;
        cmp     al, 'F'-'0'             ;
        ja      @@50                    ;
        sub     al, 7                   ;
@@10:                                   ;
        mov     ah, al                  ;
        shl     al, 4                   ;
        or      al, ah                  ;
        mov     cl, [ byte ds:edit_mask ];
        and     al, cl                  ;
        mov     ah, al                  ;
        call    get_memory              ;
        not     cl                      ;
        and     al, cl                  ;
        or      al, ah                  ;
        call    set_memory              ;
        mov     [ byte ds:edit_mask ], cl;
        cmp     cl, 0Fh                 ;
        jz      edit_dump               ;
        jmp     dump_right              ;
@@30:                                   ;
        cmp     ax, ' '                 ;
        jb      @@50                    ;
        call    set_memory              ;
        jmp     dump_right              ;
@@50:                                   ;
        mov     ax, bp                  ;
        mov     [ byte ds:edit_mask ], 0F0h;

        mov     si, offset KEYS_dump    ;
        call    do_keys                 ;
        jnc     edit_dump               ;

        ret                             ;
dump_home:                              ; ( Home )
        mov     ax, [ ds:dumpOFF ]      ;
        mov     [ ds:dumpCUR ], ax      ;
        ret                             ;
dump_enter:                             ;
        not     [ byte ds:flag_edit ]   ;
        ret                             ;
dump_left:                              ; ( Left )
        dec     [ ds:dumpCUR ]          ;
        cmp     bx, [ ds:dumpOFF ]      ;
        jnz     @@ret                   ;
        sub     [ ds:dumpOFF ], 16      ;
@@ret:                                  ;
        ret                             ;
dump_C_left:                            ; ( Ctrl + Left )
        dec     [ ds:dumpOFF ]          ;
        dec     [ ds:dumpCUR ]          ;
        ret                             ;
dump_right:                             ; ( Right )
        inc     [ ds:dumpCUR ]          ;
        cmp     bx, [ ds:dumpLAST ]     ;
        jnz     @@ret                   ;
        add     [ ds:dumpOFF ], 16      ;
        add     [ ds:dumpLAST ], 16     ;
@@ret:                                  ;
        ret                             ;
dump_C_right:                           ; ( Ctrl + Right )
        inc     [ ds:dumpOFF ]          ;
        inc     [ ds:dumpCUR ]          ;
        ret                             ;
dump_up:                                ; ( Up )
        sub     bx, 16                  ;
        mov     [ ds:dumpCUR ], bx      ;
        mov     ax, [ ds:dumpOFF ]      ;
        mov     cx, [ ds:dumpLAST ]     ;
        call    check_in                ;
        jnc     @@ret                   ;
        sub     [ ds:dumpOFF ], 16      ;
@@ret:                                  ;
        ret                             ;
dump_down:                              ; ( Down )
        add     bx, 16                  ;
        mov     [ ds:dumpCUR ], bx      ;
        mov     ax, [ ds:dumpOFF ]      ;
        mov     cx, [ ds:dumpLAST ]     ;
        call    check_in                ;
        jnc     @@ret                   ;
        add     [ ds:dumpOFF ], 16      ;
        add     [ ds:dumpLAST ], 16     ;
@@ret:                                  ;
        ret                             ;
dump_pgup:                              ; ( PgUp )
        movzx   cx, [ byte ds:dump_size ];
@@10:                                   ;
        push    cx                      ;
        mov     bx, [ ds:dumpCUR ]      ;
        call    dump_up                 ;
        pop     cx                      ;
        loop    @@10                    ;
        ret                             ;
dump_pgdn:                              ; ( PgDn )
        movzx   cx, [ byte ds:dump_size ];
@@10:                                   ;
        push    cx                      ;
        mov     bx, [ ds:dumpCUR ]      ;
        call    dump_down               ;
        pop     cx                      ;
        loop    @@10                    ;
        ret                             ;
dump_goto:                              ; ( Ctrl + G )
        mov     si, offset mess_03      ;
        mov     di, [ word ds:dump_beg ];
        add     di, 15*2                ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        mov     [ ds:dumpCUR ], bx      ;
        and     bx, 0FFF0h              ;
        mov     [ ds:dumpOFF ], bx      ;
        mov     [ ds:dumpSEG], dx       ;
@@ret:                                  ;
        ret                             ;
dump_to_int:                            ; ( Ctrl + I )
        mov     di, (90*19+20)*2        ;
        call    go_to_int               ;
        jc      @@ret                   ;
        mov     [ ds:dumpCUR ], cx      ;
        and     cx, 0FFF0h              ;
        mov     [ ds:dumpOFF ], cx      ;
        mov     [ ds:dumpSEG], ax       ;
@@ret:                                  ;
        ret                             ;
dump_f1:pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+14
        call    draw_frame              ; ࠬ
        mov     si, offset f1_dump      ;
        mov     di,(90*2+11)*2
        mov     cx, 14
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret



dump_f2:                                ; ( F2 )
        call    is_break                ; breakpoint?
        jc      @@790                   ;
        call    DisableBreak            ;
        mov     [ byte ds:si ], 0FFh    ;
        call    FACE                    ;
        ret                             ;
@@790:                                  ;
        call    find_free_break         ;
        jnc     @@10                    ;
        mov     si, offset mess_01      ;
        mov     ah, 00                  ;
        call    draw_message            ;
        ret                             ;
@@10:                                   ;
        mov     cl, al                  ;
        call    ask_break_type          ;
        mov     al, cl                  ;
        cmp     ah, 27                  ;
        jz      @@20                    ;
        mov     [ byte ds:si ], ah      ;
        mov     [ word ds:si+1 ], bx    ;
        mov     [ word ds:si+3 ], dx    ;
        call    SetBreak                ;
        cmp     [ last_key ], _Alt or _F2;
        jnz     @@20                    ;

        mov     bp, si                  ;
        mov     si, offset mess_18      ;
        mov     di, [ word ds:dump_beg ];
        add     di, 15*2                ;
        call    get_seg_off             ;
        jc      @@20                    ;
        mov     si, bp                  ;
        sub     si, offset breaks       ;
        shr     si, 2                   ; si = 0..2
        mov     [ byte si+offset brk_value ], bl;
        or      [ byte ds:bp ], 80h     ;
@@20:                                   ;
        call    FACE                    ;
        ret                             ;
dump_sf2:                               ; ( Shift + F2 )
        call    is_break                ; breakpoint?
        jc      @@ret                   ;
        test    [ byte si ], 0Fh        ;
        jz      @@ret                   ; on execution ?
        test    [ byte si ], 80h        ;
        jz      @@ret                   ; conditional ?
        dec     al                      ;
        mov     ah, 0                   ;
        mov     si, ax                  ;
        mov     al, [ byte si+brk_value ];
        mov     si, offset mess_19      ;
        mov     ah, 0FFh                ;
        call    draw_message            ;
@@ret:                                  ;
        ret                             ;
dump_f5:                                ; ( F5 )
        cmp     [ byte ds:dump_size ], 5;
        je      @@50                    ;
        mov     [ byte ds:dump_size ], 5;
        mov     [ word ds:dump_beg ], (90*24+1)*2;
        mov     ax, [ ds:dumpOFF ]      ;
        mov     [ ds:dumpCUR ], ax      ;
        call    clear_face              ;
        call    FACE                    ;
        ret                             ;
@@50:                                   ;
        mov     [ byte ds:dump_size ], 27;
        mov     [ word ds:dump_beg ], (90*2+1)*2;
        call    FACE                    ;
        ret                             ;
dump_break:                             ; Alt + 1 (+2,+3)
        and     ax, 3                   ;
        mov     si, offset breaks-5     ;
@@10:                                   ;
        add     si, 5                   ;
        call    find_break              ;
        jc      @@ret                   ;
        test    [ byte ds:si ], 0Fh     ;
        jz      @@10                    ;
        dec     ax                      ;
        jnz     @@10                    ;
        mov     ax, [ ds:si+1 ]         ;
        mov     [ ds:dumpCUR ], ax      ;
        and     ax, 0FFF0h              ;
        mov     [ ds:dumpOFF ], ax      ;
        mov     ax, [ ds:si+3 ]         ;
        mov     [ ds:dumpSEG ], ax      ;
@@ret:                                  ;
        ret                             ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
; - ࠭    䠩 ; ( Alt + S )
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
dump_save:
        push    bx dx
        mov     si, offset mess_23      ;
        mov     di, [ word ds:dump_beg ];
        add     di, 15*2                ;
        push    di
        call    get_seg_off             ;
        pop     di
        jc      dos_err                 ;
        mov     [ ds:save_ip ], bx      ;ᬥ饭
        mov     [ ds:save_cs], dx       ;ᥣ
        mov     si, offset mess_24      ;
        push    di
        call    get_seg_off             ;
        pop     di
        jc      dos_err                 ;
        mov     [ ds:save_cx ], bx      ;
        push    es sVideo               ;
        pop     es                      ; es = sVideo
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        push    di
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di,9*2                  ;
        mov     si,offset mess_25       ;
        call    put_string              ;
        pop     di                      ;
        add     di, 90*2+2              ;
        call    edit_text               ;
        pop     es
        jc      dos_err                 ;
        push    es ds
        pop     es
        mov     di,offset buffer
        push    di
        mov     cx,8
        mov     al,0
        repne   scasb
        jz      @@10
        pop     di
        push    di
        mov     cx,8
        mov     al,'.'
        repne   scasb
        jnz      @@5
        mov     cx,3
        mov     al,0
        repne   scasb
        jz      @@10
@@5:    mov     [byte di],0
@@10:   pop     si
        mov     di,offset dos_proc + 2
        mov     cx,15
        push    ds
        pop     es
        rep     movsb
        mov     ax,sConv
        mov     es,ax
        mov     ebx,[Dos_flag]
        cmp     [byte es:ebx],0
        pop     es
        jz      dos_in                   ; --   ᢮

        xor     ax,ax
        mov     si,offset mess_26       ;ப  ⮬,   .
        call    draw_message
        jmp     dos_err

;---- ᢮ --   !!! ------------------------------------
;max
dos_in:

         mov     eax,[ss:TSSv86._eflags]
         mov     [dos_fl],ax
;         mov     cl,[trace]
;         mov     [tr_s],cl
         mov     [trace],0

         mov     cx,[save_cx]
         mov     [word dos_p2+1],cx     ;ᠬ䨪 
         mov     cx,[save_ip]
         mov     [word dos_p4+1],cx
         mov     cx,[save_cs]
         mov     [word dos_p3+1],cx

         push    es
         mov     ax,sConv                ;
         mov     es,ax                   ; Load 4Gb selector
         mov     di,offset dos_buf
         mov     esi,09fd50h            ;32    9fd5:0
         mov     cx,100/4
dos_i1:  mov     eax,[es:esi]              ;࠭  
         mov     [di],eax
         add     esi,4
         add     di,4
         loop    dos_i1
         mov     di,offset dos_proc    ;ᬥ饭.  楤
         mov     esi,09ff50h            ;32    9ff50:0
         mov     cx,70/4
dos_i2:  mov     eax,[di]              ;ᠫ ᢮ 楄
         mov     [es:esi],eax
         add     esi,4
         add     di,4
         loop    dos_i2
         mov     eax,[ss:dos_adr]
         mov     esi,4*21h
         xchg    eax,[es:esi]
         mov     [ss:dos_adr],eax
         pop     es
dos_in_main:
        xor     eax,eax
        mov     ax,[ss:TSSv86._ss]
        push    eax
        mov     eax,[ss:TSSv86._esp]
        push    eax

;        mov     eax,[ss:TSSv86._eflags]
;        and     eax,0fffefcffh          ; Clear IF,TF,RF
;        mov     [ss:TSSv86._eflags],eax
        mov     eax,22202h
        mov     [ss:TSSv86._eflags],eax
        push    eax

        xor     eax,eax
        mov     ax,9ff5h
        push    eax
        xor     ax,ax
        push    eax

        iretd                           ;


dos_err:pop     dx bx
        mov     di,[ds:dumpCUR]
        call    SetCursor
        call    FACE
        ret


;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
; - 㧪    䠩 ; ( Alt + L )
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-
dump_load:
        push    bx dx
        mov     si, offset mess_27      ;
        mov     di, [ word ds:dump_beg ];
        add     di, 15*2                ;
        push    di
        call    get_seg_off             ;
        pop     di
        jc      dos_err                 ;
        mov     [ ds:save_ip ],bx       ;32 ⮢ ᬥ饭  䠩
        mov     [ ds:save_cs], dx       ;ᥣ
        mov     si, offset mess_24      ;
        push    di
        call    get_seg_off             ;
        pop     di
        jc      dos_err                 ;
        mov     [ ds:save_cx ], bx      ;
        push    es sVideo               ;
        pop     es                      ; es = sVideo
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        push    di
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di,9*2                  ;
        mov     si,offset mess_29       ;
        call    put_string              ;
        pop     di                      ;
        add     di, 90*2+2              ;
        call    edit_text               ;
        pop     es
        jc      dos_err                 ;
        push    es ds
        pop     es
        mov     di,offset buffer
        push    di
        mov     cx,8
        mov     al,0
        repne   scasb
        jz      @@10
        pop     di
        push    di
        mov     cx,8
        mov     al,'.'
        repne   scasb
        jnz      @@5
        mov     cx,3
        mov     al,0
        repne   scasb
        jz      @@10
@@5:    mov     [byte di],0
@@10:   pop     si
        mov     di,offset dos_proc2 + 2
        mov     cx,15
        push    ds
        pop     es
        rep     movsb
        mov     ax,sConv
        mov     es,ax
        mov     ebx,[Dos_flag]
        cmp     [byte es:ebx],0
        pop     es
        jz      dos_in2                  ; --   ᢮

        xor     ax,ax
        mov     si,offset mess_26       ;ப  ⮬,   .
        call    draw_message
        jmp     dos_err

dos_in2:
         mov     eax,[ss:TSSv86._eflags]
         mov     [dos_fl],ax

         mov     cx,[save_cx]
         mov     [word dos_r2+1],cx     ;ᠬ䨪 
         mov     cx,[save_ip]
         mov     [word dos_r3+1],cx
         mov     cx,[save_cs]
         mov     [word dos_r4+1],cx

         push    es
         mov     ax,sConv                ;
         mov     es,ax                   ; Load 4Gb selector
         mov     di,offset dos_buf
         mov     esi,09fd50h            ;32    9fd50:0
         mov     cx,100/4
dos_q1:  mov     eax,[es:esi]              ;࠭  
         mov     [di],eax
         add     esi,4
         add     di,4
         loop    dos_q1
         mov     di,offset dos_proc2   ;ᬥ饭.  楤
         mov     esi,09ff50h            ;32    9ff50:0
         mov     cx,70/4
dos_q2:  mov     eax,[di]              ;ᠫ ᢮ 楄
         mov     [es:esi],eax
         add     esi,4
         add     di,4
         loop    dos_q2
         mov     eax,[ss:dos_adr]
         mov     esi,4*21h
         xchg    eax,[es:esi]
         mov     [ss:dos_adr],eax
         pop     es
         jmp     dos_in_main


;-----------------------------------------
;    
;-----------------------------------------
dos_buf:db      100   dup(0)
;-----------------------------------------
; 楤     ࠭ 䠩 (68 )
;-----------------------------------------
dos_proc:jmp    dos_p1
        db      15    dup(0)
dos_p1: mov     ax,8ff5h
        mov     ss,ax
        mov     sp,0fffeh
        mov     ax,3c00h
        mov     dx,2                    ;ᬥ饭   (᫥ jmp)
        xor     cx,cx
        push    cs
        pop     ds
        int     21h
        jc      dos_p_err
        mov     bx,ax
        push    ax
        mov     ax,4000h
dos_p2: mov     cx,0                    ;\\\
dos_p3: mov     dx,0                    ;ᠬ. .
        mov     ds,dx
dos_p4: mov     dx,0                    ;///
        int     21h
        pop     bx
        mov     ah,3eh
        int     21h
dos_p_err:
        mov     ax,'CM'
        int     0ffh                    ;ਢ  ᪫祭

;-----------------------------------------
; 楤   ⠢  䠩   (67 )
;-----------------------------------------
dos_proc2:jmp    dos_r1
        db      15    dup(0)
dos_r1: mov     ax,8ff5h
        mov     ss,ax
        mov     sp,0fffeh
        mov     ax,3d00h
        mov     dx,2                    ;ᬥ饭   (᫥ jmp)
        xor     cx,cx
        push    cs
        pop     ds
        int     21h
        jc      dos_r_err
        mov     bx,ax
        push    ax
        mov     ah,3fh
dos_r2: mov     cx,0                    ;\\\
dos_r4: mov     dx,0                    ;ᠬ. .
        mov     ds,dx
dos_r3: mov     dx,0                    ;///
        int     21h
        pop     bx
        mov     ah,3eh
        int     21h
dos_r_err:
        mov     ax,'CM'
        int     0ffh                    ;ਢ  ᪫祭

;-------------------------------------
;ࠡ⪠  
;-------------------------------------
;wait_dos:
;
;        push    es sVideo               ;
;        pop     es                      ; es = sVideo
;        mov     ah, 17h                 ;
;        mov     cx, 40*256+1            ;
;        mov     di, 90*2+10
;        push    di
;        call    draw_frame              ;
;        pop     di                      ;
;        push    di                      ;
;        add     di,90*2+2                 ;
;        mov     si,offset w_d_1         ;
;        call    put_string              ;
;        pop     di                      ;
;        add     di, 90*2+8              ;
;        call    edit_text               ;
;        pop     es
;        ret
;w_d_1:  db      'DOS is bisy !',0
;
;        mov     [Int_N2],1
;        mov     edx,[Dos_flag]
;        mov     ebx,edx
;        and     bx,01111h
;        shr     edx,4                   ;dx:bx --  䫠
;        mov     ax, 100h                ; 0`     
;        call    SetBreak                ; ⠭
;        mov     [ ret_val ], 0          ;
;        mov     [ switch_scr ], 1       ;
;        mov     [ active_win ], W_NONE  ;
;        ret                             ;

dump_search:                            ; ( Ctrl + S )
        call    searching               ;
        jnc     dump_found              ;
        ret                             ;
dump_cont_s:                            ; ( Ctrl + L )
        call    cont_searching          ;
        jnc     dump_found              ;
        ret                             ;
dump_found:                             ;
        mov     [ ds:dumpCUR ], bx      ;
        mov     [ ds:dumpSEG ], dx      ;
        mov     ax, [ ds:dumpOFF ]      ;
        mov     cx, [ ds:dumpLAST ]     ;
        call    check_in                ;
        jnc     @@ret                   ;
        and     bx, 0FFF0h              ;
        mov     [ ds:dumpOFF ], bx      ;
@@ret:                                  ;
        ret                             ;
;---------------------------------------;
keys_in_FLAGS:                          ;
        call    draw_flags              ;
@@loop:                                 ;
        call    getch                   ;
        mov     bx, [ ds:flagsCUR ]     ;
        cmp     ax, 0FFFFh              ;
        je      flags_ret               ;
        mov     si, offset KEYS_flags   ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_FLAGS ;
        je      keys_in_FLAGS           ;
flags_ret:
        ret                             ;
flags_f1:
        pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+1
        call    draw_frame              ; ࠬ
        mov     si, offset f1_flags     ;
        mov     di,(90*2+11)*2
        mov     cx, 1
@@_11:  push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_11
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret

flags_toggle:                           ;
        imul    bx,3                    ;
        mov     ax, [ word flags_tbl+1+bx ];
        xor     [ gs:_FL ], ax          ;
        call    draw_regs               ;
        ret                             ;
flags_up:                               ;
        dec     bx                      ;
        jns     @@ret                   ;
        mov     bx, 7                   ;
@@ret:                                  ;
        mov     [ ds:flagsCUR ], bx     ;
        ret                             ;
flags_down:                             ;
        inc     bx                      ;
        cmp     bx, 8
        jnz     @@ret                   ;
        xor     bx, bx                  ;
@@ret:                                  ;
        mov     [ ds:flagsCUR ], bx     ;
        ret                             ;
;---------------------------------------;
keys_in_WATCH:                          ;
        call    draw_watch              ;
@@loop:                                 ;
        call    getch                   ;
        mov     bx, [ ds:watchCUR ]     ;
        cmp     ax, 0FFFFh              ;
        je      watch_ret               ;
        cmp     ax, _Enter              ;
        je      @@15                    ;
        cmp     ax, ' '                 ;
        jz      @@15                    ;
        jb      @@10                    ;
        cmp     ax, 80h                 ;
        jb      @@edit_watch            ;
@@10:                                   ;
        mov     si, offset KEYS_watch   ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_WATCH ;
        je      keys_in_WATCH           ;
        ret                             ;
@@edit_watch:                           ;
        call    unget_key               ;
@@15:                                   ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     si, offset mess_08      ;
        mov     di, (90*18+20)*2        ;
        push    bx                      ;
        push    di                      ;
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di, 12*2                ;
        call    put_string              ;
        pop     di                      ;
        add     di, (90*1+1)*2          ;
        call    edit_text               ;
        pop     bx                      ;
        jc      @@30                    ;
        push    ds                      ;
        pop     es                      ;
        mov     si, offset buffer       ;
        imul    bx, bx, 20              ;
        add     bx, offset watches      ;
        mov     di, bx                  ;
        push    di                      ;
        mov     cx, 19                  ;
        mov     al, ' '                 ;
        rep     stosb                   ;
        pop     di                      ;
        mov     cx, 19                  ;
@@20:                                   ;
        lodsb                           ;
        or      al, al                  ;
        jz      @@30                    ;
        stosb                           ;
        loop    @@20                    ;
@@30:                                   ;
        pushf                           ;
        call    FACE                    ;
        popf                            ;
        jmp     keys_in_WATCH           ;
watch_f1:
        pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+1
        call    draw_frame              ; ࠬ
        mov     si, offset f1_watch     ;
        mov     di,(90*2+11)*2
        mov     cx, 1
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret
watch_up:                               ; ( Up )
        dec     bx                      ;
        jmp     short w_UD              ;
watch_down:                             ; ( Down )
        inc     bx                      ;
w_UD:                                   ;
        and     bx, 3                   ;
        mov     [ ds:watchCUR ], bx     ;
@@ret:                                  ;
        ret                             ;
watch_text:                             ; ( Ctrl + T )
        xor     [ WATCHtxt ], 1         ;
        ret                             ;
watch_ret:                              ;
        ret                             ;
;---------------------------------------;
keys_in_BP:                             ;
        call    draw_bp                 ;
@@loop:                                 ;
        call    getch                   ;
        mov     bx, [ ds:bpCUR ]        ;
        cmp     ax, 0FFFFh              ;
        je      bp_ret                  ;
        cmp     ax, ' '                 ;
        jb      @@10                    ;
        cmp     ax, 80h                 ;
        jb      @@edit_bp               ;
@@10:                                   ;
        mov     si, offset KEYS_bp      ;
        call    do_keys                 ;
        jc      @@loop                  ;
        cmp     [ active_win ], W_BP    ;
        je      keys_in_BP              ;
        ret                             ;

@@edit_bp:                              ;
        call    unget_key               ;
        mov     si, offset mess_08      ;
        mov     di, (90*18+20)*2        ;
        push    bx                      ;
        call    get_seg_off             ;
        mov     ax, bx                  ;
        pop     bx                      ;
        jc      @@loop                  ;
        mov     dx, [ ss:TSSv86._ss ]   ;
        add     bx, [word ss:TSSv86._ebp ]
        call    set_memory              ;
        inc     bx                      ;
        mov     al, ah                  ;
        call    set_memory              ;
        call    FACE                    ;
        jmp     keys_in_BP              ;

bp_f1:  pusha                           ;
        push    es
        push    sVideo
        pop     es
        mov     di,(90*1+10)*2
        mov     ah,15
        mov     cx,45*256+2
        call    draw_frame              ; ࠬ
        mov     si, offset f1_bp        ;
        mov     di,(90*2+11)*2
        mov     cx, 2
@@_pov: push    di cx
        call    put_string              ;뢥 ⥪  ࠬ
        pop     cx di
        add     di,90*2
        dec     cx
        jne     @@_pov
        mov     ah,14
        mov     si,offset f1_end
        call    put_string              ;ࠩ 
        call    getkey                  ; wait
        pop     es
        call    clear_face              ;
        call    FACE                    ;
        popa
        ret

bp_up:                                  ; ( Up )
        mov     si, 2                   ;
        jmp     short bp_up_down        ;
bp_down:                                ; ( Down )
        mov     si, -2                  ;
bp_up_down:                             ;
        add     bx, si                  ;
        mov     [ bpCUR ], bx           ;
        mov     ax, [ bpOFF ]           ;
        mov     cx, [ bpLAST ]          ;
        call    check_in                ;
        jnc     @@ret                   ;
        add     [ bpLAST ], si          ;
        add     [ bpOFF ], si           ;
@@ret:                                  ;
        ret                             ;
bp_pgup:                                ; ( PgUp )
        mov     bp, 14                  ;
@@10:                                   ;
        call    bp_up                   ;
        dec     bp                      ;
        jnz     @@10                    ;
        ret                             ;
bp_pgdn:                                ; ( PgDn )
        mov     bp, 14                  ;
@@10:                                   ;
        call    bp_down                 ;
        dec     bp                      ;
        jnz     @@10                    ;
        ret                             ;
bp_origin:                              ; ( Ctrl+O )
        mov     [ bpOFF ], -000Ah       ;
        mov     [ bpCUR ], 0000         ;
        ret                             ;
bp_goto:                                ; ( Ctrl+G )
        mov     si, offset mess_03      ;
        mov     di, (90*18+20)*2        ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        mov     [ bpCUR ], bx           ;
        sub     bx, 000Ah               ;
        mov     [ bpOFF ], bx           ;
@@ret:                                  ;
        ret                             ;
bp_ret:                                 ;
        ret                             ;
;---------------------------------------;
go_to_int:                              ; di-scr.position, result -> ax:cx
        mov     si, offset mess_09      ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        and     bx, 00FFh               ;
        shl     bx, 2                   ;
        xor     dx, dx                  ;
        call    get_mem_word            ;
        mov     cx, ax                  ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
@@ret:                                  ;
        pusha                           ;
        pushf                           ;
        call    draw_cpu                ;
        popf                            ;
        popa                            ;
        ret                             ;
;---------------------------------------;
check_in:                               ; bx in ax-cx?
        cmp     ax, cx                  ; <CY> - out, <NC> - in
        ja      @@10                    ;
        cmp     bx, ax                  ;
        jb      @@no                    ;
        cmp     bx, cx                  ;
        ja      @@no                    ;
@@yes:                                  ;
        clc                             ;
        ret                             ;
@@10:                                   ;
        cmp     bx, ax                  ;
        jae     @@20                    ;
        cmp     bx, cx                  ;
        jbe     @@yes                   ;
        jmp     short @@no              ;
@@20:                                   ;
        cmp     bx, cx                  ;
        jae     @@yes                   ;
@@no:                                   ;
        stc                             ;
        ret                             ;
;---------------------------------------;
; ணࠬ ᪠ ப/᫠      ;
;---------------------------------------;
searching:                              ; from dx:bx
        push    sVideo                  ; if <NC> - OK, else - none
        pop     es                      ; es = sVideo
        mov     si, offset mess_05      ;
        mov     di, (90*12+20)*2        ;
        push    di                      ;
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di, 10*2                ;
        call    put_string              ;
        pop     di                      ;
        add     di, (90*1+1)*2          ;
        call    edit_text               ;
        jc      s_none                  ;
        push    ds                      ;
        pop     es                      ;
        mov     di, offset search_bytes ;
        mov     si, offset buffer       ;
        call    blanks                  ;
        mov     cl, [ byte si ]         ;
        cmp     cl, 27h                 ; ' -- 窠
        je      @@text                  ;
        cmp     cl, 22h                 ; "
        je      @@text                  ;
@@10:                                   ;
        cmp     [ byte si ], 0          ;
        jz      @@all                   ;
        call    Expression              ;
        cmp     ah, 0                   ;
        jz      @@20                    ;
        stosw                           ;
        jmp     short @@10              ;
@@20:                                   ;
        stosb                           ;
        jmp     short @@10              ;
@@text:                                 ;
        inc     si                      ;
@@30:                                   ;
        lodsb                           ;
        cmp     al, 0                   ;
        jz      @@all                   ;
        cmp     al, cl                  ;
        jz      @@all                   ;
        stosb                           ;
        jmp     short @@30              ;
@@all:                                  ;
        sub     di, offset search_bytes ;
        jz      s_none                  ;
        mov     [ word n_search ], di   ;
;---------------------------------------;
cont_searching:                         ; from dx:bx
@@5:                                    ; if <NC> - OK, else - none
        mov     si, offset search_bytes ;
        mov     cx, [ word n_search ]   ;
        jcxz    s_none                  ;
        inc     bx                      ;
        push    bx                      ;
@@10:                                   ;
        lodsb                           ;
        mov     ah, al                  ;
        call    get_memory              ;
        inc     bx                      ;
        jz      @@20                    ;
        cmp     al, ah                  ;
        jnz     @@20                    ;
        loop    @@10                    ;
        pop     bx                      ;
        call    FACE                    ;
        clc                             ; found
        ret                             ;
@@20:                                   ;
        or      bx, bx                  ;
        pop     bx                      ;
        jnz     @@5                     ;
        mov     si, offset mess_07      ;
        mov     ah, 00                  ;
        call    draw_message            ;
        cmp     dx, 0F000h              ;
        jae     @@30                    ;
        and     al, 11011111b           ;
        cmp     ax, 'Y'                 ;
        jnz     @@30                    ;
        add     dx, 1000h               ;
        mov     bx, 0FFFFh              ;
        cmp     dx, 0A000h              ;
        jb      @@5                     ;
        cmp     dx, 0C000h              ;
        jae     @@5                     ;
        mov     dx, 0C000h              ;
        jmp     @@5                     ;
@@30:                                   ;
        stc                             ; not found
        ret                             ;
s_none:                                 ;
        call    FACE                    ;
        stc                             ; not found
        ret                             ;
;---------------------------------------;
PrintHex8:                              ;
        push    ax                      ;
        shr     al, 4                   ;
        call    oh8                     ;
        pop     ax                      ;
        and     al, 0Fh                 ;
oh8:                                    ;
        cmp     al, 0Ah                 ;
        sbb     al, 69h                 ;
        das                             ;
        stosw                           ;
        ret                             ;
;---------------------------------------;
PrintHex16:                             ;
        push    ax                      ;
        mov     al, ah                  ;
        mov     ah, ATTR                ;
        call    PrintHex8               ;
        pop     ax                      ;
        mov     ah, ATTR                ;
        call    PrintHex8               ;
        ret                             ;
;---------------------------------------;
PrintHex16_2:                           ;
        push    ax                      ;
        mov     al, ah                  ;
        mov     ah, 15                  ;
        call    PrintHex8               ;
        pop     ax                      ;
        mov     ah, 15                  ;
        call    PrintHex8               ;
        ret                             ;
;---------------------------------------;
put_string:                             ; cs:si
        lods    [ byte cs:si ]          ;
        or      al, al                  ;
        jz      short @@10              ;
        stosw                           ;
        jmp     short put_string        ;
@@10:                                   ;
        ret                             ;
;---------------------------------------;
put_seg_off:                            ; dx:bx
        push    ds                      ;
        push    si                      ;
        or      ax, ax                  ;
        jz      short @@10              ;
        mov     si, ax                  ;
        mov     ax, sTSS                ;
        mov     ds, ax                  ;
        cmp     dx, [ word ds:si ]      ;
        jne     short @@10              ;
        mov     ax, ' '+256*ATTR        ;
        stosw                           ;
        lea     si, [ si + offset seg_txt - _ES ];
        call    put_string              ;
        jmp     short @@20              ;
@@10:                                   ;
        mov     ax, dx                  ;
        call    PrintHex16              ;
@@20:                                   ;
        mov     al, ':'                 ;
        stosw                           ;
        mov     ax, bx                  ;
        call    PrintHex16              ;
        mov     al, ' '                 ;
        stosw                           ;
        pop     si                      ;
        pop     ds                      ;
        ret                             ;
;---------------------------------------;
get_memory:                             ; [ dx:bx ] -> al
        push    ds                      ;
        push    esi                     ;
        push    ecx                     ;
        mov     cx,sConv                ;
        mov     ds,cx                   ;
        movzx   esi,dx                  ;
        shl     esi,4                   ;
        movzx   ecx,bx                  ;
        mov     al, [ esi+ecx ]         ;
        pop     ecx                     ;
        pop     esi                     ;
        pop     ds                      ;
        ret                             ;
;---------------------------------------;
set_memory:                             ; [ dx:bx ] <- al
        push    ds                      ;
        push    esi                     ;
        push    ecx                     ;
        mov     cx,sConv                ;
        mov     ds,cx                   ;
        movzx   esi,dx                  ;
        shl     esi,4                   ;
        movzx   ecx,bx                  ;
        mov     [ esi+ecx ], al         ;
        pop     ecx                     ;
        pop     esi                     ;
        pop     ds                      ;
        ret                             ;
;---------------------------------------;
get_mem_word:                           ; [ dx:bx ] -> ax
        call    get_memory              ;
        mov     ah, al                  ;
        inc     bx                      ;
        call    get_memory              ;
        xchg    al, ah                  ;
        dec     bx                      ;
        ret                             ;
;---------------------------------------;
get_next_cmd:                           ; get address of next CPU command
        push    ds                      ; source and result in dx:bx
        push    es                      ;
        push    cx                      ;
        mov     ax, sData               ;
        mov     ds, ax                  ;
        mov     es, ax                  ; ds = es = sData
        mov     si, offset buffer       ;
        mov     di, si                  ;
        push    bx                      ;
        mov     ax, si                  ;
        sub     ax, bx                  ;
        neg     ax                      ;
        mov     [ word ds:reloc ], ax   ;
        mov     cx, 30                  ;
@@10:                                   ;
        call    get_memory              ;
        inc     bx                      ;
        stosb                           ;
        loop    @@10                    ;
        call    DisAsm                  ;
        mov     [ byte ds:tmp ], al     ;
        mov     [ byte ds:oper_seg ], ah;
        mov     [ byte ds:oper_len ], cl;
        sub     si, offset buffer       ;
        pop     bx                      ;
        add     bx, si                  ;
        pop     cx                      ;
        pop     es                      ;
        pop     ds                      ;
        ret                             ;
;---------------------------------------;
get_prev_cmd:                           ; dx:bx -> dx:bx
        push    bp                      ;
        push    cx                      ;
        mov     bp, bx                  ;
        sub     bx, 32                  ;
        jnc     @@20                    ;
        xor     bx, bx                  ;
@@20:                                   ;
        mov     cx, bx                  ;
        call    get_next_cmd            ;
        cmp     bx, bp                  ;
        jb      @@20                    ;
        mov     bx, cx                  ;
        pop     cx                      ;
        pop     bp                      ;
        ret                             ;
;---------------------------------------;
getch:                                  ;
        call    getkey                  ;
        mov     [ word last_key ], ax   ;
        cmp     ax, _Ctrl or 'V'        ;
        je      ctrl_V                  ;
        cmp     ax, _Ctrl or _F2        ;
        je      ctrl_F2                 ;
        cmp     ax, _Ctrl or _F4        ;
        je      ctrl_F4                 ;
        cmp     ax, _Alt or _F5         ;
        je      alt_F5                  ;
        cmp     ax, _Esc                ;
        je      alt_F5
        cmp     ax, _F9                 ;
        je      F9                      ;
        cmp     ax, _F10                ;
        je      F10                     ;
        cmp     ax,_Ctrl or 'R'         ;
        je      ctrl_R                  ;
        cmp     ax, _Ctrl or _Alt or _Del;
        je      exit                    ;
        cmp     ax, _Alt or 'X'         ;
        je      exit                    ;
        cmp     ax, _Ctrl or 'C'        ;
        je      clr_scr                 ;
        cmp     ax, _Ctrl or '1'        ;
        jb      @@10                    ;
        cmp     ax, _Ctrl or '7'        ;
        jbe     quick_to_window         ;
@@10:                                   ;
        cmp     [ byte ds:dump_size ], 5;
        jne     @@20                    ;
        cmp     ax, _Tab                ;
        je      win_tab                 ;
        cmp     ax, _Shift or _Tab      ;
        je      win_sh_tab              ;
@@20:                                   ;
        ret                             ;


ctrl_V:                                 ;
        pusha                           ;
        call    draw_vectors            ;
        call    FACE                    ;
        popa                            ;
        jmp     getch                   ;

clr_scr:                                ; ( Ctrl + C ) ⪠ ࠭
        pushad
        push    ds es
        mov     ax, sData               ;
        mov     ds, ax                  ;
        mov     es, ax                  ;
        lea     di, [ video_data ]      ;
        call    RestorePlanes           ;
        lea     si, [ video_mode ]      ;
        call    SetMode                 ;⠭ ०
        push    sConv
        pop     es
        cld
        mov     edi,0A0000h             ;砫 
        xor     eax,eax
        mov     ecx,16384               ;
        rep     stos [dword ptr esi]
        mov     ecx,16384               ;⥪
        mov     eax, 07000700h   ;
        rep     stos [dword ptr esi]
clr_exit:
        lea     di, [ video_mode ]      ;
        call    SaveMode                ;
        lea     di, [ video_data ]      ;
        call    SavePlanes              ;
        lea     si, [ video_mode_03 ]   ;
        call    SetMode                 ;
        call    clear_face              ;
        call    FACE                    ;
        pop     es ds
        popad
        jmp     getch                   ;
ctrl_F4:                                ; ( Ctrl + F4 )
        pusha                           ;
        call    calculator              ;
        popa                            ;
        jmp     getch                   ;
ctrl_F2:                                ;
        mov     [ ret_val ], 0FEh       ;
        mov     [ switch_scr ], 1       ;
        mov     [ active_win ], W_NONE  ;
        mov     [ init_flag ], 0        ;
        mov     ax, 0FFFFh              ;
        ret                             ;

ctrl_R:                                 ; ( Ctrl + R )
        xor     [ byte REGS32 ], 2      ;
        call    FACE                    ;
        ret                             ;
alt_F5:                                 ;
        pusha                           ;
        push    ds                      ;
        push    es                      ;
        mov     ax, sData               ;
        mov     ds, ax                  ;
        mov     es, ax                  ;
        lea     di, [ video_data ]      ;
        call    RestorePlanes           ;
        lea     si, [ video_mode ]      ;
        call    SetMode                 ;
        call    getkey                  ; wait
        lea     di, [ video_mode ]      ;
        call    SaveMode                ;
        lea     di, [ video_data ]      ;
        call    SavePlanes              ;
        lea     si, [ video_mode_03 ]   ;
        call    SetMode                 ;
        call    clear_face              ;
        call    FACE                    ;
        pop     es                      ;
        pop     ds                      ;
        popa                            ;
        jmp     getch                   ;
F9:                                     ; ( F9 )
        mov     [ byte ds:ret_val ], 0  ;
        mov     [ byte ds:switch_scr ], 1;
        mov     [ active_win ], W_NONE  ;
        mov     ax, 0FFFFh              ;
        ret                             ;
F10:
        push    dx bx
        mov     bx,[word ss:TSSv86._esp];
        mov     dx,[ss:TSSv86._ss]      ;
        push    ds ebx edx
        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector
        movzx   edx,dx
        shl     edx,4
        movzx   ebx,bx
        add     ebx,edx                 ;
        mov     ax,[ds:ebx]
        pop     edx ebx ds
        mov     [ word ds:p_ret_of],ax  ;
        mov     ax, 300h                ; access
        call    SetBreak                ; set BP on stack top
        pop     bx dx
        mov     [ byte ds:p_ret   ], 1  ;
        mov     [ byte ds:ret_val ], 0  ;
        mov     [ byte ds:switch_scr ], 1;
        mov     [ active_win ], W_NONE  ;
        mov     ax, 0FFFFh              ;
        ret
exit:                                   ;
        mov     [ ret_val ], 0FFh       ;
        mov     [ switch_scr ], 1       ;
        mov     [ active_win ], W_NONE  ;
        mov     al, 3                   ;
@@10:                                   ;
        call    DisableBreak            ;
        dec     al                      ;
        jns     @@10                    ;
        mov     ax, 0FFFFh              ;
        ret                             ;
quick_to_window:                        ; ( Ctrl 1..7 )
        sub     ax, _Ctrl or '0'        ;
        mov     [ active_win ], al      ;
        cmp     [ byte ds:dump_size ], 5;
        je      @@20                    ;
        mov     [ word ds:dump_beg ], (90*24+1)*2;
        mov     [ byte ds:dump_size ], 5;
        call    clear_face              ;
@@20:                                   ;
        mov     ax, 0FFFFh              ;
        ret                             ;
win_tab:                                ; ( Tab )
        mov     al, [ active_win ]      ;
        inc     al                      ;
        cmp     al, 8                   ;
        jb      win_tabs                ;
        mov     al, 1                   ;
win_tabs:                               ;
        mov     [ active_win ], al      ;
        mov     ax, 0FFFFh              ;
        ret                             ;
win_sh_tab:                             ; ( Shift + Tab )
        mov     al, [ active_win ]      ;
        dec     al                      ;
        jnz     win_tabs                ;
        mov     al, 7                   ;
        jmp     short win_tabs          ;
;---------------------------------------;
draw_message:                           ; ds:si
        push    es                      ;
        push    cx                      ;
        push    di                      ;
        push    ax                      ;
        push    sVideo                  ;
        pop     es                      ; es = sVideo
        mov     di, (90*5+20)*2         ;
        mov     cx, 40*256+1            ;
        mov     ah, 0Eh                 ;
        call    draw_frame              ;
        mov     di, (90*6+21)*2         ;
        lods    [ byte ds:si ]          ;
        sub     al, 40                  ;
        neg     al                      ;
        cbw                             ;
        and     al, 0FEh                ;
        add     di, ax                  ;
        inc     di                      ;
        inc     di                      ;
        mov     ah, 0Ch                 ;
@@30:                                   ;
        lods    [ byte ds:si ]          ;
        stosw                           ;
        or      al, al                  ;
        jnz     @@30                    ;
        pop     ax                      ;
        cmp     ah, 0FFh                ;
        jne     @@40                    ;
        mov     ah, 0Eh                 ;
        call    PrintHex8               ;
@@40:                                   ;
        call    getkey                  ;
        call    FACE                    ;
        pop     di                      ;
        pop     cx                      ;
        pop     es                      ;
        ret                             ;
;---------------------------------------;
SetCursor:                              ; di
        push    ax                      ;
        push    dx                      ;
        mov     dx, 03D4h               ;
        mov     ax, di                  ;
        shr     ax, 1                   ;
        push    ax                      ;
        mov     al, 0Eh                 ;
        out     dx, ax                  ;
        pop     ax                      ;
        mov     ah, al                  ;
        mov     al, 0Fh                 ;
        out     dx, ax                  ;
        pop     dx                      ;
        pop     ax                      ;
        ret                             ;
;---------------------------------------;
HideCursor:                             ;
        push    di                      ;
        mov     di, 90*31*2             ;
        call    SetCursor               ;
        pop     di                      ;
        ret                             ;
;---------------------------------------;
;  ࠬ
draw_frame:                             ; es:di, ch - , cl-. ah-ਡ
        push    si                      ;
        mov     si, offset frame   ; ᮢ ࠬ窠
        push    di                      ;
        lods    [ byte cs:si ]     ;⠫ 
        stosw                      ;ᠫ  
        lods    [ byte cs:si ]     ; ''
        push    cx                      ;
@@10:                                   ;
        stosw                           ;
        dec     ch                      ;
        jnz     @@10      ;ᠫ ``    ࠬ
        pop     cx                      ;
        lods    [ byte cs:si ]          ;
        stosw                           ; ``
        pop     di                      ;
        add     di, 90*2                ;᫥. ப
@@20:                                   ;
        push    di                      ;
        push    si                      ;
        lods    [ byte cs:si ]          ; ``
        stosw                           ;
        lods    [ byte cs:si ]          ;
        push    cx                      ;
@@30:                                   ;
        stosw                           ;
        dec     ch                      ;
        jnz     @@30                    ;⨫ ࠬ

        pop     cx                      ;
        lods    [ byte cs:si ]          ; ``
        stosw                           ;

        pop     si                      ;
        pop     di                      ;
        add     di, 90*2                ;
        dec     cl                      ;
        jnz     @@20                    ;
        add     si, 3                   ;
        lods    [ byte cs:si ]          ;
        stosw                           ;
        lods    [ byte cs:si ]          ;
@@40:                                   ;
        stosw                           ;
        dec     ch                      ;
        jnz     @@40                    ;
        lods    [ byte cs:si ]          ;
        stosw                           ;
        pop     si                      ;
        ret                             ;
;---------------------------------------;
; -- - ⠢ ३
find_break:                             ;
@@10:                                   ; ds:si-address of table (from)
        cmp     si, offset end_breaks   ; ->si if <NC> if <CY> - not found
        jae     @@20                    ;
        cmp     [ byte ds:si ], 0FFh    ;
        jnz     @@found                 ;
        add     si, 5                   ;
        jmp     short @@10              ;
@@20:                                   ;
        stc   ;
        ret                             ;
@@found:                                ;
        clc   ;
        ret                             ;
;---------------------------------------;
;  ᢮  ?
find_free_break:                        ;
        mov     al, 0                   ;
        mov     si, offset breaks       ; ->si if <NC> if <CY> - not found
@@10:                                   ;
        inc     al                      ;
        cmp     si, offset end_breaks   ;
        jae     @@20                    ;
        cmp     [ byte ds:si ], 0FFh    ;
        jz      @@found                 ;
        add     si, 5                   ;
        jmp     short @@10              ;
@@20:                                   ;
        stc                             ;
        ret                             ;
@@found:                                ;
        clc                             ;
        ret                             ;
;---------------------------------------;
is_break:                               ; dx:bx is breakpoint ?
        mov     al, 0                   ; yes - <NC>, no - <CY>
        mov     si, offset breaks-5     ; al = number, si - address
@@10:                                   ;
        add     si, 5                   ;
        inc     al                      ;
        cmp     al, 4                   ;
        stc                             ;
        jz      @@ret                   ;
        cmp     [ byte ds:si ], 0FFh    ;
        jz      @@10                    ;
        cmp     bx, [ si+1 ]            ;
        jnz     @@10                    ;
        cmp     dx, [ si+3 ]            ;
        jnz     @@10                    ;
        clc                             ;
@@ret:                                  ;
        ret                             ;
;---------------------------------------;
;訢 ⨯ 猪
ask_break_type:                         ; ->ah
        push    si                      ;
        push    di                      ;
        push    cx                      ;
        push    sVideo                  ;
        pop     es                      ;
        mov     di, (90*5+20)*2         ;
        mov     cx, 40*256+1            ;
        mov     ah, 04h                 ;
        call    draw_frame              ;
        mov     di, (90*6+22)*2         ;
        mov     si, offset mess_04      ;
        mov     ah, 04h                 ;
        call    put_string              ;
        mov     [ byte es:di-11*2+1 ], 0Ch;
        mov     [ byte es:di-19*2+1 ], 0Ch;
        call    SetCursor               ;
@@10:                                   ;
        call    getkey                  ;
        cmp     ax, _Esc                ;
        jz      @@20                    ;
        cmp     ax, '1'                 ;
        jb      @@10                    ;
        cmp     ax, '2'                 ;
        ja      @@10                    ;
        sub     ax, '0'                 ;
        cmp     al, 2                   ;
        jnz     @@20                    ;
        mov     al, 3                   ;
@@20:                                   ;
        mov     ah, al                  ;
        call    HideCursor              ;
        pop     cx                      ;
        pop     di                      ;
        pop     si                      ;
        ret                             ;
;---------------------------------------;
ask_stack_type:                         ; ->ah
        push    si                      ;
        push    di                      ;
        push    cx                      ;
        push    sVideo                  ;
        pop     es                      ;
        mov     di, (90*5+20)*2         ;
        mov     cx, 30*256+1            ;
        mov     ah, 02h                 ;
        call    draw_frame              ;
        mov     di, (90*6+22)*2         ;
        mov     si, offset mess_14      ;
        mov     ah, 02h                 ;
        call    put_string              ;
        mov     [ byte es:di-09*2+1 ], 0Ah;
        mov     [ byte es:di-15*2+1 ], 0Ah;
        call    SetCursor               ;
@@10:                                   ;
        call    getkey                  ;
        cmp     ax, _Esc                ;
        jz      @@20                    ;
        cmp     ax, '1'                 ;
        jb      @@10                    ;
        cmp     ax, '2'                 ;
        ja      @@10                    ;
        sub     ax, '0'                 ;
        cmp     al, 2                   ;
        jnz     @@20                    ;
        mov     al, 3                   ;
@@20:                                   ;
        mov     ah, al                  ;
        call    HideCursor              ;
        pop     cx                      ;
        pop     di                      ;
        pop     si                      ;
        ret                             ;
;---------------------------------------;
draw_vectors:                           ;
        push    sVideo                  ;
        pop     es                      ;
        mov     di, 2*(90*3+7)          ;
        mov     cx, 3110h               ;
        mov     ah, 17h                 ;
        call    draw_frame              ;
        mov     si, offset mess_15      ;
        mov     di, 2*(90*3+25)         ;
        call    put_string              ;
        mov     di, 2*(90*4+9)          ;
        mov     cl, 0                   ;
        mov     si, offset oldvecs      ;
        xor     dx, dx                  ;
        xor     bx, bx                  ;
@@10:                                   ;
        lodsd                           ;
        cmp     cl, 22h                 ;
        jnz     @@15                    ;
        mov     ebp, [ dword ds:DG22vec ];
        jmp     short @@17              ;
@@15:                                   ;
        mov     ebp, eax                ;
@@17:                                   ;
        call    get_mem_word            ;
        push    ax                      ;
        inc     bx                      ;
        inc     bx                      ;
        call    get_mem_word            ;
        inc     bx                      ;
        inc     bx                      ;
        shl     eax, 16                 ;
        pop     ax                      ;
        cmp     eax, ebp                ;
        mov     ah, 18h                 ;
        jz      @@20                    ;
        mov     ah, 1Eh                 ;
@@20:                                   ;
        mov     al, cl                  ;
        call    PrintHex8               ;
        inc     di                      ;
        inc     di                      ;
        inc     cl                      ;
        test    cl, 0Fh                 ;
        jnz     @@10                    ;
        add     di, 2*(90-16*3)         ;
        cmp     cl, 0                   ;
        jnz     @@10                    ;

        call    getkey                  ;
        ret                             ;
;---------------------------------------;
do_keys:                                ; ax, ds:si = { sub, key, ... }
        mov     cx, ax                  ;
@@10:                                   ;
        lodsw                           ;
        or      ax, ax                  ;
        je      @@notfound              ;
        mov     di, ax                  ;
        lodsw                           ;
        cmp     ax, cx                  ;
        jne     @@10                    ;
        call    di                      ;
        clc                             ;
        ret                             ;
@@notfound:                             ;
        mov     ax, cx                  ;
        stc                             ;
        ret                             ;
;---------------------------------------;
Jcc_calls:                              ;
        seto    al                      ; 0
        ret                             ;
        setno   al                      ; 1
        ret                             ;
        setc    al                      ; 2
        ret                             ;
        setnc   al                      ; 3
        ret                             ;
        setz    al                      ; 4
        ret                             ;
        setnz   al                      ; 5
        ret                             ;
        setbe   al                      ; 6
        ret                             ;
        seta    al                      ; 7
        ret                             ;
        sets    al                      ; 8
        ret                             ;
        setns   al                      ; 9
        ret                             ;
        setpe   al                      ; A
        ret                             ;
        setpo   al                      ; B
        ret                             ;
        setl    al                      ; C
        ret                             ;
        setge   al                      ; D
        ret                             ;
        setle   al                      ; E
        ret                             ;
        setg    al                      ; F
        ret                             ;
;---------------------------------------;
tables:                                 ;
        db      1,'',61,'','',22,'','',03,'',''
        db      8,'',61,' ','',22,' ','',03,' ',''
        db      1,'',61,' ','',22,'','',03,'',''
        db      4,'',61,' ','',22,' ',' ',03,' ',''
        db      1,'',61,' ','',14,'','',11,'',''
        db      7,'',61,' ','',14,' ','',11,' ',''
        db      1,'',61,'','',14,'','',11,' ',''
        db      6,'',61,' ',' ',14,' ','',11,' ',''
        db      1,'',61,'','',14,'','',11,'',''
etable:                                 ;
frame:                                  ;
        db      'Ŀ'                   ;
        db      ' '                   ;
        db      ''                   ;
        db      0                       ;
;---------------------------------------;
reg_tbl:                                ;
        db      'ax',_AX                ;
        db      'ds',_DS                ;
        db      'bx',_BX                ;
        db      'es',_ES                ;
        db      'cx',_CX                ;
        db      'fs',_FS                ;
        db      'dx',_DX                ;
        db      'gs',_GS                ;
        db      'si',_SI                ;
        db      'ss',_SS                ;
        db      'di',_DI                ;
        db      'sp',_SP                ;
        db      'bp',_BP                ;
        db      'cs',_CS                ;
        db      'fl',_FL                ;
        db      'ip',_IP                ;
flags_tbl:                              ;
        db      'o'                     ;
        dw      0000100000000000b       ;
        db      'd'                     ;
        dw      0000010000000000b       ;
        db      'i'                     ;
        dw      0000001000000000b       ;
        db      's'                     ;
        dw      0000000010000000b       ;
        db      'z'                     ;
        dw      0000000001000000b       ;
        db      'a'                     ;
        dw      0000000000010000b       ;
        db      'p'                     ;
        dw      0000000000000100b       ;
        db      'c'                     ;
        dw      0000000000000001b       ;
;---------------------------------------;
regs_table:                             ; up, down, left, right
        db       84,  12,   6,   6      ; 0
        dw      _AX                     ;
        db       90,  18,   0,   0      ; 6
        dw      _DS                     ;
        db        0,  24,  18,  18      ; 12
        dw      _BX                     ;
        db        6,  30,  12,  12      ; 18
        dw      _ES                     ;
        db       12,  36,  30,  30      ; 24
        dw      _CX                     ;
        db       18,  42,  24,  24      ; 30
        dw      _FS                     ;
        db       24,  48,  42,  42      ; 36
        dw      _DX                     ;
        db       30,  54,  36,  36      ; 42
        dw      _GS                     ;
        db       36,  60,  54,  54      ; 48
        dw      _SI                     ;
        db       42,  66,  48,  48      ; 54
        dw      _SS                     ;
        db       48,  72,  66,  66      ; 60
        dw      _DI                     ;
        db       54,  78,  60,  60      ; 66
        dw      _SP                     ;
        db       60,  84,  78,  78      ; 72
        dw      _BP                     ;
        db       66,  90,  72,  72      ; 78
        dw      _CS                     ;
        db       72,  00,  90,  90      ; 84
        dw      _FL                     ;
        db       78,  06,  84,  84      ; 90
        dw      _IP                     ;
;---------------------------------------;
dump_title:                             ;
        db      '.0 .1 .2 .3 .4 .5 .6 .7 .8 .9 .A .B .C .D .E .F';
        db      '  0123456789ABCDEF',0  ;
;---------------------------------------;
seg_txt:                                ;
        db      ' es',0                 ;
        db      ' cs',0                 ;
        db      ' ss',0                 ;
        db      ' ds',0                 ;
        db      ' fs',0                 ;
        db      ' gs',0                 ;
;---------------------------------------;
mess_01:        db      26, '3 breakpoints allowed only',0;
mess_02:        db      34, 'Program terminated. Exit code :',0
mess_03:        db      'Enter segment:offset',0;
mess_04:        db      'Breakpoint type (1-write 2-access) ?',0
mess_05:        db      'Enter search byte(s)',0;
mess_06:        db      25, 'General protection fault',0
mess_07:        db      39, 'Search byte(s) not found (Y-next segm)',0
mess_08:        db      'Enter expression',0;
mess_09:        db      ' Go to interrupt ',0;
mess_11:        db      'From:',0;
mess_12:        db      'Number of bytes:',0;
mess_13:        db      26, 'Program already terminated',0;
mess_14:        db      'Go to stack (1-far 2-near) ?',0
mess_15:        db      ' Hooked vectors ',0
mess_16:        db      ' Enter condition ',0
mess_17:        db      18, 'Invalid condition',0
mess_18:        db      'Enter value',0;
mess_19:        db      21, 'Breakpoint to value :',0;
mess_20:        db      'Breakpoint to interrupt :',0
mess_21:        db      'Interrupt function :',0
mess_22:        db      'Breakpoint to port :',0
mess_23:        db      'Enter Seg:Offs of dump :',0
mess_24:        db      'Enter length of dump :',0
mess_25:        db      'Enter name of dump file :',0
mess_26:        db      37,'Can',39,'t save file -- DOS already in use',0 ;is busy',0
mess_27:        db      'Enter Seg:Offs in memory :',0
mess_29:        db      'Enter name file :',0
mess_30:        db      'Enter interrupt number:',0

;-----------------------------------------------;
f1_cpu: db      "Esc      - user screen",0
        db      "F2       - set breakpoint",0
        db      "Alt+F2   - set conditional breakpoint",0
        db      "Shift+F2 - view condition",0
        db      "F4       - run to current command",0
        db      "F7       - trace into",0
        db      "F8       - step over",0
        db      "F10      - run until ret (retf)",0
        db      "Alt+1,2,3- go to breakpoints",0
        db      "Alt+J    - replace with unconditional jump",0
        db      "Alt+K    - kill current instruction (NOP)",0
        db      "Alt+I    - set breakpoint to Interrupt",0
        db      "Alt+P    - set breakpoint to Port (in/out)",0
        db      "Ctrl+F2  - reload program",0
        db      "Ctrl+F4  - calculator",0
        db      "Ctrl+B   - go to address in stack top",0
        db      "Ctrl+G   - go to address",0
        db      "Ctrl+I   - go to Interrupt",0
        db      "Ctrl+N   - set new CS:IP",0
        db      "Ctrl+O   - go to origin CS:IP",0
        db      "Ctrl+V   - view hooked vectors",0
        db      "Ctrl+C   - clean user screen",0
        db      "Ctrl+S     - search",0
        db      "Ctrl+Enter - continue search",0
        db      "Alt+X    - exit to DOS",0


f1_dump:
        db      "Ctrl+Left  - scroll left",0
        db      "Ctrl+Right - scroll right",0
        db      "Enter      - switch HEX/ASCII",0
        db      "F2         - set breakpoint",0
        db      "Alt+F2     - set breakpoint by value",0
        db      "Shift+F2   - view value",0
        db      "F5         - zoom",0
        db      "Ctrl+G     - go to address",0
        db      "Ctrl+I     - go to Interrupt",0
        db      "Ctrl+S     - search",0
        db      "Ctrl+Enter - continue search",0
        db      "Alt+1,2,3  - go to breakpoints",0
        db      "Alt+S      - save dump of memory to file",0
        db      "Alt+L      - load dump from file to memory",0


f1_regs:db      "Ctrl+R - 32 bits registers ON/OFF",0
        db      "Ctrl+Z - zero curent register",0
        db      "Ctrl+I - increment curent register",0
        db      "Ctrl+D - decrement curent register",0

f1_stack:db     "Ctrl+G - go to address",0
         db     "Ctrl+N - set new SS:SP",0
         db     "Ctrl+O - go to origin SS:SP",0

f1_flags:db     "Enter,Space - invert current flag",0

f1_watch:db     "Ctrl+T - toggle wide text mode",0

f1_bp:   db      "Ctrl+G - go to address",0
         db      "Ctrl+O - go to origin SS:BP",0

f1_end: db      "DeGlucker.Version ",Ver," by CrazyMaX,",Date,0

;-----------------------------------------------;

KEYS_cpu:                                       ;
        dw      cpu_up,         _Up             ;
        dw      cpu_down,       _Down           ;
        dw      cpu_pgup,       _PgUp           ;
        dw      cpu_pgdn,       _PgDn           ;
        dw      cpu_to_stack,   _Ctrl or 'B'    ;
        dw      cpu_goto,       _Ctrl or 'G'    ;
        dw      cpu_origin,     _Ctrl or 'O'    ;
        dw      cpu_new,        _Ctrl or 'N'    ;
        dw      cpu_follow,     _Ctrl or 'F'    ;
        dw      cpu_prev,       _Ctrl or 'P'    ;
        dw      cpu_search,     _Ctrl or 'S'    ;
;        dw      cpu_cont_s,     _Ctrl or 'L'    ;------------=======--------
        dw      cpu_cont_s,     _Ctrl or _Enter ;
        dw      cpu_to_int,     _Ctrl or 'I'    ;
        dw      cpu_break,      _Alt or '1'     ;
        dw      cpu_break,      _Alt or '2'     ;
        dw      cpu_break,      _Alt or '3'     ;
        dw      cpu_kill,       _Alt or 'K'     ;
        dw      cpu_jmp,        _Alt or 'J'     ;
        dw      cpu_int,        _Alt or 'I'     ;  
        dw      cpu_port,       _Alt or 'P'     ;   /뢮
        dw      cpu_gen_int,    _Alt or 'G'     ; INT
        dw      cpu_f2,         _F2             ;
        dw      cpu_f2,         _Alt or _F2     ;
        dw      cpu_sf2,        _Shift or _F2   ;
        dw      cpu_f4,         _F4             ;
        dw      cpu_f7,         _F7             ;
        dw      cpu_alt_f7,     _Alt or _F7     ;
        dw      cpu_f8,         _F8             ;
        dw      cpu_f1,         _F1             ;
        dw      0                               ;
KEYS_dump:                                      ;
        dw      dump_up,        _Up             ;
        dw      dump_down,      _Down           ;
        dw      dump_left,      _Left           ;
        dw      dump_right,     _Right          ;
        dw      dump_home,      _Home           ;
        dw      dump_enter,     _Enter          ;
        dw      dump_C_left,    _Ctrl or _Left  ;
        dw      dump_C_right,   _Ctrl or _Right ;
        dw      dump_pgup,      _PgUp           ;
        dw      dump_pgdn,      _PgDn           ;
        dw      dump_goto,      _Ctrl or 'G'    ;
        dw      dump_search,    _Ctrl or 'S'    ;
        dw      dump_cont_s,    _Ctrl or _Enter ;
        dw      dump_cont_s,    _Ctrl or 'L'    ;
        dw      dump_to_int,    _Ctrl or 'I'    ;
        dw      dump_break,     _Alt or '1'     ;
        dw      dump_break,     _Alt or '2'     ;
        dw      dump_break,     _Alt or '3'     ;
        dw      dump_f2,        _F2             ;
        dw      dump_f2,        _Alt or _F2     ;
        dw      dump_sf2,       _Shift or _F2   ;
        dw      dump_f5,        _F5             ;
        dw      dump_f1,        _F1             ;
        dw      dump_save,      _Alt or 'S'     ;
        dw      dump_load,      _Alt or 'L'     ;
        dw      0                               ;
KEYS_regs:                                      ;
;        dw      regs_ctrl_R,    _Ctrl or 'R'    ;
        dw      regs_f1,        _F1             ;
        dw      regs_up,        _Up             ;
        dw      regs_down,      _Down           ;
        dw      regs_left,      _Left           ;
        dw      regs_right,     _Right          ;
        dw      regs_zero,      _Ctrl or 'Z'    ;
        dw      regs_inc,       _Ctrl or 'I'    ;
        dw      regs_dec,       _Ctrl or 'D'    ;
        dw      0                               ;
KEYS_stack:                                     ;
        dw      stack_f1,       _F1             ;
        dw      stack_up,       _Up             ;
        dw      stack_down,     _Down           ;
        dw      stack_pgup,     _PgUp           ;
        dw      stack_pgdn,     _PgDn           ;
        dw      stack_goto,     _Ctrl or 'G'    ;
        dw      stack_origin,   _Ctrl or 'O'    ;
        dw      stack_new,      _Ctrl or 'N'    ;
        dw      0                               ;
KEYS_flags:                                     ;
        dw      flags_toggle,   ' '             ;
        dw      flags_toggle,   _Enter          ;
        dw      flags_f1,       _F1             ;
        dw      flags_up,       _Up             ;
        dw      flags_down,     _Down           ;
        dw      0                               ;
KEYS_bp:                                        ;
        dw      bp_f1,          _F1             ;
        dw      bp_up,          _Up             ;
        dw      bp_down,        _Down           ;
        dw      bp_pgup,        _PgUp           ;
        dw      bp_pgdn,        _PgDn           ;
        dw      bp_origin,      _Ctrl or 'O'    ;
        dw      bp_goto,        _Ctrl or 'G'    ;
        dw      0                               ;
KEYS_watch:                                     ;
        dw      watch_f1,       _F1             ;
        dw      watch_up,       _Up             ;
        dw      watch_down,     _Down           ;
        dw      watch_text,     _Ctrl or 'T';
        dw      0                               ;
;-----------------------------------------------;
watches         db      'ds:si              ',0
                db      'es:di              ',0
                db      'ds:dx              ',0
                db      'es:bx              ',0
n_search        dw      0               ;⢮ ᨬ
search_bytes    db      40 dup(0)       ; ᮡ᭮ 饬
buffer:         db      200 dup(0)      ;஬ p
video_mode      db      71h dup(0)      ;
video_data      db      90*30*2 dup(0)  ;
video_mode_03:                          ;
        include "tbl03.inc"             ;
;---------------------------------------;
DEBUG:                                  ;
;       push    es                      ;
;       push    ax                      ;
;       push    di                      ;
;       push    sVideo                  ;
;       pop     es                      ;
;       xor     di, di                  ;
;       call    PrintHex16              ;
;       call    getkey                  ;
;       xor     di, di                  ;
;       mov     [ byte es:di ], '-'     ;
;       mov     [ byte es:di+2 ], '-'   ;
;       mov     [ byte es:di+4 ], '-'   ;
;       mov     [ byte es:di+6 ], '-'   ;
;       pop     di                      ;
;       pop     ax                      ;
;       pop     es                      ;
        ret                             ;
;---------------------------------------;
ends
        end
