;***************************************************************
;* Protected Mode Kernel                                       *
;* Programmed by ALI                                           *
;* Version 0.12                        Last revision: 9-Sep-93 *
;***************************************************************

;---------------------------- History --------------------------
; Ver  Data         Who       Description
; 0.1  ??-Feb-93    AlI       Initial release
; 0.11 03-Sep-93    ALI       Memory Block Transfer added.
; 0.12 09-Sep-93    ALI       Non-standard text video mode support
;                             was added.
; 0.13 15-Dec-93    ALI       Dump of TSS was added. Fixed BX
;                             clobbering in the function ScrollScr.
;------------------------------------------------------------
;                    /
; 0.15 14--96  CrazyMaX       F1, 㢥祭 ᪮
;                             ࠡ, ࠢ     .
;                              ⠭ 猪  뢠.
; 0.16 22.04.97   CrazyMaX    㥢  ᥣ 䨪ᥭ.   

Ideal                                   ;
NOSMART                                 ;
P386                                    ;

include "defines.inc"                   ;


;==================== General Stack Layout =====================

global  Int_N2          : byte          ; 뢠
global  Int_N           : byte          ; 뢠
global  Int_F           : word          ; 㭪
global  Int_P           : byte          ;䫠 
global  Int_PP          : byte          ;䫠 
global  Dos_flag        : dword         ;䫠 
global  v86             : proc
global  bpice_flag      : byte
global  kbd_hrd         : proc          ;⪠  ࠡ. 
global  emul_6          : proc          ;⪠  ࠡ. 
;global  trace           : byte
;global  tr_s            : byte

extrn   dos_in          : proc
extrn   dos_fl          : word
extrn   dos_adr         : dword
extrn   p_ret           : byte
extrn   p_ret_of        : word
extrn   dos_buf         : near
extrn   buffer          : near
extrn   tab_ch1         : near
extrn   DisAsm          : proc

_EDI    equ     bp-32                   ; dword
_ESI    equ     bp-28                   ; dword
_EBP    equ     bp-24                   ; dword
_EBX    equ     bp-16                   ; dword
_EDX    equ     bp-12                   ; dword
_ECX    equ     bp-08                   ; dword
_EAX    equ     bp-04                   ; dword
_AL     equ     _EAX                    ; byte
_AH     equ     (_EAX+1)                ; byte !!! TASM need these parentheses
                                        ; to correctly expand this equate
_ERCODE equ     bp+02                   ; dword
_VECT   equ     bp+04                   ; word
_MSG    equ     _VECT                   ; word
_EIP    equ     bp+06                   ; dword
_CS     equ     bp+10                   ; dword
_EFLAGS equ     bp+14                   ; dword
_ESP    equ     bp+18                   ; dword
_SS     equ     bp+22                   ; dword
_ES     equ     bp+26                   ; dword
_DS     equ     bp+30                   ; dword
_FS     equ     bp+34                   ; dword
_GS     equ     bp+38                   ; dword

        segment conv word public use32 at 0
        ends

        segment code word public use16 'CODE'
        assume  cs:code,ds:code

Int_N2          db      0
Int_N           db      0ffh            ;o 뢠  猪
Int_F           dw      0ffffh          ; 㭪樨  ⮬ 뢠
Int_P           db      0               ;᫨ = 1,   ॠ஢
Int_PP_f        dw      0               ; ࠭ 䫠
Int_port        dw      0               ; 
Int_data        db      0               ; 祭 ᪨  
                                        ;( ᪫祭 ୮ ࠡ뢠)
cr              dd      8*3   dup(0)    ;   CRx,DRx, TRx ॣ-஢.
TF_flag         db      0               ;䫠 ⫠, ⮡   譨 int 1 ᫥ popf
Dos_flag        dd      0
bpice_flag      db      0               ;䫠  ४⭮ ࠡ⪨ BPICE
Int_PP          db      0               ;筮 ।饬,   ⮢
Ont_PPP         db      0               ;䫠, 뢠騩,  뢠 
                                        ; 瘟  樨 in/out

trace   db      0                       ; Bit 0 is our TF
                                        ; Bit 1 is PopUp Enable bit
;tr_s    db      0
exctxt  db      4,"EXCEPTION #",0       ;

dmpEAX  db      2,"---------------------------------------------------"
        db      0Dh,0Ah,"EAX ",0        ;
dmpEBX  db      2," EBX ",0             ;
dmpECX  db      2," ECX ",0             ;
dmpEDX  db      2," EDX ",0             ;
dmpEBP  db      2,0Dh,0Ah,"EBP ",0      ;
dmpESI  db      2," ESI ",0             ;
dmpEDI  db      2," EDI ",0             ;
dmpESP  db      2," ESP ",0             ;
dmpCS   db      2,0Dh,0Ah,"CS ",0       ;
dmpDS   db      2,"  DS ",0             ;
dmpES   db      2,"  ES ",0             ;
dmpSS   db      2,"  SS ",0             ;
dmpIP   db      2,0Dh,0Ah,"IP ",0       ;
dmpFS   db      2," FS ",0              ;
dmpGS   db      2,"  GS ",0             ;
dmpEIP  db      2,0Dh,0Ah,"EIP ",0      ;
dmpEFlgs db     2,"   EFlags ",0        ;
dmpCR0  db      2," CR0 ",0             ;
dmpStack db     2,"Stack contents: ",0  ;
dmpTask db      2,"Task's stack  : ",0  ;
;---------------------------------------;
;tssSSP0 db      2,10,13,"SS0:ESP0 ",0   ;
;tssSSP1 db      2,10,13,"SS1:ESP1 ",0   ;
;tssSSP2 db      2,10,13,"SS2:ESP2 ",0   ;
;tssSSSP db      2,10,13," SS:ESP  ",0   ;
;tssCSIP db      2,10,13," CS:EIP  ",0   ;
;tssDS   db      2,"  DS ",0             ;
;tssES   db      2,"  ES ",0             ;
;tssFS   db      2,"  FS ",0             ;
;tssGS   db      2,"  GS ",0             ;
;tssEAX  db      2,"  EAX ",0            ;
;tssEBX  db      2,"  EBX ",0            ;
;tssECX  db      2,"  ECX ",0            ;
;tssEDX  db      2,"  EDX ",0            ;
;tssESI  db      2,"  ESI ",0            ;
;tssEDI  db      2,"  EDI ",0            ;
;tssEBP  db      2,"  EBP ",0            ;
;tssESP  db      2,"  ESP ",0            ;
;tssCR3  db      2,"  CR3 ",0            ;
;tssLDT  db      3," LDT ",0             ;
;tssEFL  db      2,"        EFLAGS ",0   ;
;tssIO   db      3,"                    ";
;        db      "I/O Map Base ",0       ;
;tssLink db      2,"--------------------";
;        db      "----------------------";
;        db      "-----------------"     ;
;        db      10,13,"Back Ref ",0     ;

CUR_COL db      0                       ;
CUR_ROW db      0                       ;
MAX_COL db      0                       ;
MAX_ROW db      0                       ;

;***************************************************************
;*                    Interrupt Handlers                       *
;***************************************************************

;++
; Entry points of hardware interrupt vectors (70h-7Fh)
; Each handler pushes onto stack software vector and calls
; interrupt emulator. Then the handler enables appropriate
; interrupt controller and returns to caller.
;--

IRQ2:
        push    0Ah                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ3:
        push    0Bh                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ4:
        push    0Ch                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ5:
        push    0Dh                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ6:
        push    0Eh                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ7:
        push    0Fh                     ; Push vector
        call    INTn                    ;
        call    MasterEOT               ;
        iretd                           ;

IRQ8:
        push    70h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ9:
        push    71h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ10:
        push    72h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ11:
        push    73h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ12:
        push    74h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ13:
        push    75h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ14:
        push    76h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

IRQ15:
        push    77h                     ; Push vector
        call    INTn                    ;
        call    SlaveEOT                ;
        iretd                           ;

;++
; Send EOT signal to Master PIC
;--
        proc    MasterEOT
        push    ax                      ;
        mov     al,20h                  ;
        out     020h,al                 ;
        pop     ax                      ;
        ret                             ;
        endp

;++
; Send EOT signal to Slave PIC
;--
        proc    SlaveEOT
        push    ax                      ;
        mov     al,20h                  ;
        out     0A0h,al                 ;
        pop     ax                      ;
        ret                             ;
        endp

;++
; Interrupt emulator
; Stack layout:
;       [BP]    BP
;       [BP+2]  RET ADDR  -- call  INTn
;       [BP+4]  _VECT        push  
;       [BP+6]  _EIP      --  
;       [BP+10] _CS
;       [BP+14] _EFLAGS
;       [BP+18] _ESP
;       [BP+22] _SS
;--
        proc    INTn                    ;

        push    bp                      ;
        mov     bp,sp                   ;
        test    [byte bp+16],2          ; Test VM flag
        jnz     v86                     ;

@@nv86:
        pop     bp                      ;
        ret     2                       ; Pop vector

v86:    pushad                          ;
        mov     ax,sConv                ;
        mov     ds,ax                   ; Load 4Gb selector
Int13n:                                 ; External entry point from Exc13
        movzx   esi,[word _SS]          ; ESI = SS<<4 + SP
        shl     esi,4                   ;
        movzx   eax,[word _ESP]         ;
        sub     ax,6                    ; Push Flags, IP and CS
        mov     [_ESP],ax               ;
        add     esi,eax                 ; Convert SS:SP to linear address

        mov     ax,[_EIP]               ; Push CS:IP onto task's stack
        mov     [esi],ax                ;
        mov     ax,[_CS]                ;
        mov     [esi+2],ax              ;
        mov     ax,[_EFLAGS]            ; Get Flags
        and     ah,0CCh                 ; Clear IOPL,IF,TF
        mov     ch,[byte ss:(TSSv86._eflags)+1]
        and     ch,033h                 ; Mask all bits except IOPL,IF,TF
        or      ah,ch                   ; Set IOPL,IF,TF as their twins in TSS
        mov     [esi+4],ax              ; Push flags

        and     ah,0FCh                 ; Clear IF,TF
        mov     [byte ss:(TSSv86._eflags)+1],ah

        movzx   bx,[byte _VECT]         ; Get vector number
        shl     bx,2                    ;

        and     [byte _EFLAGS+1],0FCh   ; Clear IF,TF
        test    [byte ss:trace],1       ;
        jz      @@10                    ;
        or      [byte _EFLAGS+1],1      ; Set TF
@@10:   mov     ax,[bx+2]               ; Set interrupt vector as our
        mov     [_CS],ax                ; return address
        mov     ax,[bx]                 ;
        mov     [_EIP],ax               ;
Ret13:                                  ; External entry point from Exc13
        and     [byte _EFLAGS+2],0FEh   ; Clear RF
        test    [byte _EFLAGS+1],1      ; Test TF
        popad                           ; Clear stack
        pop     bp                      ;
        jz      @Ret13                  ; We have not to emulate
        add     sp,4                    ;
        jmp     Exc1                    ; Transfer control to Exc1 handler

@Ret13: add     sp,4                    ;
        iretd                           ;
        endp                            ;

;++--------------------------------------------------------------------------
; Entry points of proccessor exception handlers.
;--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Exc0:   push    0                       ;   
        call    INTn                    ;
        iretd                           ;

;        jmp     ExcNN

;++
; Breakpoint monitor
;--

Exc1:
        push    bp                      ;
        push    bp                      ;
        mov     bp,sp                   ;
        test    [byte bp+14],2          ; Test VM
        jnz     @@00                    ; If it isn't V86 ignore this exc.
        or      [byte bp+14],1          ; Set RF
        pop     bp                      ;
        pop     bp                      ;
        iretd                           ;

@@00:   push    eax                     ;
        cmp     [ss:bpice_flag],1       ; Check BPICE flag
        je      @@bp_check              ; Emulate

        test    [byte ss:trace],1       ; Is it our TF?
        jnz     @@00n                   ;

        mov     eax,dr6                 ; It's hardware BP ?
        and     al,01111b
        jnz     @@00n
        push    ds esi ebx
        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector
        movzx   esi,[word _CS-2]        ; Get CS of V86
        shl     esi,4
        movzx   ebx,[word _EIP-2]       ; Get IP
        add     esi,ebx                 ;
        dec     esi
        lods    [byte esi]              ; Fetch instruction
        pop     ebx esi ds
        cmp     al,0f1h                 ; BPICE instruction ?
        jne     @@00n

@@bp_check:
        mov     [ss:bpice_flag],0       ; Remove flag
        pop     eax
        pop     bp
        pop     bp
        push    1
        call    INTn                    ; 㫨 Int 1
        iretd

@@00n1: mov     [ss:bpice_flag],0       ; Remove flag
@@00n:  mov     eax,dr6                 ;
        and     ax,0E00Fh               ; No flags
        jz      @@s                     ;
        test    ah,40h                  ; Step
        jnz     @@sclr                  ;
        test    ah,20h                  ; Next command uses DR0-3?
        jz      @@brk                   ;
        mov     [word bp],200h          ; Privileged instruction
        jmp     @@05                  ;
;-------ࠡ⪠ ⭮ 猪
@@brk:  bsf     ax,ax                   ; Calculate breakpoint number

;--⠭ ᪨ bpio
        cmp     [byte ss:Int_PP],1
        jne     @@0a

        push    bx
        mov     [byte ss:Int_PP],0         ;ᨫ 䫠
        xor     eax,eax
        call    DisableBreak            ;ࠫ   䫠 in/out
        mov     dr6,eax
        mov     bx,[word cs:Int_port]      ;⠭  
        mov     al,[byte cs:Int_data]      ; 祭 ᪨  
        mov     [byte ss:bx+2+TSSv86.iomap],al
        test    [ss:trace],1
        pop     bx eax bp bp
        jnz     Exc1e
@@b:    iretd                           ;  ணࠬ
;------- ஢ઠ  F10 (p ret)
@@0a:   cmp     [byte ss:p_ret],1
        jne     @@0b
        or      ax,ax
        jne     @@0b                    ;த ᯫ뫨    ⥪ (F10)

        push    ax
        mov     ax,[ss:p_ret_of]
        cmp     [word _EIP-2],ax        ; .  ⥪ == IP ?
        jne     @@next_val
@@n_i:  mov     [byte ss:p_ret],0
        pop     ax
        jmp     @@0b

@@next_val:
        push    ds edx ebx
        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector
@@nne:  movzx   edx,[word _SS-2]
        movzx   ebx,[word _ESP-2]
        xor     ax,ax
        call    DisableBreak
        mov     ax,300h
        call    SetBreak
        shl     edx,4
        add     ebx,edx                 ;
        mov     ax, [ds: ebx]           ; Fetch word on stack top
        mov     [ss:p_ret_of],ax
        pop     ax eax bp bp
        iretd

@@0b:   mov     [bp+2],ax               ;
@@05:   xor     eax,eax                 ; Clear status
        mov     dr6,eax                 ;
        pop     eax                     ;
        pop     bp                      ;
        jmp short Exc1m
;-----------蠣 ᯮ
@@sclr: xor     eax,eax                 ; Clear status
        mov     dr6,eax                 ;
@@s:    pop     eax                     ;
        pop     bp                      ;
        pop     bp                      ;
        test    [byte ss:(TSSv86._eflags)+1],1; Is it tasks TF?
        jz      @@20                    ; No - jump to our handler
        cmp     [ss:TF_flag],1
        jne     @@09
        and     [byte ss:(TSSv86._eflags)+1],0feh ; ⨫ TF
        mov     [ss:TF_flag],0
@@09:   push    1                       ; Vector 1
        call    INTn                    ; Call v86 1st vector handler
@@10:   push    1                       ; Thing that should not be!
        jmp     ExcNN                   ; Panic dump
@@20:   test    [byte ss:trace],1       ; Is it our TF?
        jz      @@10                    ; No - Another bug in our debug

Exc1e:  push    0h                      ;
Exc1m:  call    Master                  ; Call Master
        iretd                           ;

Exc2:   push    2
        jmp     ExcNN

Exc3:   push    3
        jmp     ExcNN

Exc4:   push    4
        jmp     ExcNN

Exc5:   push    5                       ; bound -- 室  ࠭ ᨢ
        call    INTn                    ;  । ࠢ
        iretd                           ; ࠡ稪 5' 뢠...

;        push    5
;        jmp     ExcNN

Exc6:
        push    bp                      ;
        mov     bp,sp                   ;
        sub     bp,4
        push    ds
        pushad
        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector

        movzx   esi,[word _CS]          ; Get CS of V86
        shl     esi,4
        movzx   ebx,[word _EIP]         ; Get IP
        add     esi,ebx                 ;

        cld                             ; Just to be sure
@@p_1:  lods    [byte esi]              ; Fetch instruction

        cmp     al,0f0h                 ; LOCK
        je      @@ttt
        cmp     al,26h                  ;es
        je    @@p_y
        cmp     al,2eh                  ;cs
        je    @@p_y
        cmp     al,36h                  ;ss
        je    @@p_y
        cmp     al,3eh                  ;ds
        je    @@p_y
        cmp     al,64h                  ;fs
        je    @@p_y
        cmp     al,65h                  ;gs:
        je    @@p_y
        cmp     al,0f2h                 ;repne
        je    @@p_y
        cmp     al,0f3h                 ;rep
        jne    @@ppp
@@p_y:  inc     [word _EIP]             ; Inc IP
        jmp     @@p_1

@@ttt:  inc     [word _EIP]             ; Inc IP

@@ttt1: popad
        pop     ds
        pop     bp
        iretd

@@ppp:
        popad
        pop     ds
        pop     bp
emul_6: jmp  short @@ppp1
        push    6                       ;   
        call    INTn                    ;
        iretd                           ;

@@ppp1: push    6
        jmp     ExcNN

Exc7:   push    ax
        smsw    ax
        test    ax,8                    ; Test Task-switched bit
        pop     ax
        jz      @@10
        clts
        iretd
@@10:   push    7
        call    INTn
        push    7
        jmp     ExcNN

Exc8:   push    8
        jmp     ExcNN

Exc9:   push    9
        jmp     ExcNN

Exc10:  push    10
        jmp     ExcNN

Exc11:  push    11
        jmp     ExcNN

Exc12:  push    12
        jmp     ExcNN

Exc14:  push    14
        jmp     ExcNN

Exc15:  push    15
        jmp     ExcNN

Exc16:  push    16
        jmp     ExcNN

Exc17_31:                               ; Reserved exceptions
        push    01731h                  ;
        jmp     ExcNN                   ;

;++
; Unexpected exceptions handler
;--

ExcNN:
        push    bp                      ;
        mov     bp,sp                   ;
        sub     bp,2
        push    ax                      ;
        push    si                      ;
        push    ds                      ;

        mov     ax,sData                ;
        mov     ds,ax                   ;
        lea     si,[exctxt]             ;
        call    PrintStr                ;
        mov     ax,[bp+4]               ;
        call    PrintAX                 ;
        call    NewLine                 ;
        pop     ds                      ;
        pop     si                      ;
        pop     ax                      ;
;        call    DumpStack              ;
        call    DumpTaskStack           ;
        call    Dump386Regs             ;
        pop     bp                      ;
        add     sp,2                    ;
        jmp     ReturnDOS               ;

;++
; General Protection Fault Handler
;--

Exc13:  cmp     sp,0FFD6h               ; From V86 with error code
        je      @@EC                    ;

        push    bp                      ;
        mov     bp,sp                   ;
        test    [byte bp+12],2          ; Test VM flag
@@Dump: pop     bp                      ;
        jnz     @@noEC                  ;
        push    13                      ;
        jmp     ExcNN                   ;
@@noEC: push    0ffffh                  ;
        push    0ffffh                  ; Push error code
@@EC:   push    bp                      ;
        mov     bp,sp                   ;
        test    [byte _EFLAGS+2],2      ; Test VM bit
        jz      @@Dump

        pushad
        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector

        movzx   esi,[word _CS]          ; Get CS of V86
        shl     esi,4
        movzx   ebx,[word _EIP]         ; Get IP
        add     esi,ebx                 ;

        inc     [word _EIP]             ; Inc IP
        cld                             ; Just to be sure
        lods    [byte esi]              ; Fetch instruction
        cmp     al,0F4h                 ; Is it HLT?
        je      @Hlt                    ;
        cmp     al,0FAh                 ; Is it CLI?
        je      @Cli                    ;
        cmp     al,0FBh                 ; Is it STI?
        je      @Sti                    ;
        movzx   edi,[word _SS]          ; edi = SS<<4
        shl     edi,4                   ;
        movzx   edx,[word _ESP]         ; edx = SP
        cmp     al,66h                  ; Is it 32-bit instruction
        jne     @@10 ;------------------; Jump if it isn't
        inc     [word _EIP]
        lods    [byte esi]              ; Fetch the second byte
        cmp     al,9Ch                  ; Is it PUSHFD?
        je      @Pushfd                 ;
        mov     esi,edi                 ; esi = SS<<4 + SP
        add     esi,edx                 ;
        cmp     al,9Dh                  ; Is it POPFD?
        je      @Popfd                  ;
        cmp     al,0CFh                 ; IRETD?
        je      @Iretd                  ;
        sub     [word _EIP],2           ; IP to the beginning of instruction
        jmp       @@Err                 ; It is a privileged instruction

@@10:                                   ;
        cmp     al,26h                  ;es
        je    @@p_y                     ; es: pushf
        cmp     al,2eh                  ;cs
        je    @@p_y
        cmp     al,36h                  ;ss
        je    @@p_y
        cmp     al,3eh                  ;ds
        je    @@p_y
        cmp     al,64h                  ;fs
        je    @@p_y
        cmp     al,65h                  ;gs:
        je    @@p_y
        cmp     al,0f2h                 ;repne
        je    @@p_y
        cmp     al,0f3h                 ;rep
        jne    @@p_n
@@p_y:
        inc     [word _EIP]             ; Inc IP
        lods    [byte esi]              ; Fetch instruction
        cmp     al,0F4h                 ; Is it HLT?
        je      @Hlt                    ;
        cmp     al,0FAh                 ; Is it CLI?
        je      @Cli                    ;
        cmp     al,0FBh                 ; Is it STI?
        je      @Sti                    ;
        jmp     @@10
@@p_n:  cmp     al,0Fh                  ; 䨪 0Fh
        jne     @@p_n2
        inc     [word _EIP]             ; Inc IP
        lods    [byte esi]              ; Fetch instruction
        cmp     al,20h
        jb      @@Err
        cmp     al,24h
        jbe     @@p_xRx
        cmp     al,26h
        jne     @@Err
@@p_xRx:jmp     @xRx                    ; ࠡ⪠ ॣ-஢ DRx,TRx,CRx

@@p_n2: cmp     al,9Ch                  ; Is it PUSHF?
        je      @Pushf                  ;
        cmp     al,0CCh                 ; Int 3?
        je      @Int3                   ;
        cmp     al,0CEh                 ; INTO?
        je      @INTO                   ;
;----------                             ;஢   in/out
@@p_p:  cmp     al,0e4h                 ;in al,nn
        jb      @@p_p1
        cmp     al,0e7h                 ;out nn,ax
        jbe     @in_out

@@p_p1: cmp     al,0ech                 ;in al,dx
        jb      @@p_pp
        cmp     al,0efh                 ;out dx,ax
        jbe     @in_out
;        jmp     @@p_p2

@@p_pp: cmp     al,06ch                 ;insb
        jb      @@p_p2
        cmp     al,06fh                 ;outsw
        jbe     @in_out

@@p_p2: cmp     al,0f2h                 ;repnz
        je      @@p_0
        cmp     al,0f3h                 ;rep
        jne     @@p_k
@@p_0:  lods    [byte esi]              ; Fetch instruction
        jmp     @@p_pp

;----------
@@p_k:  cmp     al,0CDh                 ; Is it INT instruction?
        je      @Int                    ;
        mov     esi,edi                 ; esi = SS<<4 + SP
        add     esi,edx                 ;
        cmp     al,9Dh                  ; Is it POPF?
        je      @Popf                   ;
        cmp     al,0CFh                 ; IRET?
        je      @Iret                   ;

@@Err:
        popad                           ; Restore stack
        pop     bp
        add     sp,4                    ; Pop Error Code
        push    200h                    ; privileged instruction
        call    Master
        iretd

; Halt

@Hlt:
        jmp     Ret13                   ;
; Disable interrupts

@Cli:
        cmp     [word esi],0fdebh
        jne     @@cl
        popad
        pop     bp
        add     sp,4

        push    0h                      ;
        call    Master                  ; Call Master
        iretd                           ;

@@cl:   and     [byte _EFLAGS+1],0FDh   ; Clear I flag
        and     [byte ss:(TSSv86._eflags)+1],0FDh;
        jmp     Ret13                   ;

; Enable interrupts

@Sti:
        or      [byte ss:(TSSv86._eflags)+1],2;
        test    [byte ss:trace],1       ;
        jnz     @@10                    ;
        or      [byte _EFLAGS+1],2      ; Set I flag
@@10:
        jmp     Ret13                   ;

; ࠡ⪠ ॣ-஢ DRx,TRx,CRx

@xRx:
        inc     [word _EIP]             ; Inc IP
        cmp     al,20h
        jne     @@x1
        mov     di,offset cr
        jmp     @@store

@@x1:   cmp     al,21h
        jne     @@x2
        mov     di,offset cr+8*4
        jmp     @@store

@@x2:   cmp     al,22h
        jne     @@x3
        mov     di,offset cr
        jmp     @@load

@@x3:   cmp     al,23h
        jne     @@x4
        mov     di,offset cr+8*4
        jmp     @@load

@@x4:   mov     di,offset cr+8*4*2
        cmp     al,24h
        jne     @@load
        jmp     @@store

@@load: call    @pr_adr                 ;᫨  
        mov     eax,[ss:_EAX+di]
;        mov     eax,[ss:(TSSv86._eax)+di]
        cmp     bx,offset cr+8*4+7*4
        jne     @@l1
        or      eax,0400h               ;⠭ 㦭  ()
@@l1:   mov     [ss:bx],eax             ;ᠫ  ᥡ 祭
        jmp     Ret13


@@store:call    @pr_adr
        mov     eax,[ss:bx]
        mov     [ss:_EAX+di],eax           ; ⠭ 祭
;        mov     [ss:(TSSv86._eax)+di],eax           ; ⠭ 祭
        jmp     Ret13

@pr_adr:lods    [byte esi]              ;   ॣ-   xDx
        mov     ah,0
        mov     bx,ax
        and     al,00111000b            ; xDx ॣ-
        shr     ax,1
        add     di,ax                   ;   
        and     bl,0111b
        shl     bx,2
        xchg    bx,di
        cmp     di,4*4
        jne     @@pr1                   ; esp
        mov     di,22
        ret
@@pr1:  cmp     di,5*4
        jne     @@pr2                   ; ebp
        sub     di,2
@@pr2:  neg     di
        ret

; Push flags

@Pushf:
        dec     dx                      ; Shift SP
        dec     dx                      ; Shift SP
        mov     [_ESP],dx               ;

        mov     ax,[_EFLAGS]            ; Get Flags
        and     ah,0CCh                 ; Set TF, IF and IOPL bits as
        mov     ch,[byte ss:(TSSv86._eflags)+1]; if it is task's flags
        and     ch,033h                 ;
        or      ah,ch                   ;
        mov     [edi+edx],ax            ; Push flags
        jmp     Ret13                   ;

; Push Eflags

@Pushfd:
        sub     dx,4                    ; Shift SP
        mov     [_ESP],dx               ;

        mov     eax,[_EFLAGS]           ; Get Flags
        and     ah,0CCh                 ; It is the same as PUSHF
        mov     ch,[byte ss:(TSSv86._eflags)+1];
        and     ch,033h                 ;
        or      ah,ch                   ;
        mov     [edi+edx],eax           ; Push eflags
        jmp     Ret13                   ;

; Emulate INT 3

@Int3:  cmp     [cs:Int_N],3            ;஢ -- - 猪  INT3
        jne     @@i1
        inc     [word _EIP]             ; Grow IP
        mov     ax,3
        jmp     check_int
@@i1:   mov     [word _VECT],3          ; Vector number
        jmp     Int13n                  ;

; Emulate INTO

@INTO:  cmp     [cs:Int_N],4            ;஢ -- - 猪  INT0
        jne     @@i2
        inc     [word _EIP]             ; Grow IP
        mov     ax,4
        jmp     check_int
@@i2:   mov     [word _VECT],4          ;
        jmp     Int13n                  ;


; ࠡ稪 in/out -- 뢠  13 ᪫祭,  ⠭
; 直   /뢮
@in_out:
        dec     [word _EIP]             ;    IN/out
        cmp     [cs:Int_PP],1           ;᫨ 䫠 = 1,   㦥 節  ⮬
        je      @@ch_m                  ;,  ய
        mov     [byte ss:Int_PP],1         ;⠭ 䫠  IN/out

        popad
        pop     bp
        add     sp,4

        push    0h                      ;
        call    Master                  ; Call Master
        iretd                           ;

;ࠡ稪 ୮ in/out

@@ch_m:
        movzx   esi,[word _CS]          ; Get CS of V86
        shl     esi,4
        movzx   ebx,[word _EIP]         ; Get IP
        add     esi,ebx                 ;

        cmp     al,0e4h                 ;in al,nn
        je     @@in_0
        cmp     al,0e5h                 ;in ax,nn
        je     @@in_0
        cmp     al,0e6h                 ;out nn,al
        je     @@in_0
        cmp     al,0e7h                 ;out nn,ax
        jne     @@in_1

@@in_0: mov     al,[byte esi+1]         ;  
        mov     ah,0
        jmp     @@in_2
@@in_1: mov     ax,[word _EDX]          ;  

@@in_2: mov     bx,ax
        shr     bx,3
        mov     dl,[byte ss:bx+2+TSSv86.iomap]
        mov     [byte ss:bx+2+TSSv86.iomap],0

        mov     eax,[ds:esi]            ;稫   (4 )

        push    ds es fs sData          ;㪠뢠  ᥫ ⮣ ᥣ
        pop     ds                      ;⮡  뫮  ஢
        push    ds
        pop     fs
        push    ds
        pop     es
        mov     [word Int_port],bx      ;  
        mov     [byte Int_data],dl      ; 祭 ᪨  
        mov     si,offset buffer+90
        mov     [dword si],eax
        mov     di,offset buffer
        push    si bp
        call    DisAsm                  ;맢 ᥬ, ⮡ 㧭
                                        ; ᫥. .
        pop     bp bx
        sub     si,bx
        mov     bx,[word _EIP]
        add     bx,si
        mov     dx,[word _CS]

        xor     ax,ax
        call    SetBreak

        pop     fs es ds


        mov     ax,[word ss:TSSv86._eflags]
        mov     [word ss:Int_PP_f],ax
        and     ah,0CFh                 ;
        or      ah,20h                  ;
        mov     [_EFLAGS],ax
;        mov     [ss:trace],1

        jmp     Ret13                   ;


; Emulate INT instruction

@Int:
        inc     [word _EIP]             ; Grow IP
        movzx   ax,[byte esi]           ; Get interrupt number
;------------------max

        cmp     al,0ffh
        jne     check_int
        cmp     [word _EAX],'CM'
        jne     check_int

        popad
        pop     bp
        add     sp,4

        call    pod_1                   ;⠭ -  TSS


        push    0
        push    bp bp
        mov     bp,sp
        push    eax

        mov     eax,[ss:TSSv86._esp]
        mov     [_ESP],eax
        mov     eax,[ss:TSSv86._eip]
        mov     [_EIP],eax

        call    pod_2                   ;⠭. ᥣ. -  TSS

        mov     ax,[ss:dos_fl]
        mov     [_EFLAGS],ax
        push    ds es
        pushad
        mov     ax,sData
        mov     ds,ax                    ;
        mov     ax,sConv                ;
        mov     es,ax                   ; Load 4Gb selector
        mov     si,offset dos_buf
        mov     edi,09fd50h            ;32    9f50:0
        mov     cx,100/4
@@y_i1: mov     eax,[si]              ;⠭  
        mov     [es:edi],eax
        add     si,4
        add     edi,4
        loop    @@y_i1
        mov     eax,[ss:dos_adr]
        mov     esi,4*21h
        xchg    eax,[es:esi]
        mov     [ss:dos_adr],eax
        popad
        pop     es ds

        pop     eax bp bp
        call    Master                  ; Call Master
        iretd                           ;
;ࠡ⪠  
;@@uu:   cmp     [cs:Int_N2],1           ;䫠=1  㦭 
;        jnz     @@ch_01
;        cmp     al,28h
;        jnz     @@ch_01
;
;;        push    ds sData                ;㪠뢠  ᥫ ⮣ ᥣ
;;        pop     ds                      ;⮡  뫮  ஢
;;        mov     [byte Int_N2],0         ;⠭ 䫠  INT nn
;;        pop     ds
;;        xor     ax,ax

;        push    ds es sData             ;㪠뢠  ᥫ ⮣ ᥣ
;        pop     ds                      ;⮡  뫮  ஢
;        pushad
;        mov     [byte Int_N2],0         ;ᨫ 䫠
;        xor     ax,ax
;        call    DisableBreak            ;ࠫ   䫠 In_Dos
;
;        call    dos_in                  ;࠭ 
;
;        popad
;        pop     es ds
;
;        dec     [word _EIP]             ;  ⮣, ⮡  㪠뢠
;        dec     [word _EIP]             ;    INT nn
;        popad
;        pop     bp
;        add     sp,4
;
;        push    0h                      ;
;        call    Master                  ; Call Master
;        iretd                           ;

check_int:
@@ch_01:cmp     [cs:Int_P],1            ;᫨ 䫠 = 1,   㦥 節  ⮬
        je      @@ch_m                  ;,  ய

        cmp     al,0ffh                 ;᫨ INT 0FFh,  ப뢠
        je      @@ch_m
        cmp     [cs:Int_N],al           ;஢ -- - 猪   INT
        jne     @@ch_m

        push    ax
        mov     ax,[word _EAX]          ;稫   㭪樨
        cmp     [byte ptr cs:Int_F],0ffh
        jz      @@ch_1
        cmp     [byte ptr cs:Int_F],al
        jne     @@ch_n
@@ch_1: cmp     [byte ptr cs:Int_F+1],0ffh
        je      @@ch_ok
        cmp     [byte ptr cs:Int_F+1],ah
        jne     @@ch_n
@@ch_ok:pop     ax


        mov     [byte ss:Int_P],1          ;⠭ 䫠  INT nn

        dec     [word _EIP]             ;  ⮣, ⮡  㪠뢠
        dec     [word _EIP]             ;    INT nn
        popad
        pop     bp
        add     sp,4

        push    0h                      ;
        call    Master                  ; Call Master
        iretd                           ;
;------------------

@@ch_n: pop     ax

@@ch_m:

        mov     [byte ss:Int_P],0          ;㫨 䫠  INT nn

        cmp     al,21h                  ; DOS Services?
        je      @@Int21                 ;
        cmp     al,15h                  ; AT Services?
        jne     @@Emul
        cmp     [byte _AH],87h          ; Request to move ext. memory block?
        je      @@Move
        cmp     [byte _AH],88h          ; cmp ah
        je      @@Size
        cmp     [byte _AH],89h          ; Request to enter protected mode?
        je      @@Prot                  ;
        cmp     [byte _AH],0FFh         ; Have we called?
        jne     @@Emul

; INT 15h Interface
; AH    - FFh
; AL    - function
;---------------------------------------
; Fn 00h   -    Get installed state
; Entry:
;       AX      = FF00h
; Return:
;       No Carry Flag
;---------------------------------------
; Fn 01h   -    Popup DeGluker
; Entry:
;       AX      = FF01h
;       BX      = PSP
;       DX:CX   = SS:SP
;       DI:SI   = CS:IP
; This function doesn't return to caller
;---------------------------------------
; Fn 02h   -    Uninstall
; Entry:
;       AX      = FF02h
; Return:
;       ???
;---------------------------------------
; Fn 03h   -    Signal termination of user task
; Entry:
;       AX      = FF03h
; This function doesn't return to caller
;
        cmp     [byte _AL],1            ; Set Trace Flag
        je      @@PopUp                 ;

        cmp     [byte _AL],0            ; Check for presence
        je      @@Ack

        cmp     [byte _AL],3
        je      @@Term

        cmp     [byte _AL],2            ; Remove from memory
        jne     @@RetEr

        mov     bx,[_EIP]               ; Get IP
        mov     dx,[_CS]                ; Get CS
        jmp     Uninstall               ; Uninstall will expect
                                        ; the return address in DX:BX
;---------------

@@PopUp:
        test    [byte _EFLAGS],1        ; Test CF???
        jnz     ReturnDOS               ;
        test    [byte ss:trace],2       ; Test PopUp Enable bit
        jz      @@10                    ;
        mov     [byte ss:trace],1       ;
        or      [byte _EFLAGS+1],1      ; Set TF
@@10:   mov     ax,[_EBX]               ; Get user's PSP
        mov     [_ES],ax                ;
        mov     [_DS],ax                ;
        push    ax
        mov     [word _EAX],0           ;+
        mov     [word _EBX],0           ;+
        mov     ax,[_ECX]               ; Get user's SP
        mov     [_ESP],ax               ;
        mov     [word _ECX],0ffh        ;+
        mov     ax,[_EDX]               ; Get user's SS
        mov     [_SS],ax                ;
        pop     ax
        mov     [_EDX],ax               ;+PSP
        mov     ax,[_ESI]               ; Get user's IP
        mov     [_EIP],ax               ;
        mov     [word _ESI],100h        ;+
        mov     ax,[_EDI]               ; Get user's CS
        mov     [_CS],ax                ;
        mov     [word _EDI],0fffeh      ;+
        mov     [word bp],091ch     ;+
        jmp     Ret13

@@Term: mov     ax,[_EBX]
        mov     ah,10h
        mov     [_VECT],ax
        popad
        pop     bp
        add     sp,2
        call    Master
        iretd

@@Ack:  and     [byte _EFLAGS],0FEh     ; Clear CF
        jmp     Ret13

@@Prot:
@@RetEr:
        mov     [byte _AH],0FFh         ;
        or      [byte _EFLAGS],1        ; Set Carry Flag
        jmp     Ret13

; Move extended memory block

@@Move: pushad
        push    es
        movzx   ebx,[word _ES]
        shl     ebx,4
        movzx   eax,[word _ESI]
        add     ebx,eax                 ;
        add     ebx,2 * SIZE desc       ;
        mov     ah,[(desc ebx).baseH]   ;
        mov     al,[(desc ebx).baseM]   ;
        mov     si,ax                   ;
        shl     esi,16                  ;
        mov     si,[(desc ebx).baseL]   ;
        add     ebx,SIZE desc           ;
        mov     ah,[(desc ebx).baseH]   ;
        mov     al,[(desc ebx).baseM]   ;
        mov     di,ax                   ;
        shl     edi,16                  ;
        mov     di,[(desc ebx).baseL]   ;
        movzx   ecx,[word _ECX]         ;
        shr     ecx,1
        mov     ax,ds
        mov     es,ax
;       call    Dump386Regs
        cld                             ; Just to be sure

        rep     movs [dword edi],[esi]  ;
;       db      67h
;       nop
        rcl     cx,1
        rep     movs [word edi],[esi]   ; Odd word

;       mov     [byte _AH],2            ; Exception occured
;       or      [byte _EFLAGS],1        ; Set Carry Flag
        mov     [byte _AH],0            ; Operation successful
        or      [byte _EFLAGS],40h      ; Set Zero Flag
        and     [byte _EFLAGS],0FEh     ; Clear Carry Flag
        pop     es
        popad
        jmp     Ret13

; Tell extended memory size

@@Size: mov     ax,[cs:extsize]         ;
        mov     [_EAX],ax               ; Return size of extended memory
        jmp     Ret13

; Call v86 handler

@@Emul: mov     [_VECT],ax              ;
;       call    PrintAX
;       call    NewLine
        jmp     Int13n                  ;

; Execution Intercept

@@Int21:
        cmp     [word _EAX],4B00h       ;
        jne     @@Emul                  ;
        mov     ax,sPSP93               ;
        mov     es,ax                   ;
        movzx   esi,[word _ES]          ; Get ES
        shl     esi,4                   ;
        movzx   edi,[word _EBX]         ; Get BX
        add     esi,edi                 ;
        lea     di,[child]              ;
        mov     [_EBX],di               ; Set BX
        mov     ax,[ss:realCS]          ;
        mov     [_ES],ax                ; Set ES
        mov     cx,7                    ;
        rep     movs [word edi],[esi]   ; Copy task's EPB
        mov     di,[es:level]           ;
        mov     ax,[_CS]                ; Get CS
        shl     eax,16                  ;
        mov     ax,[_EIP]               ; Get IP
        mov     [es:retstk+edi*4],eax   ;
        inc     [word es:level]         ; Inc the level of nested execs
        mov     [byte _AL],1            ; Change exec to debug
        mov     ax,[ss:realCS]          ;
        mov     [_CS],ax                ;
        mov     [word _EIP],offset UserExec
        mov     [byte _VECT],21h        ;
        jmp     Int13n                  ; Emulate INT 21h

; Emulate IRET instruction

@Iret:
        add     dx,4                    ;
        lods    [word esi]              ;
        mov     [_EIP],ax               ; Get IP
        lods    [word esi]              ;
        mov     [_CS],ax                ; Get CS
@Popf:  inc     dx                      ;
        inc     dx                      ;
        mov     [_ESP],dx               ;⥪

        lods    [word esi]              ;稫 䫠
;        test    [byte ss:(TSSv86._eflags)+1],1 ; TF flag
;        jz      @@11
        test    ah,1
        jz     @@11
        mov     [ss:TF_flag],11         ;. ७ 䫠,  TF=1
        jmp     @@12
@@11:   cmp     [ss:TF_flag],11
        jne     @@12
        test    [word ss:TSSv86._eflags],100h ;஢ -- 䫠 ⫠
        jnz     @@111                        ;㫨  襭 ᥡ :)
        mov     [ss:TF_flag],0               ;᫨  -- 㫨 ᯮ
        jmp     @@12
@@111:  mov     [ss:TF_flag],1
        or      ah,1

@@12:   mov     [word ss:TSSv86._eflags],ax

        mov     cx,0EF20h               ;
        test    [byte ss:trace],1       ;
        jz      @@10                    ;
        mov     cx,0ED21h               ;
@@10:   and     ah,ch                   ;
        or      ah,cl                   ; Set TF
        mov     [_EFLAGS],ax            ; Set Flags
Iret13:
        and     [byte bp+16],0FEh       ; Clear RF so the breakpoint monitor
                                        ; can get control if a hardware
                                        ; breakpoint have been set at the
                                        ; instruction on which we have
                                        ; to return
        cmp     [ss:TF_flag],1          ; ᫨ ⠭ 䫠, 
        jne     @@09                    ; ।. ࠢ.  ࠡ稪
        popad                           ; Int 1 (trace) ⮡  
        pop     bp                      ;   int 1 ᫥ popf, iret...
        add     sp,4
        jmp     Exc1

@@09:   test    [byte ss:trace],1       ; Test TF
        popad                           ; Clear stack
        pop     bp                      ;
        jz      @@10                    ; We have not to emulate
        add     sp,4                    ;
        jmp     Exc1e                    ; Transfer control to Exc1 handler
@@10:   add     sp,4                    ;
        iretd                           ;

; Emulate IRETD instruction

@Iretd:
        add     dx,8                    ;
        lods    [dword esi]             ;
        mov     [_EIP],eax              ; Get EIP
        lods    [dword esi]             ;
        mov     [_CS],ax                ; Get CS
@Popfd: add     dx,4                    ;
        mov     [_ESP],dx               ;

        lods    [dword esi]             ;
        mov     [ss:TSSv86._eflags],eax ;

        mov     cx,0EF20h               ;
        test    [byte ss:trace],1       ;
        jz      @@10                    ;
        mov     cx,0ED21h               ;
@@10:   and     ah,ch                   ;
        or      ah,cl                   ; Set TF
        bts     eax,17                  ; Set VM
        mov     [_EFLAGS],eax           ; Set Flags
        jmp     Iret13                  ;

;++
; Unexpected interrupt handler
; Entry:
;       _MSG in the stack consist of a _MSG ID in MSB and number in LSB
; Valid IDs are:
;       00h - common breakpoint, value in LSB is meaningless
;       02h - privileged instruction, value in LSB has no meaning
;       10h - user task termination, LSB is an exit code
;
;--

        proc    Master                  ;mas

        push    bp
        mov     bp,sp
        cmp     [byte _MSG+1],10h       ; Is it task termination?
        je      @@00                    ; Yeah - skip registers synchronization

        pop     bp

        mov     [ss:TSSv86._eax],eax
        mov     [ss:TSSv86._ebx],ebx
        mov     [ss:TSSv86._ecx],ecx
        mov     [ss:TSSv86._edx],edx
        mov     [ss:TSSv86._ebp],ebp
        mov     [ss:TSSv86._esi],esi
        mov     [ss:TSSv86._edi],edi

        push    bp
        mov     bp,sp

        mov     eax,[_ESP]
        mov     [ss:TSSv86._esp],eax
        mov     eax,[_EIP]
        mov     [ss:TSSv86._eip],eax
        mov     ax,[_EFLAGS]
        and     [word ss:TSSv86._eflags],03300h
        and     ah,0CCh
        or      [word ss:TSSv86._eflags],ax
        mov     ax,[_CS]
        mov     [ss:TSSv86._cs],ax
        mov     ax,[_SS]
        mov     [ss:TSSv86._ss],ax
        mov     ax,[_ES]
        mov     [ss:TSSv86._es],ax
        mov     ax,[_DS]
        mov     [ss:TSSv86._ds],ax
        mov     ax,[_FS]
        mov     [ss:TSSv86._fs],ax
        mov     ax,[_GS]
        mov     [ss:TSSv86._gs],ax

@@00:   mov     al,0Ah                  ; Save PICs masks into CX
        out     20h,al                  ;
        delay
        in      al,21h                  ;
        mov     cl,al                   ;

        mov     al,0Ah
        out     0A0h,al
        delay
        in      al,0A1h                 ;
        mov     ch,al                   ;

        mov     al,0FCh                 ; Disable all IRQs except
        out     21h,al                  ; the keyboard IRQ (IRQ1)
        mov     al,0FFh                 ;
        out     0A1h,al                 ;

;---
        in      al,61h
        and     al,01111111b
        out     61h,al
kbd_hrd:jmp   short  @@0001
        mov     al,0aeh                 ;
        out     64h,al                  ;ࠧ᪨஢ 
        mov     al,0f6h
        out     60h,al
;---
@@0001:

        sti                             ; Keyboard interrupt only can occure
                                        ; while our face is on the screen
        mov     ax,[_MSG]               ; The draw_face procedure will return
        call    draw_face               ; the following codes in AL:
        cmp     al,0FEh                 ; FEh - reload the user task
        je      @@Load                  ;
        cmp     al,0FFh                 ; FFh - exit to DOS
        jne     @@Go                    ;
        jmp     ReturnDOS               ;

@@Load: mov     [byte ss:trace],2       ; Enable PopUp
        and     [byte _EFLAGS+1],0FEh   ; Clear Trace Flag
        call    RestoreVectors          ; Restore real mode int table
        mov     ax,sPSP93               ;
        mov     ds,ax                   ; Get selctor to conventional memory
        mov     [byte exitflg],2        ;
        cmp     [word level],0          ;
        js      @@Down                  ;
        mov     [byte _VECT],21h        ; Call DOS Terminate function
        mov     ax,4C00h                ;
        jmp     v86                     ;

@@Down: mov     ax,[ss:realCS]          ;
        mov     [_CS],ax                ;
        mov     [_SS],ax                ;
        mov     [word _EIP],offset Reload;
        mov     ax,[_EIP]
        mov     [word _ESP],offset @STACK@
        pushad                          ;
        jmp     Ret13                   ;

@@Go:   mov     [byte ss:trace],al      ;
@@Ret:
        cli                             ;

        mov     al,cl                   ;
        out     21h,al                  ;
        mov     al,ch                   ;
        out     0A1h,al                 ;

        mov     eax,[ss:TSSv86._esp]
        mov     [_ESP],eax
        mov     eax,[ss:TSSv86._eip]
        mov     [_EIP],eax
        mov     ax,[word ss:TSSv86._eflags]
        test    [byte ss:trace],1
        jz      @@10
        and     ah,0CCh                 ;
        or      ah,021h                 ;
        jmp short @@20

@@10:   and     ah,0CFh                 ;
        or      ah,20h                  ;
@@20:   mov     [_EFLAGS],ax
        or      [byte bp+16],1          ; ??? Set RF

        call    pod_2           ;⠭ ᥣ. -  TSS

        pop     bp

        call    pod_1           ;. -  TSS

;-- 뤥  -஢
        mov     [dword ss:tab_ch1+08h],eax
        mov     [dword ss:tab_ch1+14h],ebx
        mov     [dword ss:tab_ch1+0ch],ecx
        mov     [dword ss:tab_ch1+10h],edx
        mov     [dword ss:tab_ch1+1ch],ebp
        mov     [dword ss:tab_ch1+20h],esi
        mov     [dword ss:tab_ch1+24h],edi
        push    eax
        mov     eax,[ss:TSSv86._esp]
        mov     [dword ss:tab_ch1+18h],eax
        mov     eax,[ss:TSSv86._eip]
        mov     [dword ss:tab_ch1+00h],eax
        mov     eax,[dword ss:TSSv86._eflags]
        mov     [dword ss:tab_ch1+04h],eax

        mov     ax,[ss:TSSv86._es]
        mov     [word ss:tab_ch1+28h],ax
        mov     ax,[ss:TSSv86._cs]
        mov     [word ss:tab_ch1+2ch],ax
        mov     ax,[ss:TSSv86._ss]
        mov     [word ss:tab_ch1+30h],ax
        mov     ax,[ss:TSSv86._ds]
        mov     [word ss:tab_ch1+34h],ax
        mov     ax,[ss:TSSv86._fs]
        mov     [word ss:tab_ch1+38h],ax
        mov     ax,[ss:TSSv86._gs]
        mov     [word ss:tab_ch1+3ch],ax
        pop     eax
        ret     2                       ;
        endp                            ;

;===============================================================
;======================== Procedures ===========================
;===============================================================

;++
; Dump all 386 registers
;--
        proc    Dump386Regs             ;

        pushfd                          ;

        push    eax                     ;
        push    esi                     ;
        push    ds                      ;

        push    cs                      ;
        pop     ds                      ;

        push    si                      ;

        lea     si,[dmpEAX]             ;
        call    PrintStr                ;
        call    PrintEAX                ;

        lea     si,[dmpEBX]             ;
        call    PrintStr                ;
        mov     eax,ebx                 ;
        call    PrintEAX                ;

        lea     si,[dmpECX]             ;
        call    PrintStr                ;
        mov     eax,ecx                 ;
        call    PrintEAX                ;

        lea     si,[dmpEDX]             ;
        call    PrintStr                ;
        mov     eax,edx                 ;
        call    PrintEAX                ;

        lea     si,[dmpEBP]             ;
        call    PrintStr                ;
        mov     eax,ebp                 ;
        mov     ax,[bp+2]               ; 
        call    PrintEAX                ;

        lea     si,[dmpESI]             ;
        call    PrintStr                ;

        pop     si                      ;

        mov     eax,esi                 ;
        call    PrintEAX                ;

        lea     si,[dmpEDI]             ;
        call    PrintStr                ;
        mov     eax,edi                 ;
        call    PrintEAX                ;

        lea     si,[dmpESP]             ;
        call    PrintStr                ;
        mov     eax,[_ESP]              ;
        call    PrintEAX                ;

        lea     si,[dmpCS]              ;
        call    PrintStr                ;
        mov     ax,[_CS]                ;
        call    PrintAX                 ;

        lea     si,[dmpDS]              ;
        call    PrintStr                ;

        mov     ax,[_DS]
        call    PrintAX                 ;

        lea     si,[dmpES]              ;
        call    PrintStr                ;
        mov     ax,[_ES]                ;
        call    PrintAX                 ;

        lea     si,[dmpFS]              ;
        call    PrintStr                ;
        mov     ax,[_FS]                ;
        call    PrintAX                 ;

        lea     si,[dmpGS]              ;
        call    PrintStr                ;
        mov     ax,[_GS]                ;
        call    PrintAX                 ;

        lea     si,[dmpSS]              ;
        call    PrintStr                ;
        mov     ax,[_SS]                ;
        call    PrintAX                 ;
                                        ;
        lea     si,[dmpIP]              ;
        call    PrintStr                ;
        mov     ax,[_EIP]               ;
        call    PrintAX                 ;

        lea     si,[dmpEFlgs]           ;
        call    PrintStr                ;
        mov     eax,[_EFLAGS]           ;
        call    PrintEAX                ;

        lea     si,[dmpCR0]             ;
        call    PrintStr                ;
        mov     eax,cr0                 ;
        call    PrintEAX                ;

        call    NewLine                 ;
        pop     ds                      ;
        pop     esi                     ;
        pop     eax                     ;

        popfd                           ;

        ret                             ;

        endp                            ;

;++
; Dump Stack
;--
        proc    DumpStack

        push    ax
        push    cx
        push    si
        push    ds

        mov     ax,cs
        mov     ds,ax

        lea     si,[dmpStack]
        call    PrintStr

        mov     ax,ss
        mov     ds,ax                   ; Load DS with stack selector

;        mov     si,sp
        mov     si,bp
;        add     si,10                   ; Pop saved registers and callers addr
        cld                             ; Stack grows backward
        mov     cx,29                   ; Dump twenty nine words
@@10:   lodsw                           ; Pop a word from stack
        call    PrintAX                 ; Print it
        mov     ax,0720h                ; Print whitespace
        cmp     bp,si                   ;
        jne     @@15                    ;
        mov     al,'>'                  ;
@@15:   call    PrintChar               ;
        or      si,si                   ; Is it the end of the stack
        jz      @@20                    ;
        loop    @@10                    ; Next word
@@20:
        call    NewLine

        pop     ds
        pop     si
        pop     cx
        pop     ax
        ret
        endp



;++
; Dump Stack
;--
        proc    DumpTaskStack

        push    eax                      ;
        push    ebx                     ;
        push    cx
        push    esi
        push    ds

        mov     ax,cs
        mov     ds,ax

        lea     si,[dmpTask]
        call    PrintStr

        mov     ax,sConv
        mov     ds,ax                   ; Load 4Gb selector

        movzx   esi,[word _SS]          ;
        shl     esi,4                   ;
        movzx   ebx,[word _ESP]         ;
        add     esi,ebx                 ;

        cld                             ; Stack grows backward
        mov     cx,29                   ; Dump twenty nine words
@@10:   lods    [word esi]              ; Pop a word from stack
        call    PrintAX                 ; Print it
        add     bx,2                    ;
        mov     ax,0720h                ; Print whitespace
        call    PrintChar               ;
        or      bx,bx                   ; Is it the end of the stack
        jz      @@20                    ;
        loop    @@10                    ; Next word
@@20:
        call    NewLine

        pop     ds                      ;
        pop     esi
        pop     cx
        pop     ebx
        pop     eax
        ret
        endp

;---------------------------------------;
; Dump Task State Segment.              ;
; Expects:                              ;
;  DS:BX - TSS                          ;
;---------------------------------------;
;        macro   DTSSW txt,val           ;
;        lea     si, [ txt ]             ;
;        call    PrintStr                ;
;        mov     ax, [ (tss bx).val ]    ;
;        call    PrintAX                 ;
;        endm                            ;
;;---------------------------------------;
;        macro   DTSSD txt,val           ;
;        lea     si, [ txt ]             ;
;        call    PrintStr                ;
;        mov     eax, [ (tss bx).val ]   ;
;        call    PrintEAX                ;
;        endm                            ;
;;---------------------------------------;
;        macro   DTSSP txt,s,o           ;
;        lea     si, [ txt ]             ;
;        call    PrintStr                ;
;        mov     ax, [ (tss bx).s ]      ;
;        call    PrintAX                 ;
;        mov     ax, 0F00h OR ':'        ;
;        call    PrintChar               ;
;        mov     eax, [ (tss bx).o ]     ;
;        call    PrintEAX                ;
;        endm                            ;
;;---------------------------------------;
;        proc    DumpTSS                 ;
;        push    eax                     ;
;        push    si                      ;
;        DTSSW   tssLink, back           ;
;        DTSSD   tssEFL, _eflags         ;
;        DTSSD   tssCR3, _cr3            ;
;        DTSSW   tssLDT, _ldt            ;
;        DTSSP   tssSSP0, ss0, esp0      ;
;        DTSSD   tssEAX, _eax            ;
;        DTSSD   tssESI, _esi            ;
;        DTSSW   tssDS, _ds              ;
;        DTSSP   tssSSP1, ss1, esp1      ;
;        DTSSD   tssEBX, _ebx            ;
;        DTSSD   tssEDI, _edi            ;
;        DTSSW   tssES, _es              ;
;        DTSSP   tssSSP2, ss2, esp2      ;
;        DTSSD   tssECX, _ecx            ;
;        DTSSD   tssEBP, _ebp            ;
;        DTSSW   tssFS, _fs              ;
;        DTSSP   tssSSSP, _ss, _esp      ;
;        DTSSD   tssEDX, _edx            ;
;        DTSSD   tssESP, _esp            ;
;        DTSSW   tssGS, _gs              ;
;        DTSSP   tssCSIP, _cs, _eip      ;
;        DTSSW   tssIO, iomap            ;
;        call    NewLine                 ;
;        pop     si                      ;
;        pop     eax                     ;
;        ret                             ;
;        endp                            ;
;---------------------------------------;

;++
; Print AX
;--
        proc    PrintAX

        push    ax
        push    bx
        push    cx

        mov     bx,ax
        mov     ah,0Fh
        mov     cx,4
@@10:
        mov     al,bh
        shr     al,4
        cmp     al,al                   ; Clear AF
        daa                             ; Cool translation hex to ASCII
        add     al,0F0h                 ;
        adc     al,40h                  ;

        call    PrintChar               ;

        shl     bx,4
        loop    @@10

        pop     cx                      ;
        pop     bx                      ;
        pop     ax                      ;
        ret                             ;


        endp

;++
; Print EAX
;--
        proc    PrintEAX

        push    eax
        push    ebx
        push    cx

        mov     ebx,eax
        mov     cx,8
@@10:
        mov     eax,ebx                 ;
        shr     eax,28                  ;
        cmp     al,al                   ; Clear AF
        daa                             ; Cool translation hex to ASCII
        add     al,0F0h                 ;
        adc     al,40h                  ;
        mov     ah,0Fh                  ;
        call    PrintChar               ;

        shl     ebx,4
        loop    @@10

        pop     cx                      ;
        pop     ebx                     ;
        pop     eax                     ;
        ret                             ;


        endp

;++
; Print string
; DS:SI - string pointer
;--

        proc    PrintStr                ;

        cld                             ;
        push    ax                      ;
        push    si                      ;
        lodsb                           ; First byte of string
        mov     ah,al                   ; is used as attribute

@@10:   lodsb                           ;
        or      al,al                   ;
        jz      @@20                    ;
        call    PrintChar               ;
        jmp SHORT @@10                  ;
@@20:   pop     si                      ;
        pop     ax                      ;
        ret                             ;

        endp                            ;

;++
; Print character
; AL    - character
; AH    - attribute
;--

        proc    PrintChar               ;

        push    di                      ;
        push    ds                      ;
        push    es                      ;

        push    ax                      ;

        smsw    ax                      ;
        test    al,1                    ; Does it protected mode
        jz      @@Real                  ;

        mov     ax,sData                ; Load protected mode selectors
        mov     ds,ax                   ;
        mov     ax,sVideo               ;
        mov     es,ax                   ;
        jmp SHORT @@00                  ;

@@Real: mov     ax,cs                   ; Load real mode segments
        mov     ds,ax                   ;
        mov     ax,0B800h               ;
        mov     es,ax                   ;

@@00:   pop     ax                      ;
        cmp     al,0Dh                  ;
        jne     @@10                    ;

        mov     [byte CUR_COL],0        ;
        jmp     @@Ret                   ;

@@10:   cmp     al,0Ah                  ;
        je      @@20                    ;

        call    MakePtr                 ;

        cld                             ; Just to be sure

        stosw                           ;

        mov     al,[byte MAX_COL]       ;
        inc     [byte CUR_COL]          ;
        cmp     al,[byte CUR_COL]       ;
        ja      @@Ret                   ;
        mov     [byte CUR_COL],0        ;

@@20:   inc     [byte CUR_ROW]          ;
        mov     al,[byte MAX_ROW]       ;
        cmp     al,[byte CUR_ROW]       ;
        jae     @@Ret                   ;

        dec     [byte CUR_ROW]          ;
        call    ScrollScr               ;

@@Ret:  pop     es                      ;
        pop     ds                      ;
        pop     di                      ;
        ret                             ;

        endp                            ;

;++
; Move cursor to new line
;--

        proc    NewLine                 ;

        push    ax                      ;
        mov     al,0Dh                  ;
        call    PrintChar               ;
        mov     al,0Ah                  ;
        call    PrintChar               ;
        pop     ax                      ;
        ret                             ;

        endp                            ;

;++
; Make video pointer
; Return:
; DI    - pointer to current cursor position
;--

        proc    MakePtr                 ; Very simple code

        push    ax                      ;
        push    cx                      ;
        push    ds                      ;

        smsw    ax                      ;
        test    al,1                    ;
        jz      @@Real                  ;

        mov     ax,sData                ;
        jmp SHORT @@10                  ;

@@Real: mov     ax,cs                   ;

@@10:   mov     ds,ax                   ;

        mov     al,[byte CUR_ROW]       ;
        mov     cl,[byte MAX_COL]       ;
        mul     cl                      ;
        add     al,[byte CUR_COL]       ;
        adc     ah,0                    ;
        shl     ax,1                    ;
        mov     di,ax                   ;

        pop     ds                      ;
        pop     cx                      ;
        pop     ax                      ;
        ret                             ;

        endp                            ;

;++
; Scroll up the screen
;--

        proc    ScrollScr               ; No comments

        push    ds                      ;
        push    es                      ;
        push    fs                      ;
        push    ax                      ;
        push    cx                      ;
        push    si                      ;
        push    di                      ;

        cld                             ;

        smsw    ax                      ;
        test    al,1                    ;
        jz      @@Real                  ;

        mov     ax,sVideo               ;
        mov     cx,sData                ;
        jmp SHORT @@10                  ;

@@Real: mov     ax,0B800h               ;
        mov     cx,cs                   ;

@@10:   mov     ds,ax                   ;
        mov     es,ax                   ;
        mov     fs,cx                   ;
        movzx   si,[byte fs:MAX_COL]    ;
        shl     si,1                    ;
        xor     di,di                   ;
        mov     al,[byte fs:MAX_COL]    ;
        mov     cl,[byte fs:MAX_ROW]    ;
        mul     cl                      ;
        mov     cx,ax                   ;
        rep     movsw                   ;
        mov     ax,0720h                ;
        movzx   cx,[byte fs:MAX_COL]    ;
        rep     stosw                   ;

        pop     di                      ;
        pop     si                      ;
        pop     cx                      ;
        pop     ax                      ;
        pop     fs                      ;
        pop     es                      ;
        pop     ds                      ;
        ret                             ;

        endp                            ;
;---------------------------------------;
pod_1:  mov     eax,[ss:TSSv86._eax]
        mov     ebx,[ss:TSSv86._ebx]
        mov     ecx,[ss:TSSv86._ecx]
        mov     edx,[ss:TSSv86._edx]
        mov     ebp,[ss:TSSv86._ebp]
        mov     esi,[ss:TSSv86._esi]
        mov     edi,[ss:TSSv86._edi]
        ret
;-----------------------------------
pod_2:  mov     ax,[ss:TSSv86._cs]
        mov     [_CS],ax
        mov     ax,[ss:TSSv86._ss]
        mov     [_SS],ax
        mov     ax,[ss:TSSv86._es]
        mov     [_ES],ax
        mov     ax,[ss:TSSv86._ds]
        mov     [_DS],ax
        mov     ax,[ss:TSSv86._fs]
        mov     [_FS],ax
        mov     ax,[ss:TSSv86._gs]
        mov     [_GS],ax
        ret

ends
        end
