Ideal                                   ;
p386                                    ;
        segment code byte public use16 'CODE'
        assume  cs:code, ds:code        ;
                                        ;
global  Expression      : proc          ;
global  get_seg_off     : proc          ;
global  blanks          : proc          ;
global  edit_text       : proc          ;
global  calculator      : proc          ;
global  unget_key       : proc          ;
global  check_condition : proc          ;
global  h30             : proc          ;

extrn   put_string      : proc          ;
extrn   draw_frame      : proc          ;
extrn   SetCursor       : proc          ;
extrn   HideCursor      : proc          ;
extrn   FACE            : proc          ;
extrn   PrintHex16      : proc          ;
extrn   Jcc_calls       : proc          ;
extrn   DEBUG           : proc          ;
extrn   buffer          : byte          ;
extrn   mess_08         : byte          ;
                                        ;
include "defines.inc"
include "keys.inc"

;---------------------------------------;
TSS_regs:                               ;
        db      'IP', 20h, 0FFh         ;
        db      'FL', 24h, 0FFh         ;
        db      'AX', 28h, 0FFh         ;
        db      'CX', 2Ch, 0FFh         ;
        db      'DX', 30h, 0FFh         ;
        db      'BX', 34h, 0FFh         ;
        db      'SP', 38h, 0FFh         ;
        db      'BP', 3Ch, 0FFh         ;
        db      'SI', 40h, 0FFh         ;
        db      'DI', 44h, 0FFh         ;
e32r:                                   ;
        db      'ES', 48h, 0FFh         ;
        db      'CS', 4Ch, 0FFh         ;
        db      'SS', 50h, 0FFh         ;
        db      'DS', 54h, 0FFh         ;
        db      'FS', 58h, 0FFh         ;
        db      'GS', 5Ch, 0FFh         ;
        db      'AL', 28h, 00           ;
        db      'AH', 29h, 00           ;
        db      'CL', 2Ch, 00           ;
        db      'CH', 2Dh, 00           ;
        db      'DL', 30h, 00           ;
        db      'DH', 31h, 00           ;
        db      'BL', 34h, 00           ;
        db      'BH', 35h, 00           ;
;---------------------------------------;
opers   db      '+','-'                 ;
        db      '*','/'                 ;
        db      '%','^'                 ;
        db      '&','|'                 ;
        dw      0                       ;
;---------------------------------------;
Expression:                             ;
        push    ebx                     ; ds:si -> eax
        push    edx                     ;
        lea     edx, [ opers ]          ;
        call    expr                    ;
        pop     edx                     ;
        pop     ebx                     ;
        ret                             ;
;---------------------------------------;
expr:                                   ;
        call    expr1                   ;
@@00:                                   ;
        mov     bl, [ byte ds:si ]      ;
        cmp     bl, [ byte cs:edx ]     ;
        je      short @@10              ;
        cmp     bl, [ byte cs:edx+1 ]   ;
        je      short @@10              ;
        ret                             ;
@@10:                                   ;
        inc     si                      ;
        push    edx                     ;
        push    eax                     ;
        push    bx                      ;
        call    expr1                   ;
        pop     bx                      ;
        pop     edx                     ;
        xchg    eax, edx                ; eax - first, edx - second
        cmp     bl, '+'                 ;
        jne     short @@20              ;
        add     eax, edx                ; +
        jmp     short @@all             ;
@@20:                                   ;
        cmp     bl, '-'                 ;
        jne     short @@30              ;
        sub     eax, edx                ; -
        jmp     short @@all             ;
@@30:                                   ;
        cmp     bl, '*'                 ;
        jne     short @@40              ;
        mul     edx                     ; *
        jmp     short @@all             ;
@@40:                                   ;
        cmp     bl, '/'                 ;
        jne     @@50                    ;
        or      edx, edx                ; /
        je      short @@err             ;
        mov     ebx, edx                ;
        xor     edx, edx                ;
        div     ebx                     ;
        jmp     short @@all             ;
@@50:                                   ;
        cmp     bl, '%'                 ;
        jne     @@60                    ;
        or      edx, edx                ; %
        je      short @@err             ;
        mov     ebx, edx                ;
        xor     edx, edx                ;
        div     ebx                     ;
        mov     eax, edx                ;
        jmp     short @@all             ;
@@60:                                   ;
        cmp     bl, '^'                 ;
        jne     @@70                    ;
        xor     eax, edx                ; ^
        jmp     short @@all             ;
@@70:                                   ;
        cmp     bl, '&'                 ;
        jne     @@80                    ;
        and     eax, edx                ; &
        jmp     short @@all             ;
@@80:                                   ;
        cmp     bl, '|'                 ;
        jne     @@err                   ;
        or      eax, edx                ; |
        jmp     short @@all             ;
@@err:                                  ;
        mov     eax, 0FFFFFFFFh         ;
@@all:                                  ;
        pop     edx                     ;
        jmp     @@00                    ;
;---------------------------------------;
expr1:                                  ;
        cmp     [ word cs:edx+2 ], 0    ;
        je      @@10                    ;

        inc     edx                     ;
        inc     edx                     ;
        call    expr                    ;
        dec     edx                     ;
        dec     edx                     ;
        jmp     short @@20              ;
@@10:                                   ;
        call    hier                    ;
@@20:                                   ;
        call    blanks                  ;
        ret                             ;
;---------------------------------------;
hier:                                   ;
        call    blanks                  ;
        cmp     [ byte ds:si ], '-'     ; un-
        jne     h10                     ;
        inc     si                      ;
        call    hier                    ;
        neg     eax                     ;
        ret                             ;
h10:                                    ;
        cmp     [ byte ds:si ], '('     ; (...)
        jne     short h20               ;
        inc     si                      ;
        call    Expression              ;
        cmp     [ byte ds:si ], ')'     ;
        je      h11                     ;
        xor     eax, eax                ;
        dec     si                      ;
h11:                                    ;
        inc     si                      ;
        ret                             ;
h20:                                    ;
        call    check_regs              ;
        jnc     @@ret                   ;
                                        ;
        cmp     [ byte ds:si ], 27h     ; '
        jne     h30                     ;
        inc     si                      ;
        xor     ebx, ebx                ;
@@22:                                   ;
        lodsb                           ;
        cmp     al, 27h                 ;
        je      @@25                    ;
        shl     ebx, 8                  ;
        mov     bl, al                  ;
        jmp     short @@22              ;
@@25:                                   ;
        mov     eax, ebx                ;
@@ret:                                  ;
        ret                             ;
h30:                                    ;
        push    edi                     ;
        push    esi                     ;
h31:                                    ;
        lodsb                           ;
        cmp     al, '0'                 ;
        jl      h32                     ;
        cmp     al, '9'                 ;
        jg      h32                     ;
        jmp     short h31               ;
h32:                                    ;
        dec     si                      ;
        pop     edi                     ;
        cmp     di, si                  ;
        mov     si, di                  ;
        je      h40                     ;
        cmp     al, '.'                 ; .
        jne     h40                     ;
        call    do_decimal              ;
        jmp     short h50               ;
h40:                                    ;
        call    do_hex                  ;
h50:                                    ;
        pop     edi                     ;
        ret                             ;
;---------------------------------------;
; ய ஡
;        dec     si                      ;
bl01:   inc     si                      ;
blanks: cmp     [ byte si ], ' '        ;
        je      short bl01              ;
        ret                             ;
;---------------------------------------;
do_decimal:                             ; [ds:si]->eax
        push    ebx                     ;
        xor     ebx, ebx                ;
        mov     eax, ebx                ;
dd00:                                   ;
        mov     bl, [ byte ds:si ]      ;
        sub     bl, '0'                 ;
        jl      dd01                    ;
        cmp     bl, 9                   ;
        jg      dd01                    ;
        imul    eax, eax, 10            ;
        add     eax, ebx                ;
        inc     si                      ;
        jmp     short dd00              ;
dd01:                                   ;
        inc     si                      ;
        pop     ebx                     ;
        ret                             ;
;---------------------------------------;
do_hex:                                 ; ->eax
        push    ebx                     ;
        xor     ebx, ebx                ;
        mov     eax, ebx                ;
dh00:                                   ;
        mov     bl, [ byte ds:si ]      ;
        sub     bl, '0'                 ;
        jl      dh01                    ;
        cmp     bl, 9                   ;
        jle     dh02                    ;
        and     bl, 11011111b           ;
        cmp     bl, 'A'-'0'             ;
        jl      dh01                    ;
        cmp     bl, 'F'-'0'             ;
        jg      dh01                    ;
        sub     bl, 7                   ;
dh02:                                   ;
        shl     eax, 4                  ;
        add     eax, ebx                ;
        inc     si                      ;
        jmp     short dh00              ;
dh01:                                   ;
        pop     ebx                     ;
        ret                             ;
;---------------------------------------;
check_regs:                             ; ds:si -> ok:<NC>, result in eax
        push    edi                     ;
        push    ds                      ;
        push    ecx                     ;
        mov     al, [ byte ds:si ]      ;
        inc     si                      ;
        and     al, 11011111b           ; to upper
        cmp     al, 'E'                 ;
        jnz     @@10                    ;
        call    chk                     ;
        jc      @@10                    ;
        cmp     bx, offset e32r         ;
        jae     @@10                    ;
        mov     edi, 0FFFFFFFFh         ;
        jmp     short @@20              ;
@@10:                                   ;
        dec     si                      ;
        call    chk                     ;
        jc      @@ret                   ;
        mov     edi, 0000FFFFh          ;
@@20:                                   ;
        inc     si                      ;
        inc     si                      ;
        mov     ax, sTSS                ;
        mov     ds, ax                  ;
        mov     cl, [ byte cs:bx+3 ]    ;
        movzx   bx, [ byte cs:bx+2 ]    ;
        mov     eax, [ dword ds:bx ]    ;
        and     ah, cl                  ;
        and     eax, edi                ;
        clc                             ;
@@ret:                                  ;
        pop     ecx                     ;
        pop     ds                      ;
        pop     edi                     ;
        ret                             ;

chk:                                    ;
        mov     bx, offset TSS_regs     ;
        mov     ax, [ word ds:si ]      ;
        and     ax, 1101111111011111b   ; to upper
        mov     cx, 24                  ; sizeof(TSS_regs)
@@10:                                   ;
        cmp     [ word cs:bx ], ax      ;
        je      short @@ret             ;
        add     bx, 4                   ;
        loop    @@10                    ;
                                        ;
        stc                             ;
@@ret:                                  ;
        ret                             ;
;---------------------------------------;
get_seg_off:                            ; cs:si-text, di-where, ->edx:ebx
        push    cx                      ; ( if segment missed, then dx not
        push    ax                      ;  changed )  <CY> if Esc pressed
        push    es                      ;

        push    sVideo                  ;
        pop     es                      ; es = sVideo
        push    di                      ;
        mov     ah, 17h                 ;
        mov     cx, 40*256+1            ;
        call    draw_frame              ;
        pop     di                      ;
        push    di                      ;
        add     di, 12*2                ;
        call    put_string              ;
        pop     di                      ;
        add     di, (90*1+1)*2          ;
        call    edit_text               ;
        jc      @@20                    ;
        mov     si, offset buffer       ;
        call    Expression              ;
        cmp     [ byte ds:si ], ':'     ;
        jnz     @@10                    ;
        inc     si                      ;
        mov     edx, eax                ;
        call    Expression              ;
@@10:                                   ;
        mov     ebx, eax                ;
        clc                             ;
@@20:                                   ;
        pushf                           ;
        call    FACE                    ;
        popf                            ;

        pop     es                      ;
        pop     ax                      ;
        pop     cx                      ;
        ret                             ;
;---------------------------------------;
edit_text:                              ; -> buffer, es:di - where
        mov     si, offset buffer       ;
        push    di                      ;
        push    cx                      ;
        mov     cx, 40                  ;
        mov     ax, 17h*256+' '         ;
        rep     stosw                   ;
        pop     cx                      ;
        pop     di                      ;
        call    SetCursor               ;
@@loop:                                 ;
        call    get_my_key              ;
        cmp     ax, _BS                 ;
        jnz     @@5                     ;
        cmp     si, offset buffer       ;
        jz      @@loop                  ;
        dec     si                      ;
        mov     [ byte si ], ' '        ;
        dec     di                      ;
        dec     di                      ;
        mov     [ byte es:di ], ' '     ;
        call    SetCursor               ;
        jmp     short @@loop            ;
@@5:                                    ;
        cmp     ax, _Enter              ;
        jz      @@10                    ;
        cmp     ax, _Esc                ;
        jz      @@20                    ;
        cmp     si, offset buffer+39    ;
        jz      @@loop                  ;
        cmp     ax, 100h                ;
        jnb     @@loop                  ;
        mov     [ byte si ], al         ;
        inc     si                      ;
        mov     ah, 17h                 ;
        stosw                           ;
        call    SetCursor               ;
        jmp     short @@loop            ;
@@10:                                   ;
        mov     [ byte si ], 0          ;
        call    HideCursor              ;
        clc                             ;
        ret                             ;
@@20:                                   ;
        call    HideCursor              ;
        stc                             ;
        ret                             ;
;---------------------------------------;
calculator:                             ;
        mov     di, (90*5+20)*2         ;
        mov     si, offset mess_08      ;
        call    get_seg_off             ;
        jc      @@ret                   ;
        call    draw_result             ;
@@ret:                                  ;
        call    FACE                    ;
        ret                             ;
;---------------------------------------;
draw_result:                            ; ebx
        push    sVideo                  ;
        pop     es                      ; es = ਯ 
        mov     di, (90*5+20)*2         ;
        mov     ah, 17h                 ;
        mov     cx, 31*256+1            ;
        call    draw_frame              ;
        mov     di, (90*6+22)*2         ;
        mov     si, offset txt01        ;
        mov     ah, 1Fh                 ;
        call    put_string              ;
        mov     eax, ebx                ;
        call    PrintHex32              ;
        mov     si, offset txt02        ;
        mov     ah, 1Fh                 ;
        call    put_string              ;
        mov     eax, ebx                ;
        call    PrintDec32              ;
        cmp     ebx, 100h               ;
        jnb     @@ret                   ;
        mov     si, offset txt03        ;
        mov     ah, 1Fh                 ;
        call    put_string              ;
        mov     ah, 07h                 ;
        mov     al, bl                  ;
        stosw                           ;
@@ret:                                  ;
        call    getkey                  ;
        ret                             ;
;---------------------------------------;
PrintDec32:                             ; eax
        mov     si, offset buffer       ;
        mov     ecx, 10                 ;
@@10:                                   ;
        xor     edx, edx                ;
        div     ecx                     ;
        mov     [ byte si ], dl         ;
        inc     si                      ;
        or      eax, eax                ;
        jnz     @@10                    ;

        mov     ah, 07h                 ;
@@20:                                   ;
        dec     si                      ;
        mov     al, [ byte si ]         ;
        add     al, '0'                 ;
        stosw                           ;
        cmp     si, offset buffer       ;
        jnz     @@20                    ;

        ret                             ;
;---------------------------------------;
PrintHex32:                             ; eax
        test    eax, 0FFFF0000h         ;
        je      @@10                    ;
        push    eax                     ;
        shr     eax, 16                 ;
        call    @@10                    ;
        pop     eax                     ;
@@10:                                   ;
        call    PrintHex16              ;
        ret                             ;
;---------------------------------------;
unget_key:                              ; ax
        mov     [ word ds:unchar ], ax  ;
        ret                             ;
;---------------------------------------;
get_my_key:                             ;
        xor     ax, ax                  ;
        xchg    ax, [ word ds:unchar ]  ;
        or      ax, ax                  ;
        jnz     @@10                    ;
        call    getkey                  ;
@@10:                                   ;
        ret                             ;
;---------------------------------------;
check_condition:                        ; ds:si - text of condition
        push    es                      ; <C> - true,
        push    ds                      ; al=0 - OK, al=FF - bad cond.
        pop     es                      ;

        call    Expression              ;
        push    eax                     ;
        call    blanks                  ;
        lodsb                           ;
        mov     cx, 4                   ;
        mov     di, offset cond         ;
        repnz scasb                     ;
        jnz     @@bad                   ;
        mov     dl, cl                  ;
        lodsb                           ;
        mov     cx, 4                   ;
        mov     di, offset cond         ;
        repnz scasb                     ;
        jz      @@10                    ;
        mov     cl, 4                   ;
@@10:                                   ;
        shl     cl, 2                   ;
        add     cl, dl                  ;
        mov     di, cx                  ;
        movzx   bx, [ byte di+offset c_code ];
        cmp     bl, 0FFh                ;
        jz      @@bad                   ;
        test    bl, 80h                 ;
        jz      @@20                    ;
        dec     si                      ;
        and     bl, 7Fh                 ;
@@20:                                   ;
        shl     bx, 2                   ;
        add     bx, offset Jcc_calls    ;
        call    Expression              ;
        pop     edx                     ;
        cmp     edx, eax                ;
        call    bx                      ;
        shr     al, 1                   ;
        mov     al, 0                   ;
        jmp     short @@done            ;
@@bad:                                  ;
        pop     eax                     ;
        mov     al, 0FFh                ;
        stc                             ;
@@done:                                 ;
        pop     es                      ;
        ret                             ;
;---------------------------------------;
cond    db      '><!='                  ;
c_code  db      4                       ; ==
        db      5                       ; !=
        db      6                       ; <=
        db      3                       ; >=
        db      0FFh                    ; =!
        db      0FFh                    ; !!
        db      0FFh                    ; <!
        db      0FFh                    ; >!
        db      6                       ; =<
        db      0FFh                    ; !<
        db      0FFh                    ; <<
        db      5                       ; ><
        db      3                       ; =>
        db      0FFh                    ; !>
        db      5                       ; <>
        db      0FFh                    ; >>
        db      84h                     ; =
        db      0FFh                    ; !
        db      82h                     ; <
        db      87h                     ; >
;---------------------------------------;
unchar: dw      0                       ;
txt01:  db      'HEX :',0               ;
txt02:  db      ', DEC :',0             ;
txt03:  db      ', ASCII :',0           ;
;---------------------------------------;
ends
        end
